
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADCSR=6;     
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

void init(void);
void runCom(void);
unsigned int continous(void);

void getCom(void);

unsigned char spi(unsigned char data);
void SetWGFreq(unsigned int);
void SetWGPhase(unsigned int);

void SetWGPhase1(unsigned int);

void init_io(void);
unsigned char AD7798_8(unsigned char cmd, unsigned char value);
unsigned int AD7798_16(unsigned char cmd, unsigned int value);
unsigned int readADC(void);
float voltage(unsigned int);
void Permitivity(void);
float voltage_at(int phase1);
void phaseshift(float *MAX10, int *INDEX);
void phaseshift1(float *MAX20, int *INDEX1);

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);
int printf(char flash *fmtstr,...);
int sprintf(char *str, char flash *fmtstr,...);
int vprintf(char flash * fmtstr, va_list argptr);
int vsprintf(char *str, char flash * fmtstr, va_list argptr);

char *gets(char *str,unsigned int len);
int snprintf(char *str, unsigned int size, char flash *fmtstr,...);
int vsnprintf(char *str, unsigned int size, char flash * fmtstr, va_list argptr);

int scanf(char flash *fmtstr,...);
int sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib

#pragma used+

signed char cmax(signed char a,signed char b);
int max(int a,int b);
long lmax(long a,long b);
float fmax(float a,float b);
signed char cmin(signed char a,signed char b);
int min(int a,int b);
long lmin(long a,long b);
float fmin(float a,float b);
signed char csign(signed char x);
signed char sign(int x);
signed char lsign(long x);
signed char fsign(float x);
unsigned char isqrt(unsigned int x);
unsigned int lsqrt(unsigned long x);
float sqrt(float x);
float ftrunc(float x);
float floor(float x);
float ceil(float x);
float fmod(float x,float y);
float modf(float x,float *ipart);
float ldexp(float x,int expon);
float frexp(float x,int *expon);
float exp(float x);
float log(float x);
float log10(float x);
float pow(float x,float y);
float sin(float x);
float cos(float x);
float tan(float x);
float sinh(float x);
float cosh(float x);
float tanh(float x);
float asin(float x);
float acos(float x);
float atan(float x);
float atan2(float y,float x);

#pragma used-
#pragma library math.lib

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

#pragma used+
void sleep_enable(void);
void sleep_disable(void);
void idle(void);

void powerdown(void);

void powersave(void);

void standby(void);

void extended_standby(void);
#pragma used-

#pragma library sleep.lib

typedef signed char int8_t;
typedef unsigned char uint8_t;

typedef short int16_t;
typedef unsigned short uint16_t;

typedef long int32_t;
typedef unsigned long uint32_t;

typedef short intptr_t;
typedef unsigned short uintptr_t;

typedef short flash_intptr_t;
typedef unsigned short flash_uintptr_t;

typedef short eeprom_intptr_t;
typedef unsigned short eeprom_uintptr_t;

unsigned char statusreg,Id; 
unsigned int value,value1, mode, conf, adc,RawData, WaveFreq=125,WavePhase; 
unsigned int RawData;
float v,v1,Vr,Vg,v5,v6,v7,Analog_Voltage,v2;  
int m,n,Newvalue1,Phase7,Phase6,Phase5,Phase,Newvalue;  

unsigned long unixTime = 0;

unsigned char now = 0;
unsigned int logInt = 0;
unsigned char flag = 1;

unsigned char debug = 0;
unsigned int status = 0x0010;

unsigned int vcc;
unsigned int analogVoltPos;
unsigned int analogVoltNeg;
unsigned int supplyVoltage;

unsigned char Command;

unsigned int  Param=125;
extern unsigned char rx_counter0;

unsigned int ReadMcAdc(unsigned char adcInput)
{

ADMUX=adcInput | (0xC0   & 0xff);

delay_us(10);

ADCSRA|=0x40;

while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}

void init(void){

#asm("cli");        

PORTB=0x04;

DDRB=0xBF;

PORTC=0x40;
DDRC=0xC3;

PORTD=0xD4;

DDRD=0xFC;

UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x19;
UCSRA=0x00;
UCSRB=0xD8;

ADMUX=0xC0   & 0xff;
ADCSRA=0x84;

SPCR=0x5D;

PORTB.3 = 1;    

#asm("sei")
}

void runCom(void){
unsigned char c1; 
unsigned char c; 

switch(Command){

case(0):
Command = 0;
break;

case(1):
printf("\r\n\r\n");
printf("Petrotech\r\n");
printf("TurboPVT2 Permittivity\r\n");
printf("Ver. 1.0A\r\n");
printf("Compiled: %p %p\r\n","Dec 17 2012","17:52:00");

supplyVoltage = (unsigned int)ReadMcAdc(3   )*30.6065;               
printf("Power supply voltage: %u [mV]\r\n", supplyVoltage);                   
analogVoltPos = (unsigned int)ReadMcAdc(1   )*15.16443375;           
analogVoltNeg = (unsigned int)ReadMcAdc(2   )*27.782;           
printf("Positive analog voltage: %u [mV]\tNegative analog voltage: -%u [mV]\r\n", analogVoltPos, analogVoltNeg);
vcc = (unsigned int)ReadMcAdc(0   )*6.348375;                        
printf("Digital supply voltage: %u [mV]\r\n", vcc);  
RawData=readADC(); 
printf("ADC RawData:%d\r\n", RawData);   
Analog_Voltage = voltage(RawData); 
printf("Demodulator Voltage Level:%f [v]\r\n",Analog_Voltage);  

printf("Present wave frequency is setted to:%d\r\n",WaveFreq);
printf("Vr Signal Phase value at maximum voltage :%d\r\n",Newvalue); 
printf("Vg Signal Phase value at maximum voltage :%d\r\n",Newvalue1);

if(m == 1)   printf("Mux is setted to:%d",m);
if(m == 2)   printf("Mux is setted to:%d",m);
if(m == 3)   printf("Mux is setted to:%d",m);
if(m == 4)   printf("Mux is setted to:%d",m);
if(m == 5)   printf("Mux is setted to:%d",m);
if(m == 6)   printf("Mux is setted to:%d",m);
if(m == 7)   printf("Mux is setted to:%d",m);  

if(n==1) printf("\r\nAmplification stage 3x selected"); 
if(n==2) printf("\r\nAmplification stage 13x selected");
if(n==3) printf("\r\nAmplification stage 5x selected");
if(n==4) printf("\r\nAmplification stage 15x selected"); 
if(n==5) printf("\r\nDampling stage is selected");
if(n==6) printf("\r\nBypass stage is selected");

Command = 0;
break;

case(2       ):  
while (1)
{
continous();
return; 
}
Command = 0;
break;

case(3):
if(Param < 500)
SetWGFreq(Param);  
WaveFreq = Param; 
Command = 0;
break; 

case(4):
if(Param < 4095) 
SetWGPhase1(Param); 
WavePhase=Param;
Command = 0;
break;   

case(5):  

printf("Select amplification stage: 1-3x,2-5x,3-13x,4-15x\r\n5-Damping stage\r\n6-Bypass circiut\r\n");  
c1 = getchar();        
switch(c1){                   
case '1':
PORTC=0x43;  
PORTD=0xD4; 
printf("Amplification stage 3x selected\r\n");
n=1;
Command = 0;  
break;   
case '2':
PORTC=0x40;  
PORTD=0xD4; 
printf("Amplification stage 5x selected\r\n");
n=2;
Command = 0;  
break;
case '3':
PORTC=0x42;  
PORTD=0x14; 
printf("Amplification stage 13x selected\r\n");
n=3;
Command = 0;  
break; 
case '4':
PORTC=0x40;  
PORTD=0x14; 
printf("Amplification stage 15x selected\r\n");
n=4;
Command = 0;  
break; 
case '5':
PORTC=0x00;
PORTD=0x14;
printf("Damping stage selected\r\n");
n=5;
Command = 0;  
break;  
case '6':
PORTC=0x01;
PORTD=0x14;
printf("Bypass circuit selected\r\n"); 
n=6;
Command = 0;  
break;  
default:
Command = 0;
break;
}    
Command = 0;
break;     
case(6):                  

c = getchar(); 

switch(c){

case '1': 
PORTB=0x00; 
phaseshift(&v, &Phase); 
Vg=v;  
printf("Muxchanel 1 Demodulator Voltage Level:%f [v]\r\n",Vg);
Newvalue1=Phase;
printf("Related Phase Value:%d\r\n",Newvalue1);                            
m = 1;
Command = 0; 
break;

case '2':           
PORTB=0x04;
delay_ms(100);
phaseshift(&v, &Phase); 
v2=v;
v2=v2*3;
Vg=v2;  
printf("Muxchanel 2 Demodulator Voltage Level:%f [v]\r\n",Vg);
Newvalue1=Phase;
printf("Related Phase Value:%d\r\n",Newvalue1);    
m = 2; 
Command = 0; 
break; 

case '3':      
PORTB=0x02; 
phaseshift(&v, &Phase);  
Vg=v;  
printf("Muxchanel 3 Demodulator Voltage Level:%f [v]\r\n",Vg);
Newvalue1=Phase;
printf("Related Phase Value:%d\r\n",Newvalue1); 
m = 3;
Command = 0;    
break;     

case '4':  
PORTB=0x06;
phaseshift(&v, &Phase);  
Vg=v;  
printf("Muxchanel 4 Demodulator Voltage Level:%f [v]\r\n",Vg); 
Newvalue1=Phase;
printf("Related Phase Value:%d\r\n",Newvalue1); 
m = 4;
Command = 0; 
break; 

case '5': 
PORTB=0x01; 
delay_ms(100);  
phaseshift(&v, &Phase); 
v5=v;
v5=v5*3;
Vr=v5;  
printf("Muxchanel 5 Demodulator Voltage Level:%f [v]\r\n",Vr); 

Phase5=Phase;  
printf("Related Phase Value:%d\r\n",Phase5);
Phase5=(Phase5+0);
Newvalue=Phase5;
printf("Related Phase Value1:%d\r\n",Newvalue);                                    
m = 5;
Command = 0;  
break; 

case '6': 
PORTB=0x05;
delay_ms(100); 
phaseshift(&v, &Phase);
v6=v;
v6=(v6*3)/5.3548;
Vr=v6;  
printf("Muxchanel 6 Demodulator Voltage Level:%f [v]\r\n",Vr);

Phase6=Phase; 
printf("Related Phase Value:%d\r\n",Phase6);
Phase6=(Phase6-50);
Newvalue=Phase6;
printf("Related Phase Value:%d\r\n",Newvalue); 
m = 6;
Command = 0;   
break;

case '7':
PORTB=0x03; 
delay_ms(100);
phaseshift(&v, &Phase);
v7=v;
v7=(v7*3)/28.53;
Vr=v7;  
printf("Muxchanel 7 Demodulator Voltage Level:%f [v]\r\n",Vr);

Phase7=Phase;
printf("Related Phase Value:%d\r\n",Phase7);
Phase7=(Phase7-240);
Newvalue=Phase7;
printf("Related Phase Value:%d\r\n",Newvalue); 
m = 7;
Command = 0; 
break;    
case '8':
PORTB=0x04; 

RawData = readADC(); 
v2 = voltage(RawData); 
v2=(v2*3);

Vr=v2;  
printf("Muxchanel 8 Demodulator Voltage Level:%f [v]\r\n",Vr);

printf("Related Phase Value:%d\r\n",WavePhase);
m=8;
Command = 0;  
break;

default:
Command = 0;
break;

}
Command = 0; 
break;     
case(7):
Permitivity(); 
Command = 0;
break;

default:
Command = 0;
break;   
}
}

unsigned int continous(void){  

float Z=0.0F, R=1000.0F,Cp,Cs,theta,theta1,delta,delta1,W,Xcs,C0=25.55E-12,Erp,Ers;
float pi,Cs1,Cp1;
pi = 4.0*atan(1.0); 
printf("Start\r\n");  
PORTB=0x04;
delay_ms(100);
phaseshift(&v, &Phase); 
v2=v;
v2=v2*3;
Vg=v2;  
Newvalue1=Phase;  

PORTB=0x05;
delay_ms(100); 
phaseshift(&v, &Phase);
v6=v;
v6=(v6*3)/5.3548;
Vr=v6;  
Phase6=Phase; 
Phase6=(Phase6-50);
Newvalue=Phase6;

theta=abs(Newvalue1-Newvalue); 
theta1= theta/180*pi;
delta=abs(90-theta); 
delta1= delta/180*pi;
Z= ((Vg-Vr)/Vr)*R; 
printf("Z:%f[Ohms]\t", Z);  
printf("Vg:%f[V]\t", Vg);
printf("Vg phase:%f\t", Newvalue1);
printf("Vr:%f[V]\t",Vr); 
printf("Vr phase:%f\t", Newvalue);      

W= (2.0*pi*WaveFreq*1000);  
Xcs= fabs((fabs(Z)* sin(theta1)));  

Cs= fabs(1/(W*Xcs));
Cs1= Cs*10E11;    
Cp= fabs((Cs/(1+pow(tan(delta1),2))));
Cp1= Cp*10E11;    
if (Z>=5001){  
printf("Cp:%f[pF]\t", Cp1);    
Erp= fabs(Cp/C0);
printf("Permitivity:%f\r\n", Erp);
printf("Stop\r\n");
} else   {
printf("Cs:%f[pF]\t", Cs1);
Ers= fabs(Cs/C0);
printf("Permitivity:%f\r\n", Ers);
printf("Stop\r\n");
}
return 0;                         
}

void main(void){

int Flag = 0;
status = 0x0010;

init();                                     

Command = 1;    
printf("chaking for data to usb");

debug = 0;                                  

while (1){   
SetWGFreq(125);
if(rx_counter0) getCom();
if(Command)     runCom(); 

if(logInt > 0){
if(now){
if(!(unixTime % logInt)){
if(flag){
printf("Time[sec]\tPress[raw];[psia]\tTemp[raw];[C x 0.01]\tBatt[raw];[mV]\tAVdd[raw];[mV]\r\n");
flag = 0;
}
now = 0;                  

}
}
}

#asm("WDR");        

} 

} 

