
     /*****************************************************
    Project : TurboPVT2_Perm
    Version : 1.0A
    Date    : 29.05.2012
    Author  : Lars Ole Espeland
    Company : Expro Fluids
    Comments: 


    Chip type           : ATmega32
    Program type        : Application
    Clock frequency     : 16.0000 MHz
    Memory model        : Small
    External RAM size   : 0
    Data Stack size     : 512
    *****************************************************/

    #include <MEGA32.h>
    #include <main.h>
    #include <interface.h>
    #include <stdio.h>
    #include <stdlib.h>
    #include <math.h>
    #include <delay.h>
    #include <sleep.h> 
    #include <stdint.h>
    #include <io.h> 
    
    #define JTD 7
//    #define SEL  
//    #define STAGEA
//    #define STAGEB

    // GLOBAL VARIABLES

 //  unsigned int i;
    unsigned char statusreg,Id; 
    unsigned int value,value1, mode, conf, adc,RawData, WaveFreq=125,WavePhase; 
    unsigned int RawData;
    float v,v1,Vr,Vg,v5,v6,v7,Analog_Voltage,v2;  
    int m,n,Newvalue1,Phase7,Phase6,Phase5,Phase,Newvalue;  
  

    
    //Timer
    unsigned long unixTime = 0;
   //  unsigned int ms = 0;
    unsigned char now = 0;
    unsigned int logInt = 0;
    unsigned char flag = 1;
  //  unsigned int delay = 125;

    //Status
   // unsigned char state = 0;
    unsigned char debug = 0;
    unsigned int status = 0x0010;

    //Measured
//    char adcStatus;
//    char adcStatus1;
//    unsigned int adcMode;
//    unsigned int adcConfig;
//    unsigned char adcId;
//    unsigned int battVoltRaw;
//    unsigned int battVolt;
//    unsigned int analogVoltRaw;
//    unsigned int analogVolt;
//    unsigned int tempRaw;                                  
//    unsigned int temp;
//    unsigned int pressRaw;
//    unsigned int press = 0; 
//     unsigned int data;

    unsigned int vcc;
    unsigned int analogVoltPos;
    unsigned int analogVoltNeg;
    unsigned int supplyVoltage;

    //Flash
//    char manufId;                      
//    char memType;
//    char memCap;

    //External variables
    unsigned char Command;
    //ADC, stage1, stage2;
    unsigned int  Param=125;
    extern unsigned char rx_counter0;

    //Read microcontroller ADC
    unsigned int ReadMcAdc(unsigned char adcInput)
    {

    ADMUX=adcInput | (ADC_VREF_TYPE & 0xff);
    // Delay needed for the stabilization of the ADC input voltage
    delay_us(10);
    // Start the AD conversion
    ADCSRA|=0x40;
    // Wait for the AD conversion to complete
    while ((ADCSRA & 0x10)==0);
    ADCSRA|=0x10;
    return ADCW;
    }

    //Initialize registers
    void init(void){

    #asm("cli");        //Disable global interrupt

    // Input/Output Ports initialization
    // Port B initialization
     
    // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
    // PORTB=(0<<PB0)|(0<<PB1)|(0<<PB2)|(0<<PB3)|(0<<PB4)|(0<<PB5)|(0<<PB6)|(0<<PB7);
    PORTB=0x04;
    // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=Out Func0=Out
    DDRB=0xBF;

    // Port C initialization
    // Func7=out Func6=Out Func5=In Func4=In Func3=In Func2=In Func1=Out Func0=Out 
    // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
    PORTC=0x40;
    DDRC=0xC3;

                               
    // Port D initialization
     
    // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
    PORTD=0xD4;
    // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=In Func0=In
    DDRD=0xFC;

    // USART initialization
    // Communication Parameters: 8 Data, 1 Stop, No Parity
    // USART Receiver: On
    // USART Transmitter: On
    // USART0 Mode: Asynchronous
    // USART Baud Rate: 38400
    UCSRC=0x86;
    UBRRH=0x00;
    UBRRL=0x19;
    UCSRA=0x00;
    UCSRB=0xD8;
    //UCSRC=0x86;


    // ADC initialization
    // ADC Clock frequency: 1000 kHz
    // ADC Voltage Reference: AREF pin
    // ADC Auto Trigger Source: None
    // Digital input buffers on ADC0: On, ADC1: On, ADC2: On, ADC3: On
    // ADC4: On, ADC5: On
    //DIDR0=0x00;
    ADMUX=ADC_VREF_TYPE & 0xff;
    ADCSRA=0x84;

    // SPI initialisation
    // SPI clock rate fck/16
    // SPI master
    // SPI MSB first
    // SPI CPOL = 1, CPHA = 1
    SPCR=0x5D;
    //PORTB.1 = 1;    //Flash CS high
    PORTB.3 = 1;    //ADC CS high

    //Global enable interrupts
    #asm("sei")
    }

    // Execute commands
    void runCom(void){
                  unsigned char c1; 
                  unsigned char c; 
                  //getchar();      
        switch(Command){
                      
            case(NO_COM1):
                Command = 0;
                break;
            
            case(inf):
                printf("\r\n\r\n");
                printf("Petrotech\r\n");
                printf("TurboPVT2 Permittivity\r\n");
                printf("Ver. 1.0A\r\n");
                printf("Compiled: %p %p\r\n",__DATE__,__TIME__);
                
                supplyVoltage = (unsigned int)ReadMcAdc(VIN)*30.6065;               //2.5*12*1.0202
                printf("Power supply voltage: %u [mV]\r\n", supplyVoltage);                   
                analogVoltPos = (unsigned int)ReadMcAdc(AVP)*15.16443375;           //2.5*5.99*1.01265
                analogVoltNeg = (unsigned int)ReadMcAdc(AVN)*27.782;           //2.5*10.99*1.011
                printf("Positive analog voltage: %u [mV]\tNegative analog voltage: -%u [mV]\r\n", analogVoltPos, analogVoltNeg);
                vcc = (unsigned int)ReadMcAdc(VCC)*6.348375;                        //2.5*2.5*1.01574
                printf("Digital supply voltage: %u [mV]\r\n", vcc);  
                RawData=readADC(); 
                printf("ADC RawData:%d\r\n", RawData);   
                Analog_Voltage = voltage(RawData); 
                printf("Demodulator Voltage Level:%f [v]\r\n",Analog_Voltage);  
                 
                printf("Present wave frequency is setted to:%d\r\n",WaveFreq);
                printf("Vr Signal Phase value at maximum voltage :%d\r\n",Newvalue); 
                printf("Vg Signal Phase value at maximum voltage :%d\r\n",Newvalue1);
               // printf("Present wave Phase is setted to:%d\r\n",Newvalue7); 
                 
                 if(m == 1)   printf("Mux is setted to:%d",m);
                 if(m == 2)   printf("Mux is setted to:%d",m);
                 if(m == 3)   printf("Mux is setted to:%d",m);
                 if(m == 4)   printf("Mux is setted to:%d",m);
                 if(m == 5)   printf("Mux is setted to:%d",m);
                 if(m == 6)   printf("Mux is setted to:%d",m);
                 if(m == 7)   printf("Mux is setted to:%d",m);  
                 
                 if(n==1) printf("\r\nAmplification stage 3x selected"); 
                 if(n==2) printf("\r\nAmplification stage 13x selected");
                 if(n==3) printf("\r\nAmplification stage 5x selected");
                 if(n==4) printf("\r\nAmplification stage 15x selected"); 
                 if(n==5) printf("\r\nDampling stage is selected");
                 if(n==6) printf("\r\nBypass stage is selected");
                
                Command = 0;
                break;

            case(scan):  
                 while (1)
                 {
                 continous();
                  return; 
                 }
                  Command = 0;
                  break;

            case(WGF):
                  if(Param < 500)
                    SetWGFreq(Param);  
                    WaveFreq = Param; 
                    Command = 0;
                  break; 
                
            case(WGP):
                  if(Param < 4095) 
                    SetWGPhase1(Param); //shifting the signal with a value.  
                    WavePhase=Param;
                  Command = 0;
                  break;   
                
            case(ADC):  
                // if(Param<3)
          printf("Select amplification stage: 1-3x,2-5x,3-13x,4-15x\r\n5-Damping stage\r\n6-Bypass circiut\r\n");  
                   c1 = getchar();        
                   switch(c1){                   
                            case '1':
                               PORTC=0x43;  
                               PORTD=0xD4; 
                               printf("Amplification stage 3x selected\r\n");
                               n=1;
                               Command = 0;  
                               break;   
                            case '2':
                               PORTC=0x40;  
                               PORTD=0xD4; 
                               printf("Amplification stage 5x selected\r\n");
                               n=2;
                               Command = 0;  
                               break;
                            case '3':
                               PORTC=0x42;  
                               PORTD=0x14; 
                               printf("Amplification stage 13x selected\r\n");
                               n=3;
                               Command = 0;  
                               break; 
                            case '4':
                               PORTC=0x40;  
                               PORTD=0x14; 
                               printf("Amplification stage 15x selected\r\n");
                               n=4;
                               Command = 0;  
                               break; 
                            case '5':
                               PORTC=0x00;
                               PORTD=0x14;
                               printf("Damping stage selected\r\n");
                               n=5;
                               Command = 0;  
                               break;  
                            case '6':
                               PORTC=0x01;
                               PORTD=0x14;
                               printf("Bypass circuit selected\r\n"); 
                               n=6;
                               Command = 0;  
                               break;  
                            default:
                               Command = 0;
                               break;
                             }    
                 Command = 0;
                 break;     
            case(MUX):                  
                
                 c = getchar(); 
                 //getchar();
                   switch(c){
                                                                 
                         case '1': 
                            PORTB=0x00; 
                            phaseshift(&v, &Phase); 
                            Vg=v;  
                            printf("Muxchanel 1 Demodulator Voltage Level:%f [v]\r\n",Vg);
                            Newvalue1=Phase;
                            printf("Related Phase Value:%d\r\n",Newvalue1);                            
                            m = 1;
                            Command = 0; 
                            break;
                                             
                         case '2':           
                            PORTB=0x04;
                            delay_ms(100);
                            phaseshift(&v, &Phase); 
                            v2=v;
                            v2=v2*3;
                            Vg=v2;  
                            printf("Muxchanel 2 Demodulator Voltage Level:%f [v]\r\n",Vg);
                            Newvalue1=Phase;
                            printf("Related Phase Value:%d\r\n",Newvalue1);    
                            m = 2; 
                            Command = 0; 
                            break; 
                                                
                         case '3':      
                            PORTB=0x02; 
                            phaseshift(&v, &Phase);  
                            Vg=v;  
                            printf("Muxchanel 3 Demodulator Voltage Level:%f [v]\r\n",Vg);
                            Newvalue1=Phase;
                            printf("Related Phase Value:%d\r\n",Newvalue1); 
                            m = 3;
                            Command = 0;    
                            break;     
                                             
                         case '4':  
                            PORTB=0x06;
                            phaseshift(&v, &Phase);  
                            Vg=v;  
                            printf("Muxchanel 4 Demodulator Voltage Level:%f [v]\r\n",Vg); 
                            Newvalue1=Phase;
                            printf("Related Phase Value:%d\r\n",Newvalue1); 
                            m = 4;
                            Command = 0; 
                            break; 
                                             
                         case '5': 
                            PORTB=0x01; 
                            delay_ms(100);  
                            phaseshift(&v, &Phase); 
                            v5=v;
                            v5=v5*3;
                            Vr=v5;  
                            printf("Muxchanel 5 Demodulator Voltage Level:%f [v]\r\n",Vr); 
                            // printf("Related Phase Value:%d\r\n",Phase); 
                            Phase5=Phase;  
                            printf("Related Phase Value:%d\r\n",Phase5);
                            Phase5=(Phase5+0);
                            Newvalue=Phase5;
                            printf("Related Phase Value1:%d\r\n",Newvalue);                                    
                            m = 5;
                            Command = 0;  
                            break; 
                                             
                         case '6': 
                            PORTB=0x05;
                            delay_ms(100); 
                            phaseshift(&v, &Phase);
                            v6=v;
                            v6=(v6*3)/5.3548;
                            Vr=v6;  
                            printf("Muxchanel 6 Demodulator Voltage Level:%f [v]\r\n",Vr);
                            //printf("Related Phase Value:%d\r\n",Phase); 
                            Phase6=Phase; 
                            printf("Related Phase Value:%d\r\n",Phase6);
                            Phase6=(Phase6-50);
                            Newvalue=Phase6;
                            printf("Related Phase Value:%d\r\n",Newvalue); 
                            m = 6;
                            Command = 0;   
                            break;
                                             
                         case '7':
                            PORTB=0x03; 
                            delay_ms(100);
                            phaseshift(&v, &Phase);
                            v7=v;
                            v7=(v7*3)/28.53;
                            Vr=v7;  
                            printf("Muxchanel 7 Demodulator Voltage Level:%f [v]\r\n",Vr);
                            //printf("Related Phase Value:%d\r\n",Phase);  
                            Phase7=Phase;
                            printf("Related Phase Value:%d\r\n",Phase7);
                            Phase7=(Phase7-240);
                            Newvalue=Phase7;
                            printf("Related Phase Value:%d\r\n",Newvalue); 
                            m = 7;
                            Command = 0; 
                            break;    
                         case '8':
                            PORTB=0x04; 
                            //phaseshift1(&v, &Phase); 
                            RawData = readADC(); 
                            v2 = voltage(RawData); 
                            v2=(v2*3);
                           // v2=(v2*3)/5.3548;
                            Vr=v2;  
                            printf("Muxchanel 8 Demodulator Voltage Level:%f [v]\r\n",Vr);
                            //Newvalue=Phase;
                            printf("Related Phase Value:%d\r\n",WavePhase);
                            m=8;
                            Command = 0;  
                            break;
                                             
                         default:
                            Command = 0;
                            break;
                                       
                          }
                 Command = 0; 
                 break;     
            case(PERM):
                Permitivity(); 
                 Command = 0;
                 break;
            
            default:
                 Command = 0;
                 break;   
        }
    }

 unsigned int continous(void){  

   float Z=0.0F, R=1000.0F,Cp,Cs,theta,theta1,delta,delta1,W,Xcs,C0=25.55E-12,Erp,Ers;
   float pi,Cs1,Cp1;
   pi = 4.0*atan(1.0); 
   printf("Start\r\n");  
   PORTB=0x04;
   delay_ms(100);
   phaseshift(&v, &Phase); 
   v2=v;
   v2=v2*3;
   Vg=v2;  
   Newvalue1=Phase;  
   
   PORTB=0x05;
   delay_ms(100); 
   phaseshift(&v, &Phase);
   v6=v;
   v6=(v6*3)/5.3548;
   Vr=v6;  
   Phase6=Phase; 
   Phase6=(Phase6-50);
   Newvalue=Phase6;
   
     theta=abs(Newvalue1-Newvalue); 
     theta1= theta/180*pi;
     delta=abs(90-theta); 
     delta1= delta/180*pi;
     Z= ((Vg-Vr)/Vr)*R; 
     printf("Z:%f[Ohms]\t", Z);  
     printf("Vg:%f[V]\t", Vg);
     printf("Vg phase:%f\t", Newvalue1);
     printf("Vr:%f[V]\t",Vr); 
     printf("Vr phase:%f\t", Newvalue);      
    
     W= (2.0*pi*WaveFreq*1000);  
     Xcs= fabs((fabs(Z)* sin(theta1)));  
     
     Cs= fabs(1/(W*Xcs));
     Cs1= Cs*10E11;    
     Cp= fabs((Cs/(1+pow(tan(delta1),2))));
     Cp1= Cp*10E11;    
     if (Z>=5001){  
     printf("Cp:%f[pF]\t", Cp1);    
     Erp= fabs(Cp/C0);
     printf("Permitivity:%f\r\n", Erp);
     printf("Stop\r\n");
     } else   {
      printf("Cs:%f[pF]\t", Cs1);
      Ers= fabs(Cs/C0);
      printf("Permitivity:%f\r\n", Ers);
      printf("Stop\r\n");
      }
     return 0;                         
 }


    
  
    

  /*  char *pLong(long num){

        static unsigned char str[16];    
        ltoa(num,str);
        return str;     
    }*/

    /*
    void ReadFlashId(void)
    {
                                                     
        if(PINB.2){
            PORTB.1 = 0;
            while(PINB.1);          //Wait for flash chip select pin to go low
            //Wait(250);
            //spi(0x9F);              //Issue read identification instruction
            spi(0x05);              //Read status register
            manufId = spi(0xFF);    //Read manufacturer Id byte = 0x20 for STMicroelectronics
            //memType = spi(0xFF);    //Read memory type byte = 0x20
            //memCap = spi(0xFF);     //Read memory capacity byte = 0x14
            PORTB.1 = 1;
            Wait(10);
        }
        else
            printf("ADC in use, not possible to access flash\r\n");
    }*/

    void main(void){
                
            int Flag = 0;
      status = 0x0010;
        
        
           init();                                     //Initialize controller
           // Command = WGF;                            //Initialize waveformgenerator 125 kHz
           Command = inf;    
             printf("chaking for data to usb");
          //  SetWGFreq(125);                   
           debug = 0;                                  //Controls output during motor running      
            // MCUCSR =(1<<7);
            // MCUCSR =(1<<7);

        while (1){   
              SetWGFreq(125);
            if(rx_counter0) getCom();
            if(Command)     runCom(); 
             
            
            if(logInt > 0){
                if(now){
                if(!(unixTime % logInt)){
                    if(flag){
                        printf("Time[sec]\tPress[raw];[psia]\tTemp[raw];[C x 0.01]\tBatt[raw];[mV]\tAVdd[raw];[mV]\r\n");
                        flag = 0;
                    }
                    now = 0;                  
                   // MeasureAll();
//                    printf("%s\t", pLong(unixTime));                   //Print the time as number of seconds since 01.01.1960
//                    printf("%u;%u\t", pressRaw, press);                //Print pressure
//                    printf("%u;%u\t", tempRaw, temp);                  //Print temperature
//                    printf("%u;%u\t", battVoltRaw, battVolt);          //Print battery voltage
//                    printf("%u;%u\r\n", analogVoltRaw, analogVolt);    //Print regulated voltage
                }
                }
            }

            #asm("WDR");        //Reset WD timer 
            
        } // EOF "while(1)"   
        
        
 
    } // EOF "main(void)"



    /*
    void findStPtr(void){
        while(EEPROM_read(status) != 0xFF){ 
            status += 3;
            if(status > 130){
                status = 0x10;
                break;
            }
        }
    }*/

    /*
    void Wait(unsigned int d)
    {
        StartTimer0();
        while(ms < d);
        StopTimer0();
    }*/

    /*
    void StartTimer0(void)
    {
        ms = 0;         //Always start with 0
        
        TCNT0 = 0x00;   //Start counting from 0
        
        OCR0A = 0x39;   //To get almost 1 ms update rate
        
        TIMSK0 = 0x02;  //Enable timer 0 output compare A interrupt
        
        TCCR0A = 0x02;
        TCCR0B = 0x03;  //Start timer 0 in CTC-mode (2) with prescale 16
    }*/

    /*
    void StopTimer0(void)
    {
        TCCR0A = 0x00;
        TCCR0B = 0x00;  //Stop timer 0
        TIMSK0 = 0x00;  //Switch of interrupt
    }*/

    //Start timer 1 for counting seconds