/*****************************************************
Company : Expro Fluids
Project : TurboPVT2_Perm
Version : 1.0A
Date    : 29.05.2012
Author  : Lars Ole Espeland
*****************************************************/

#include <MEGA32.h>
#include <main.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <interface.h>                                                                  
#include <delay.h>
#include <stdint.h>
#include <io.h>
#include <math.h>


#define ADC_CS_PIN PINB.3
#define WG_CS_PIN PINB.4

#define MUX_A2 PORTB.0
#define MUX_A1 PORTB.1
#define MUX_A0 PORTB.2
#define ADC_CS PORTB.3
#define WG_CS PORTB.4
#define MOSI PORTB.5
//#define MISO PINB.6
#define SCK PORTB.7


#define MISO_PU PORTB.6 
#define MISO_PIN PINB.6 


#define MODE_SW4 PORTC.0
#define MODE_SW3 PORTC.1
#define MODE_SW2 PORTC.6
#define MODE_SW1 PORTC.7

#define MODE_SW10 PORTD.2
#define MODE_SW9 PORTD.3
#define MODE_SW8 PORTD.4
#define MODE_SW7 PORTD.5
#define MODE_SW6 PORTD.6
#define MODE_SW5 PORTD.7



extern char adcStatus;
extern char adcStatus1;
extern char adcId;
extern unsigned int adcMode;
extern unsigned int adcConfig;
//extern unsigned int i;
//extern unsigned int delay;
extern  unsigned int data;

extern unsigned int battVoltRaw;
extern unsigned int battVolt;
extern unsigned int analogVoltRaw;
extern unsigned int analogVolt;
extern unsigned int tempRaw;
extern unsigned int temp;
extern unsigned int pressRaw;
extern unsigned int press;

extern unsigned char statusreg,Id; 
extern unsigned int value, value1, mode, conf, adc,Phase,WaveFreq;
extern float Analog_Voltage,v1,Vg,Vr,v2; 
extern  unsigned int RawData;
extern int Newvalue1,Newvalue;


  

       


  void init_io(void) 
  { 
    //DDRB = (1<<7)|(1<<5)|(1<<4)|(1<<3);        // make SCK, MOSI, CS1, CS2 outputs  
    DDRB = 0xBF;       
  //  PORTB=0x03;
    ADC_CS = 1;              //disable ADC 
    WG_CS = 1;               //disable WaveGenerator 
    MISO_PU = 1;             //enable pull-up on MISO so we can test !RDY 
  } 
    
  
unsigned char spi(unsigned char data) 
{ 
    //Start transmision 
    SPDR = data; 
    //Wait for transmision complete 
    while (!(SPSR & 0x80)); 
    return SPDR; 
}        
  


//Sets the waveform generator output to given kHz
  void SetWGFreq(unsigned int freq)
  {
    unsigned long freg;
    char fByte0;
    char fByte1;
    char fByte2;
    char fByte3;
    
    freg = (unsigned long)freq*33554.432;   //Number based on a MCLK of 8 MHz
    fByte0 = (char)freg;
    fByte1 = (char)(freg>>8);
    fByte1 = (fByte1 & 0x3F) | 0x40;        //clears bits 15 and 14, then sets for FREQ0
    fByte2 = (char)(freg>>14);              //byte1 only has 6 bits, so move over by 8+6
    fByte3 = (char)(freg>>22);              //byte1 only has 6 bits, so move over by 8+8+6
    fByte3 = (fByte3 & 0x3F) | 0x40;        //clears bits 15 and 14, then sets for FREQ0
    
    SPCR = 0x5A;        //Set SPI to mode 2 and Fosc/64
    WG_CS = 0;
    while(WG_CS_PIN);   //Wait for chip select pin to go low
    spi(0x20);          //Load control register with B28 high
    spi(0x00);
    spi(fByte1);
    spi(fByte0);
    spi(fByte3);
    spi(fByte2);
    WG_CS = 1;
  }          
  


  void SetWGPhase(unsigned int phase)
  {
    //unsigned long phase; 
    phase = (uint32_t)phase*4096/360;
    SPCR = 0x5A;
    WG_CS = 0;
    while(WG_CS_PIN);
    spi(0x20);
    spi(0x00);
    spi((phase>>8) | 0xC0);     //Load into phase register 0
    spi(phase & 0x00FF);
    WG_CS = 1;
  }   
  
   void SetWGPhase1(unsigned int phase)
  {
    //unsigned long phase; 
    phase = (uint32_t)phase*4096/360;
    SPCR = 0x5A;
    WG_CS = 0;
    while(WG_CS_PIN);
    spi(0x20);
    spi(0x00);
    spi((phase>>8) | 0xC0);     //Load into phase register 0
    spi(phase & 0x00FF);
    WG_CS = 1;
  }    
   
          
  
  
  
  //function for reading or writing 8 bit registers 
unsigned char AD7798_8(unsigned char cmd, unsigned char value) 
{ 
    unsigned char data; 
    SPCR = 0x5D;        // mode #3 F_CPU/16 
    ADC_CS = 0;                 // enable 
    spi(cmd);                   //Place instruction in communication register 
    data = spi(value);          // and lo-byte. 
    ADC_CS = 1;                 // disable 
    return data; 
} 

//function for reading or writing 16 bit registers 
unsigned int AD7798_16(unsigned char cmd, unsigned int value) 
{ 
    unsigned int data; 
    SPCR = 0x5D;        // mode #3 F_CPU/16 
    ADC_CS = 0;                 // enable 
    spi(cmd);                   //Place instruction in communication register 
    data = spi(value >> 8);     // read hi-byte 
    data = (data << 8) | spi(value);    // and lo-byte. 
    ADC_CS = 1;                 // disable 
    return data; 
} 
  
 
    unsigned int readADC(void)  
    {         
           
           init_io();                                 // setup SPI pins 

           // read power on default register values 
           statusreg = AD7798_8(0x40, 0xFF);          // read STATUS register
           Id = AD7798_8(0x60, 0xFF);                 // read ID register  
           mode = AD7798_16(0x48, 0xFFFF);            // read MODE register 
           conf = AD7798_16(0x50, 0xFFFF);            // read CONFIGURATIONregister 
      
//           printf("Id register %02x\r\n", Id);            // printing ID reg default value
//           printf("status register %02x\r\n", statusreg); // printing STATUS reg default value
//           printf(" conf regisetr %04x\r\n", conf);       // printing CONFIGURATION reg default value
//           printf(" mode register %04x\r\n", mode);       // printing MODE reg default value
           
           AD7798_16(0x10, 0x0010);                 // write Configuration reg = 0x0010.  2.5V range  
           value = AD7798_16(0x50, 0xFFFF);         // read Configration register    
          
//         AD7798_16(0x08, 0x000A);                 // write Mode register = 0x0080.  
//         value1 = AD7798_16(0x48, 0xFFFF);        // read Mode register             
//                                                                     
          // printf("configreg %04x\r\n", value);     // printing Configuration register value
//         printf("modereg %04x\r\n", value1);      // printing Mode register value

//           if (statusreg != 0x80)                                    //check status register
//           printf("unexpected power on status %02x\r\n", statusreg); 
//           if (conf != 0x0710)                                       //check configuration register
//           printf("unexpected power on conf %04x\r\n", conf); 
//           if (mode != 0x000A)                                       //check mode register
//           printf("unexpected power on mode %04x\r\n", mode);  
//        
//           if (value != 0x0010) 
//           printf("unexpected conf setting %04x\r\n", value);  
//           
//         if (value1 != 0x000A) 
//         printf("unexpected mode setting %04x\r\n", value1);
           
           while ((statusreg & 0x80) != 0);                         // wait till ADC is ready 
           adc = AD7798_16(0x58, 0xFFFF);                           // read registe    
          return adc;
         }    
                                             
 float voltage(unsigned int a)
{
           float Ain=0.0F, adcfloat=0.0F; 
           adcfloat = (float)a;
           Ain=((adcfloat / 32768.0F) - 1.0F) / 0.4F; 
           Ain=2.5+Ain;
           return Ain;
}
   
 
void Permitivity(void)
{
     float Z=0.0F, R=1000.0F, Rs,Cs,Rp,Cp,theta,theta1,delta,delta1,W,Xcs,C0=25.55E-12,Erp,Ers;
     float pi, Rin=0.003F,Rout=0.00397F, L=0.08F, Cp1,Cs1,sigma;
     pi = 4.0*atan(1.0);
     theta=abs(Newvalue1-Newvalue); 
     theta1= theta/180*pi;
     delta=abs(90-theta); 
     delta1= delta/180*pi;
     Z= ((Vg-Vr)/Vr)*R; 
     printf("value of Impedance (Z): %f[Ohms]\r\n", Z);  
     printf("level of excitation signal (Vg): %f[V]\r\n", Vg);
     printf("level of return signal (Vr): %f[V]\r\n",Vr);      
     printf("value of Theta: %f\r\n", theta);
     printf("value of Delta: %f\r\n", delta);
     //  WavePhase = ((WavePhase * pi)/180)  ;   
    // printf("WavePhase: %d\r\n", WavePhase);    
    
     W= (2.0*pi*WaveFreq*1000); 
     printf("value of Omega: %f\r\n", W);
     
     Rs= (fabs(Z)* cos(theta1));
     Xcs= fabs((fabs(Z)* sin(theta1)));  
     Rp= ((1+pow(tan(delta1),2))/(pow(tan(delta1),2))*Rs);
     
     Cs= fabs(1/(W*Xcs)); 
     Cs1= Cs*10E11;  
     Cp= fabs((Cs/(1+pow(tan(delta1),2))));
     Cp1= Cp*10E11;    
     
     printf("value of Reactance(Xc): %f\r\n", Xcs);
     printf("value of Serial Resistance(Rs): %f[Ohms]\r\n", Rs); 
     printf("value of Serial Capacitance(Cs): %f[pF]\r\n", Cs1);
     printf("value of Parallel Resistance(Rp): %f[Ohms]\r\n", Rp);  
     printf("value of Parallel Capacitance(Cp): %f[pF]\r\n", Cp1);   
     Ers= fabs(Cs/C0);
     printf("value of Permitivity for Serial Model: %f\r\n", Ers); 
     Erp= fabs(Cp/C0);
     printf("value of Permitivity for Parallel Model: %f\r\n", Erp);
     
     sigma= (L/(Rs*log(Rout/Rin))*1000);  
     printf("value of Conductivity: %f[mS/m]\r\n", sigma); 
} 

float voltage_at(int phase1)
{
    SetWGPhase(phase1);
    delay_ms(140);
    RawData = readADC(); 
    v1=voltage(RawData);
    return v1;
}

//void phaseshift(float *MAX10, unsigned int *INDEX)
// {   
//   unsigned int idx, second,first;
//
//   struct best {
//    unsigned pos;
//    float val;
//    } samples[3] = {{0, 0.0}, };
//
//   for (idx = 0;idx < 3;idx++) {
//    samples[idx].pos = 120*idx;
//    samples[idx].val = voltage_at(samples[idx].pos);
//
//    switch (idx) {
//    default:
//        if (samples[idx].val >= samples[first].val) { second = first; first = idx; }
//        else if (samples[idx].val >= samples[second].val) { second = idx; }
//        break;
//    case 1:
//        if (samples[idx].val >= samples[first].val) { first = idx; }
//        else second = idx;
//        break;
//    case 0:
//        second = first = idx;
//        break;
//        }
//    }
//
// // fprintf(stderr, "Second=%u First=%u\n", second,first );
//
//  if (second != first) {
//    for(idx=3-first-second; samples[second].pos != samples[first].pos; idx=3-first-second) {
//
//       // fprintf(stderr, "Second=%u First=%u , Idx=%u\n", second,first,idx );
//        samples[idx].pos = (samples[second].pos + samples[first].pos) /2;
//        samples[idx].val = voltage_at( samples[idx].pos );
//
//        if (samples[idx].val >= samples[first].val) { second = first; first = idx; }
//        else if (samples[idx].val > samples[second].val) { second = idx; }
//        else break;
//        }
//     }
//
//    *MAX10 = samples[first].val;
//    *INDEX = samples[first].pos;
//
// }     
 
 
 void phaseshift1(float *MAX20, int *INDEX1)
  {      
      int i;
      *MAX20 = 0.0F;
     for (i=0;i<=359;i+=1)   
     {              
       SetWGPhase(i); 
      delay_ms(130);
       RawData = readADC(); 
       v2 = voltage(RawData);   
       if(v2>*MAX20)
           {
             *MAX20 = v2;
             *INDEX1 = i;  
           }             
       }    
  }

//BINARY SEARCH
 void phaseshift(float *MAX10, int *INDEX)
  {
    int  phase2, phase3, i;
   int range;
   float voltage;
   *INDEX = 0;
   *MAX10 = voltage_at(*INDEX);
   for (i = 1; i < 8; i++) {
    phase2 = 45 * i;
    voltage = voltage_at(phase2);
    if (voltage > *MAX10) {                    
        *INDEX = phase2;
        *MAX10 = voltage;
    }
   }   
    range=32;  //360/12 = 30, next higher power of two is 32  
    while (range > 1) {
  range = range / 2;
  phase2 = *INDEX + range;
  if (phase2 >= 360)
      phase2 -= 360;
  phase3 = *INDEX - range;
  if (phase3 < 0)
      phase3 += 360;
  voltage = voltage_at(phase2);
   if (voltage > *MAX10) {
     *INDEX = phase2;
      *MAX10 = voltage;
   }
  voltage = voltage_at(phase3);
   if (voltage > *MAX10) {
      *INDEX = phase3;
      *MAX10 = voltage;
   }
  }   
 }     
 


/* WITH ONE DEGREE ACCURACY
//void phaseshift(float *MAX10, unsigned int *INDEX)
//  {   
//   unsigned int index,i,j,k,a,INDEX20,INDEX30;
//     float MAX = 0.0,MAX20,MAX30;
//     for (i=0;i<360;i+=45)   //while(i<359){ ------- i=45*j) while(j<8)}{ j++;}
//     {              
//       SetWGPhase(i); 
//      delay_ms(130);
//       RawData = readADC(); 
//       v1 = voltage(RawData);   
//       if(v1>MAX)
//           {
//             MAX = v1;
//             index = i;  
//           }             
//       }    
//       MAX20 = MAX; 
//       INDEX20=index;
//        for (i=INDEX20-31; i<=INDEX20+31;i+=15) { 
//         j = i; 
//         SetWGPhase(j); // i should be adjusted if i near zero or 360 : 
//         delay_ms(130); 
//         RawData = readADC(); 
//         v1 = voltage(RawData);    
//         if(v1>MAX20) 
//           { 
//             MAX20 = v1; 
//             INDEX20 = j; 
//           }              
//        }  
//         MAX30=MAX20 ; 
//         INDEX30=INDEX20;
//        for (i=INDEX30-11; i<=INDEX30+11;i+=5) { 
//         k = i; 
//         SetWGPhase(k); // i should be adjusted if i near zero or 360 : 
//         delay_ms(130); 
//         RawData = readADC(); 
//         v1 = voltage(RawData);    
//         if(v1>MAX30) 
//           { 
//             MAX30 = v1; 
//             INDEX30 = k; 
//           }              
//        }   
//         *MAX10=MAX30 ; 
//         *INDEX=INDEX30;
//        for (i=*INDEX-4; i<=*INDEX+4;i+=1) { 
//         a = i; 
//         SetWGPhase(a); // i should be adjusted if i near zero or 360 : 
//         delay_ms(130); 
//         RawData = readADC(); 
//         v1 = voltage(RawData);    
//         if(v1>*MAX10) 
//           { 
//             *MAX10 = v1; 
//             *INDEX = a; 
//           }              
//        } 
//  } */

  

  
  
  
  
//  void phaseshift(void)
//  {
//   for(j=0; j<= 360; j++)
//            {       
//            SetWGPhase(j);
//            mux1 = readADC();  stores the Current ADC value to array
//            v1[j] = voltage(mux1); stores the current voltage to array
//               if(j=360)
//               {    
//                MAX = v1[0];
//                  for (i=0;i<=360;i++)
//                  {
//                     if(v1[i]>MAX)
//                     {
//                        MAX = v1[i];
//                        index = i;  
//                     }  
//                  }               
//               }           
//            }    
//            printf("Max Voltage Value:%d\r\n", MAX); 
//            printf("Related Phase Value:%d\r\n", index);
//  }
















// unsigned int get_timer_ticks(void)
// {      
//    unsigned int i;
//    i= TCNT1H;
//    i= i|TCNT1L;
//    return i;
// }  