
typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);
int printf(char flash *fmtstr,...);
int sprintf(char *str, char flash *fmtstr,...);
int vprintf(char flash * fmtstr, va_list argptr);
int vsprintf(char *str, char flash * fmtstr, va_list argptr);

char *gets(char *str,unsigned int len);
int snprintf(char *str, unsigned int size, char flash *fmtstr,...);
int vsnprintf(char *str, unsigned int size, char flash * fmtstr, va_list argptr);

int scanf(char flash *fmtstr,...);
int sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib

#pragma used+

char *strcat(char *str1,char *str2);
char *strcatf(char *str1,char flash *str2);
char *strchr(char *str,char c);
signed char strcmp(char *str1,char *str2);
signed char strcmpf(char *str1,char flash *str2);
char *strcpy(char *dest,char *src);
char *strcpyf(char *dest,char flash *src);
unsigned int strlenf(char flash *str);
char *strncat(char *str1,char *str2,unsigned char n);
char *strncatf(char *str1,char flash *str2,unsigned char n);
signed char strncmp(char *str1,char *str2,unsigned char n);
signed char strncmpf(char *str1,char flash *str2,unsigned char n);
char *strncpy(char *dest,char *src,unsigned char n);
char *strncpyf(char *dest,char flash *src,unsigned char n);
char *strpbrk(char *str,char *set);
char *strpbrkf(char *str,char flash *set);
char *strrchr(char *str,char c);
char *strrpbrk(char *str,char *set);
char *strrpbrkf(char *str,char flash *set);
char *strstr(char *str1,char *str2);
char *strstrf(char *str1,char flash *str2);
char *strtok(char *str1,char flash *str2);

unsigned int strlen(char *str);
void *memccpy(void *dest,void *src,char c,unsigned n);
void *memchr(void *buf,unsigned char c,unsigned n);
signed char memcmp(void *buf1,void *buf2,unsigned n);
signed char memcmpf(void *buf1,void flash *buf2,unsigned n);
void *memcpy(void *dest,void *src,unsigned n);
void *memcpyf(void *dest,void flash *src,unsigned n);
void *memmove(void *dest,void *src,unsigned n);
void *memset(void *buf,unsigned char c,unsigned n);
unsigned int strcspn(char *str,char *set);
unsigned int strcspnf(char *str,char flash *set);
int strpos(char *str,char c);
int strrpos(char *str,char c);
unsigned int strspn(char *str,char *set);
unsigned int strspnf(char *str,char flash *set);

#pragma used-
#pragma library string.lib

#pragma used+

unsigned char isalnum(char c);
unsigned char isalpha(char c);
unsigned char isascii(char c);
unsigned char iscntrl(char c);
unsigned char isdigit(char c);
unsigned char islower(char c);
unsigned char isprint(char c);
unsigned char ispunct(char c);
unsigned char isspace(char c);
unsigned char isupper(char c);
unsigned char isxdigit(char c);
unsigned char toint(char c);
char tolower(char c);
char toupper(char c);

#pragma used-

#pragma library ctype.lib

#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADCSR=6;     
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

typedef signed char int8_t;
typedef unsigned char uint8_t;

typedef short int16_t;
typedef unsigned short uint16_t;

typedef long int32_t;
typedef unsigned long uint32_t;

typedef short intptr_t;
typedef unsigned short uintptr_t;

typedef short flash_intptr_t;
typedef unsigned short flash_uintptr_t;

typedef short eeprom_intptr_t;
typedef unsigned short eeprom_uintptr_t;

void init(void);
void runCom(void);
unsigned int continous(void);

void getCom(void);

unsigned char spi(unsigned char data);
void SetWGFreq(unsigned int);
void SetWGPhase(unsigned int);

void SetWGPhase1(unsigned int);

void init_io(void);
unsigned char AD7798_8(unsigned char cmd, unsigned char value);
unsigned int AD7798_16(unsigned char cmd, unsigned int value);
unsigned int readADC(void);
float voltage(unsigned int);
void Permitivity(void);
float voltage_at(int phase1);
void phaseshift(float *MAX10, int *INDEX);
void phaseshift1(float *MAX20, int *INDEX1);

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

flash unsigned char *cmdList[8     ] = {
"NO_COM1",       
"inf",          
"scan",          
"WGF",          
"WGP",          
"ADC",       
"MUX",

"PERM"           
};

unsigned char CompIndex;            
unsigned char Compare[64]; 
extern unsigned char Command;              
extern unsigned int  Param;                

unsigned char Step;

extern unsigned char state;
extern unsigned int status;
extern unsigned char debug;

char rx_buffer0[32];

unsigned char rx_wr_index0,rx_rd_index0,rx_counter0;

bit rx_buffer_overflow0;

interrupt [14] void usart_rx_isr(void){
char status,data;
status=UCSRA;
data=UDR; 

if ((status & ((1<<4) | (1<<2) | (1<<3)))==0)
{
rx_buffer0[rx_wr_index0]=data;
if (++rx_wr_index0 == 32) rx_wr_index0=0;
if (++rx_counter0 == 32)
{
rx_counter0=0;
rx_buffer_overflow0=1;
};
};
}

#pragma used+                               
char getchar(void){
char data;
while (rx_counter0==0);
data=rx_buffer0[rx_rd_index0];
if (++rx_rd_index0 == 32) rx_rd_index0=0;
#asm("cli")
--rx_counter0;
#asm("sei")
return data;
}
#pragma used-

char tx_buffer0[32];

unsigned char tx_wr_index0,tx_rd_index0,tx_counter0;

interrupt [16] void usart_tx_isr(void){
if (tx_counter0){
--tx_counter0;
UDR=tx_buffer0[tx_rd_index0];
if (++tx_rd_index0 == 32) tx_rd_index0=0;

}
}

#pragma used+
void putchar(char c){
while (tx_counter0 == 32);
#asm("cli")
if (tx_counter0 || ((UCSRA & (1<<5))==0)){
tx_buffer0[tx_wr_index0]=c;
if (++tx_wr_index0 == 32) tx_wr_index0=0;
++tx_counter0;
}
else
UDR=c;
#asm("sei")
}
#pragma used-

void help(void){

unsigned char  i;

printf("Commands: ");
for(i=0;i<8     ;i++){
printf(cmdList[i]);
printf(", ");
}printf("\r\n");
}

void getCom(void){

unsigned char c;

while(rx_counter0){                     
c = getchar();                    
if(CompIndex >= 64) CompIndex = 0;

if(c == '#'){                     
CompIndex = 0;
}else if(c == '\r'){              
Compare[CompIndex]='\0';    
break;                      
}else if(c == '\n'){              

}else if(c == 8){                 
if(CompIndex) CompIndex--;  
}else if(c == 9){                 
help();                     
}else if(c == 27){                
Command = 0;                
Param = 0;                  
Step = 0;
}else{
Compare[CompIndex++]=c;     
}if(!rx_counter0) return;         
}CompIndex=0;                           

c = 1;                            

while(c<8     ){          
if(strncmpf(Compare,cmdList[c],strlenf(cmdList[c])) == 0) break;
c++; 
}

if(c<8     ){             
Command = c;      
if(isdigit(Compare[strlenf(cmdList[c])])){
Param = atoi(&Compare[strlenf(cmdList[c])]);

}else{   
Param  = 0;

}
printf("@%s\r\n",&Compare); 
}else{
printf("Command not found\r\n");  
printf("->??: '%s'\r\n",&Compare); 
Command = 0;
}

}

