//Clock frequency of system clock
#define FSCLK   16000000    //16 MHz

//ADC
#define ADC_VREF_TYPE 0xC0  //Using 1.1V as reference
#define VCC  0   //ADC channel for reading VCC
#define AVP  1   //ADC channel for reading +12V
#define AVN  2   //ADC channel for reading -12V
#define VIN  3   //ADC channel for reading +24V

// Commands
#define CMD_SIZE    8     //Number of commands
#define NO_COM1      0
#define inf         1
#define scan          2       
#define WGF         3
#define WGP         4
#define ADC         5
#define MUX      6
#define PERM      7
//  #define   sdgrwer  (1<<3)       //use this to set adc port 1
//SET_ADC_PON1(vaariable)             variable=variable|(1<<2)

//Calculated
//Baudrate
#define BAUD        (FSCLK/(16*9600))-1   //Calculate UBRR content

//FUNCTIONS

//Main.c
void init(void);
void runCom(void);
unsigned int continous(void);
//void selcase(unsigned int arg);
//unsigned int timer_phase (void);


//interface.c
void getCom(void);
//void EEPROM_write(unsigned int eAdr, unsigned char eData);
//unsigned char EEPROM_read(unsigned int eAdr);


//isr.c
//interrupt [TIM0_COMPA] void timer0_compa_isr(void);
//interrupt [TIM1_COMPA] void timer1_compa_isr(void);

//sensor.c
unsigned char spi(unsigned char data);
void SetWGFreq(unsigned int);
void SetWGPhase(unsigned int);
//void SetWGFreq1(unsigned int freq);
void SetWGPhase1(unsigned int);
//void setupAd();
//unsigned int ReadAdStatusReg(void);
//unsigned int ReadAdModeReg(void);
//unsigned int ReadAdConfReg(void);
//unsigned int ReadAdIdReg(void);
//unsigned int ReadAd(void);
//unsigned char CheckStatus(void);
void init_io(void);
unsigned char AD7798_8(unsigned char cmd, unsigned char value);
unsigned int AD7798_16(unsigned char cmd, unsigned int value);
unsigned int readADC(void);
float voltage(unsigned int);
void Permitivity(void);
float voltage_at(int phase1);
void phaseshift(float *MAX10, int *INDEX);
void phaseshift1(float *MAX20, int *INDEX1);



//void StartTimer1(void);
//void StopTimer1(void);
//void ResetTimer1(void);
//unsigned int get_timer_ticks(void);


//void CheckStatus(void);
//void SensorPower(char p);
//void BattCh(void);
//void TempCh(void);
//void PressCh(void);
//void Avdd(void);
//unsigned int BattVoltCalc(unsigned int);
//unsigned int AnalogVoltCalc(unsigned int);
//unsigned int PressCalc(unsigned int);
//void MeasureAll(void);



