#include <MEGA32.h>
#include <main.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <interface.h>                                                                  
#include <delay.h>
#include <stdint.h>
#include <io.h>
#include <math.h>


#define ADC_CS_PIN PINB.3
#define WG_CS_PIN PINB.4

#define MUX_A2 PORTB.0
#define MUX_A1 PORTB.1
#define MUX_A0 PORTB.2
#define ADC_CS PORTB.3
#define WG_CS PORTB.4
#define MOSI PORTB.5
//#define MISO PINB.6
#define SCK PORTB.7


#define MISO_PU PORTB.6 
#define MISO_PIN PINB.6 


#define MODE_SW4 PORTC.0
#define MODE_SW3 PORTC.1
#define MODE_SW2 PORTC.6
#define MODE_SW1 PORTC.7

#define MODE_SW10 PORTD.2
#define MODE_SW9 PORTD.3
#define MODE_SW8 PORTD.4
#define MODE_SW7 PORTD.5
#define MODE_SW6 PORTD.6
#define MODE_SW5 PORTD.7



extern char adcStatus;
extern char adcStatus1;
extern char adcId;
extern unsigned int adcMode;
extern unsigned int adcConfig;
//extern unsigned int i;
//extern unsigned int delay;
extern  unsigned int data;

extern unsigned int battVoltRaw;
extern unsigned int battVolt;
extern unsigned int analogVoltRaw;
extern unsigned int analogVolt;
extern unsigned int tempRaw;
extern unsigned int temp;
extern unsigned int pressRaw;
extern unsigned int press;

extern unsigned char statusreg,Id; 
extern unsigned int value, value1, mode, conf, adc,Phase,WaveFreq;
extern float Analog_Voltage,v1,Vg,Vr,v2; 
extern  unsigned int RawData;
extern int Newvalue1,Newvalue;


  

       


  void init_io(void) 
  { 
    //DDRB = (1<<7)|(1<<5)|(1<<4)|(1<<3);        // make SCK, MOSI, CS1, CS2 outputs  
    DDRB = 0xBF;       
  //  PORTB=0x03;
    ADC_CS = 1;              //disable ADC 
    WG_CS = 1;               //disable WaveGenerator 
    MISO_PU = 1;             //enable pull-up on MISO so we can test !RDY 
  } 
    
  
unsigned char spi(unsigned char data) 
{ 
    //Start transmision 
    SPDR = data; 
    //Wait for transmision complete 
    while (!(SPSR & 0x80)); 
    return SPDR; 
}        
  


//Sets the waveform generator output to given kHz
  void SetWGFreq(unsigned int freq)
  {
    unsigned long freg;
    char fByte0;
    char fByte1;
    char fByte2;
    char fByte3;
    
    freg = (unsigned long)freq*33554.432;   //Number based on a MCLK of 8 MHz
    fByte0 = (char)freg;
    fByte1 = (char)(freg>>8);
    fByte1 = (fByte1 & 0x3F) | 0x40;        //clears bits 15 and 14, then sets for FREQ0
    fByte2 = (char)(freg>>14);              //byte1 only has 6 bits, so move over by 8+6
    fByte3 = (char)(freg>>22);              //byte1 only has 6 bits, so move over by 8+8+6
    fByte3 = (fByte3 & 0x3F) | 0x40;        //clears bits 15 and 14, then sets for FREQ0
    
    SPCR = 0x5A;        //Set SPI to mode 2 and Fosc/64
    WG_CS = 0;
    while(WG_CS_PIN);   //Wait for chip select pin to go low
    spi(0x20);          //Load control register with B28 high
    spi(0x00);
    spi(fByte1);
    spi(fByte0);
    spi(fByte3);
    spi(fByte2);
    WG_CS = 1;
  }          
  


  void SetWGPhase(unsigned int phase)
  {
    //unsigned long phase; 
    phase = (uint32_t)phase*4096/360;
    SPCR = 0x5A;
    WG_CS = 0;
    while(WG_CS_PIN);
    spi(0x20);
    spi(0x00);
    spi((phase>>8) | 0xC0);     //Load into phase register 0
    spi(phase & 0x00FF);
    WG_CS = 1;
  }   
  
   void SetWGPhase1(unsigned int phase)
  {
    //unsigned long phase; 
    phase = (uint32_t)phase*4096/360;
    SPCR = 0x5A;
    WG_CS = 0;
    while(WG_CS_PIN);
    spi(0x20);
    spi(0x00);
    spi((phase>>8) | 0xC0);     //Load into phase register 0
    spi(phase & 0x00FF);
    WG_CS = 1;
  }    
   
          
  
  
  
  //function for reading or writing 8 bit registers 
unsigned char AD7798_8(unsigned char cmd, unsigned char value) 
{ 
    unsigned char data; 
    SPCR = 0x5D;        // mode #3 F_CPU/16 
    ADC_CS = 0;                 // enable 
    spi(cmd);                   //Place instruction in communication register 
    data = spi(value);          // and lo-byte. 
    ADC_CS = 1;                 // disable 
    return data; 
} 

//function for reading or writing 16 bit registers 
unsigned int AD7798_16(unsigned char cmd, unsigned int value) 
{ 
    unsigned int data; 
    SPCR = 0x5D;        // mode #3 F_CPU/16 
    ADC_CS = 0;                 // enable 
    spi(cmd);                   //Place instruction in communication register 
    data = spi(value >> 8);     // read hi-byte 
    data = (data << 8) | spi(value);    // and lo-byte. 
    ADC_CS = 1;                 // disable 
    return data; 
} 
  
 
    unsigned int readADC(void)  
    {         
           
           init_io();                                 // setup SPI pins 

           // read power on default register values 
           statusreg = AD7798_8(0x40, 0xFF);          // read STATUS register
           Id = AD7798_8(0x60, 0xFF);                 // read ID register  
           mode = AD7798_16(0x48, 0xFFFF);            // read MODE register 
           conf = AD7798_16(0x50, 0xFFFF);            // read CONFIGURATIONregister 
      
   
           AD7798_16(0x10, 0x0010);                 // write Configuration reg = 0x0010.  2.5V range  
           value = AD7798_16(0x50, 0xFFFF);         // read Configration register    
          
 
           while ((statusreg & 0x80) != 0);                         // wait till ADC is ready 
           adc = AD7798_16(0x58, 0xFFFF);                           // read registe    
          return adc;
         }    
                                             
 float voltage(unsigned int a)
{
           float Ain=0.0F, adcfloat=0.0F; 
           adcfloat = (float)a;
           Ain=((adcfloat / 32768.0F) - 1.0F) / 0.4F; 
           Ain=2.5+Ain;
           return Ain;
}
   
 


float voltage_at(int phase1)
{
    SetWGPhase(phase1);
    delay_ms(140);
    RawData = readADC(); 
    v1=voltage(RawData);
    return v1;
}

  
 
 
 void phaseshift(float *MAX20, int *INDEX1)
  {      
      int i;
      *MAX20 = 0.0F;
     for (i=0;i<=359;i+=1)   
     {              
       SetWGPhase(i); 
      delay_ms(130);
       RawData = readADC(); 
       v2 = voltage(RawData);   
       if(v2>*MAX20)
           {
             *MAX20 = v2;
             *INDEX1 = i;  
           }             
       }    
  }


