
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADCSR=6;     
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

void init(void);
void runCom(void);
unsigned int continous(void);

void getCom(void);

unsigned char spi(unsigned char data);
void SetWGFreq(unsigned int);
void SetWGPhase(unsigned int);

void SetWGPhase1(unsigned int);

void init_io(void);
unsigned char AD7798_8(unsigned char cmd, unsigned char value);
unsigned int AD7798_16(unsigned char cmd, unsigned int value);
unsigned int readADC(void);
float voltage(unsigned int);
void Permitivity(void);
float voltage_at(int phase1);
void phaseshift(float *MAX10, int *INDEX);
void phaseshift1(float *MAX20, int *INDEX1);

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);
int printf(char flash *fmtstr,...);
int sprintf(char *str, char flash *fmtstr,...);
int vprintf(char flash * fmtstr, va_list argptr);
int vsprintf(char *str, char flash * fmtstr, va_list argptr);

char *gets(char *str,unsigned int len);
int snprintf(char *str, unsigned int size, char flash *fmtstr,...);
int vsnprintf(char *str, unsigned int size, char flash * fmtstr, va_list argptr);

int scanf(char flash *fmtstr,...);
int sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib

#pragma used+

char *strcat(char *str1,char *str2);
char *strcatf(char *str1,char flash *str2);
char *strchr(char *str,char c);
signed char strcmp(char *str1,char *str2);
signed char strcmpf(char *str1,char flash *str2);
char *strcpy(char *dest,char *src);
char *strcpyf(char *dest,char flash *src);
unsigned int strlenf(char flash *str);
char *strncat(char *str1,char *str2,unsigned char n);
char *strncatf(char *str1,char flash *str2,unsigned char n);
signed char strncmp(char *str1,char *str2,unsigned char n);
signed char strncmpf(char *str1,char flash *str2,unsigned char n);
char *strncpy(char *dest,char *src,unsigned char n);
char *strncpyf(char *dest,char flash *src,unsigned char n);
char *strpbrk(char *str,char *set);
char *strpbrkf(char *str,char flash *set);
char *strrchr(char *str,char c);
char *strrpbrk(char *str,char *set);
char *strrpbrkf(char *str,char flash *set);
char *strstr(char *str1,char *str2);
char *strstrf(char *str1,char flash *str2);
char *strtok(char *str1,char flash *str2);

unsigned int strlen(char *str);
void *memccpy(void *dest,void *src,char c,unsigned n);
void *memchr(void *buf,unsigned char c,unsigned n);
signed char memcmp(void *buf1,void *buf2,unsigned n);
signed char memcmpf(void *buf1,void flash *buf2,unsigned n);
void *memcpy(void *dest,void *src,unsigned n);
void *memcpyf(void *dest,void flash *src,unsigned n);
void *memmove(void *dest,void *src,unsigned n);
void *memset(void *buf,unsigned char c,unsigned n);
unsigned int strcspn(char *str,char *set);
unsigned int strcspnf(char *str,char flash *set);
int strpos(char *str,char c);
int strrpos(char *str,char c);
unsigned int strspn(char *str,char *set);
unsigned int strspnf(char *str,char flash *set);

#pragma used-
#pragma library string.lib

#pragma used+

unsigned char isalnum(char c);
unsigned char isalpha(char c);
unsigned char isascii(char c);
unsigned char iscntrl(char c);
unsigned char isdigit(char c);
unsigned char islower(char c);
unsigned char isprint(char c);
unsigned char ispunct(char c);
unsigned char isspace(char c);
unsigned char isupper(char c);
unsigned char isxdigit(char c);
unsigned char toint(char c);
char tolower(char c);
char toupper(char c);

#pragma used-

#pragma library ctype.lib

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

typedef signed char int8_t;
typedef unsigned char uint8_t;

typedef short int16_t;
typedef unsigned short uint16_t;

typedef long int32_t;
typedef unsigned long uint32_t;

typedef short intptr_t;
typedef unsigned short uintptr_t;

typedef short flash_intptr_t;
typedef unsigned short flash_uintptr_t;

typedef short eeprom_intptr_t;
typedef unsigned short eeprom_uintptr_t;

#pragma used+

signed char cmax(signed char a,signed char b);
int max(int a,int b);
long lmax(long a,long b);
float fmax(float a,float b);
signed char cmin(signed char a,signed char b);
int min(int a,int b);
long lmin(long a,long b);
float fmin(float a,float b);
signed char csign(signed char x);
signed char sign(int x);
signed char lsign(long x);
signed char fsign(float x);
unsigned char isqrt(unsigned int x);
unsigned int lsqrt(unsigned long x);
float sqrt(float x);
float ftrunc(float x);
float floor(float x);
float ceil(float x);
float fmod(float x,float y);
float modf(float x,float *ipart);
float ldexp(float x,int expon);
float frexp(float x,int *expon);
float exp(float x);
float log(float x);
float log10(float x);
float pow(float x,float y);
float sin(float x);
float cos(float x);
float tan(float x);
float sinh(float x);
float cosh(float x);
float tanh(float x);
float asin(float x);
float acos(float x);
float atan(float x);
float atan2(float y,float x);

#pragma used-
#pragma library math.lib

extern char adcStatus;
extern char adcStatus1;
extern char adcId;
extern unsigned int adcMode;
extern unsigned int adcConfig;

extern  unsigned int data;

extern unsigned int battVoltRaw;
extern unsigned int battVolt;
extern unsigned int analogVoltRaw;
extern unsigned int analogVolt;
extern unsigned int tempRaw;
extern unsigned int temp;
extern unsigned int pressRaw;
extern unsigned int press;

extern unsigned char statusreg,Id; 
extern unsigned int value, value1, mode, conf, adc,Phase,WaveFreq;
extern float Analog_Voltage,v1,Vg,Vr,v2; 
extern  unsigned int RawData;
extern int Newvalue1,Newvalue;

void init_io(void) 
{ 

DDRB = 0xBF;       

PORTB.3 = 1;              
PORTB.4 = 1;               
PORTB.6  = 1;             
} 

unsigned char spi(unsigned char data) 
{ 

SPDR = data; 

while (!(SPSR & 0x80)); 
return SPDR; 
}        

void SetWGFreq(unsigned int freq)
{
unsigned long freg;
char fByte0;
char fByte1;
char fByte2;
char fByte3;

freg = (unsigned long)freq*33554.432;   
fByte0 = (char)freg;
fByte1 = (char)(freg>>8);
fByte1 = (fByte1 & 0x3F) | 0x40;        
fByte2 = (char)(freg>>14);              
fByte3 = (char)(freg>>22);              
fByte3 = (fByte3 & 0x3F) | 0x40;        

SPCR = 0x5A;        
PORTB.4 = 0;
while(PINB.4);   
spi(0x20);          
spi(0x00);
spi(fByte1);
spi(fByte0);
spi(fByte3);
spi(fByte2);
PORTB.4 = 1;
}          

void SetWGPhase(unsigned int phase)
{

phase = (uint32_t)phase*4096/360;
SPCR = 0x5A;
PORTB.4 = 0;
while(PINB.4);
spi(0x20);
spi(0x00);
spi((phase>>8) | 0xC0);     
spi(phase & 0x00FF);
PORTB.4 = 1;
}   

void SetWGPhase1(unsigned int phase)
{

phase = (uint32_t)phase*4096/360;
SPCR = 0x5A;
PORTB.4 = 0;
while(PINB.4);
spi(0x20);
spi(0x00);
spi((phase>>8) | 0xC0);     
spi(phase & 0x00FF);
PORTB.4 = 1;
}    

unsigned char AD7798_8(unsigned char cmd, unsigned char value) 
{ 
unsigned char data; 
SPCR = 0x5D;        
PORTB.3 = 0;                 
spi(cmd);                   
data = spi(value);          
PORTB.3 = 1;                 
return data; 
} 

unsigned int AD7798_16(unsigned char cmd, unsigned int value) 
{ 
unsigned int data; 
SPCR = 0x5D;        
PORTB.3 = 0;                 
spi(cmd);                   
data = spi(value >> 8);     
data = (data << 8) | spi(value);    
PORTB.3 = 1;                 
return data; 
} 

unsigned int readADC(void)  
{         

init_io();                                 

statusreg = AD7798_8(0x40, 0xFF);          
Id = AD7798_8(0x60, 0xFF);                 
mode = AD7798_16(0x48, 0xFFFF);            
conf = AD7798_16(0x50, 0xFFFF);            

AD7798_16(0x10, 0x0010);                 
value = AD7798_16(0x50, 0xFFFF);         

while ((statusreg & 0x80) != 0);                         
adc = AD7798_16(0x58, 0xFFFF);                           
return adc;
}    

float voltage(unsigned int a)
{
float Ain=0.0F, adcfloat=0.0F; 
adcfloat = (float)a;
Ain=((adcfloat / 32768.0F) - 1.0F) / 0.4F; 
Ain=2.5+Ain;
return Ain;
}

void Permitivity(void)
{
float Z=0.0F, R=1000.0F, Rs,Cs,Rp,Cp,theta,theta1,delta,delta1,W,Xcs,C0=25.55E-12,Erp,Ers;
float pi, Rin=0.003F,Rout=0.00397F, L=0.08F, Cp1,Cs1,sigma;
pi = 4.0*atan(1.0);
theta=abs(Newvalue1-Newvalue); 
theta1= theta/180*pi;
delta=abs(90-theta); 
delta1= delta/180*pi;
Z= ((Vg-Vr)/Vr)*R; 
printf("value of Impedance (Z): %f[Ohms]\r\n", Z);  
printf("level of excitation signal (Vg): %f[V]\r\n", Vg);
printf("level of return signal (Vr): %f[V]\r\n",Vr);      
printf("value of Theta: %f\r\n", theta);
printf("value of Delta: %f\r\n", delta);

W= (2.0*pi*WaveFreq*1000); 
printf("value of Omega: %f\r\n", W);

Rs= (fabs(Z)* cos(theta1));
Xcs= fabs((fabs(Z)* sin(theta1)));  
Rp= ((1+pow(tan(delta1),2))/(pow(tan(delta1),2))*Rs);

Cs= fabs(1/(W*Xcs)); 
Cs1= Cs*10E11;  
Cp= fabs((Cs/(1+pow(tan(delta1),2))));
Cp1= Cp*10E11;    

printf("value of Reactance(Xc): %f\r\n", Xcs);
printf("value of Serial Resistance(Rs): %f[Ohms]\r\n", Rs); 
printf("value of Serial Capacitance(Cs): %f[pF]\r\n", Cs1);
printf("value of Parallel Resistance(Rp): %f[Ohms]\r\n", Rp);  
printf("value of Parallel Capacitance(Cp): %f[pF]\r\n", Cp1);   
Ers= fabs(Cs/C0);
printf("value of Permitivity for Serial Model: %f\r\n", Ers); 
Erp= fabs(Cp/C0);
printf("value of Permitivity for Parallel Model: %f\r\n", Erp);

sigma= (L/(Rs*log(Rout/Rin))*1000);  
printf("value of Conductivity: %f[mS/m]\r\n", sigma); 
} 

float voltage_at(int phase1)
{
SetWGPhase(phase1);
delay_ms(140);
RawData = readADC(); 
v1=voltage(RawData);
return v1;
}

void phaseshift1(float *MAX20, int *INDEX1)
{      
int i;
*MAX20 = 0.0F;
for (i=0;i<=359;i+=1)   
{              
SetWGPhase(i); 
delay_ms(130);
RawData = readADC(); 
v2 = voltage(RawData);   
if(v2>*MAX20)
{
*MAX20 = v2;
*INDEX1 = i;  
}             
}    
}

void phaseshift(float *MAX10, int *INDEX)
{
int  phase2, phase3, i;
int range;
float voltage;
*INDEX = 0;
*MAX10 = voltage_at(*INDEX);
for (i = 1; i < 8; i++) {
phase2 = 45 * i;
voltage = voltage_at(phase2);
if (voltage > *MAX10) {                    
*INDEX = phase2;
*MAX10 = voltage;
}
}   
range=32;  
while (range > 1) {
range = range / 2;
phase2 = *INDEX + range;
if (phase2 >= 360)
phase2 -= 360;
phase3 = *INDEX - range;
if (phase3 < 0)
phase3 += 360;
voltage = voltage_at(phase2);
if (voltage > *MAX10) {
*INDEX = phase2;
*MAX10 = voltage;
}
voltage = voltage_at(phase3);
if (voltage > *MAX10) {
*INDEX = phase3;
*MAX10 = voltage;
}
}   
}     

