
;CodeVisionAVR C Compiler V2.04.4a Standard
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega32
;Program type             : Application
;Clock frequency          : 16,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : float, width, precision
;(s)scanf features        : long, width
;External RAM size        : 0
;Data Stack size          : 512 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : No
;'char' is unsigned       : Yes
;8 bit enums              : No
;global 'const' stored in FLASH: Yes
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega32
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2048
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _statusreg=R5
	.DEF _Id=R4
	.DEF _value=R6
	.DEF _value1=R8
	.DEF _mode=R10
	.DEF _conf=R12

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer1_compa_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _usart_rx_isr
	JMP  0x00
	JMP  _usart_tx_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0x3:
	.DB  0x7D
_0x4:
	.DB  0x1
_0x5:
	.DB  0x10
_0x6:
	.DB  0x7D
_0x40:
	.DB  0x7C,0xBD,0xE0,0x2D,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x7A,0x44
	.DB  0x0,0x0,0x0,0x0
_0x0:
	.DB  0xD,0xA,0xD,0xA,0x0,0x50,0x65,0x74
	.DB  0x72,0x6F,0x74,0x65,0x63,0x68,0xD,0xA
	.DB  0x0,0x54,0x75,0x72,0x62,0x6F,0x50,0x56
	.DB  0x54,0x32,0x20,0x50,0x65,0x72,0x6D,0x69
	.DB  0x74,0x74,0x69,0x76,0x69,0x74,0x79,0xD
	.DB  0xA,0x0,0x56,0x65,0x72,0x2E,0x20,0x31
	.DB  0x2E,0x30,0x41,0xD,0xA,0x0,0x43,0x6F
	.DB  0x6D,0x70,0x69,0x6C,0x65,0x64,0x3A,0x20
	.DB  0x25,0x70,0x20,0x25,0x70,0xD,0xA,0x0
	.DB  0x44,0x65,0x63,0x20,0x31,0x37,0x20,0x32
	.DB  0x30,0x31,0x32,0x0,0x31,0x37,0x3A,0x35
	.DB  0x32,0x3A,0x30,0x30,0x0,0x50,0x6F,0x77
	.DB  0x65,0x72,0x20,0x73,0x75,0x70,0x70,0x6C
	.DB  0x79,0x20,0x76,0x6F,0x6C,0x74,0x61,0x67
	.DB  0x65,0x3A,0x20,0x25,0x75,0x20,0x5B,0x6D
	.DB  0x56,0x5D,0xD,0xA,0x0,0x50,0x6F,0x73
	.DB  0x69,0x74,0x69,0x76,0x65,0x20,0x61,0x6E
	.DB  0x61,0x6C,0x6F,0x67,0x20,0x76,0x6F,0x6C
	.DB  0x74,0x61,0x67,0x65,0x3A,0x20,0x25,0x75
	.DB  0x20,0x5B,0x6D,0x56,0x5D,0x9,0x4E,0x65
	.DB  0x67,0x61,0x74,0x69,0x76,0x65,0x20,0x61
	.DB  0x6E,0x61,0x6C,0x6F,0x67,0x20,0x76,0x6F
	.DB  0x6C,0x74,0x61,0x67,0x65,0x3A,0x20,0x2D
	.DB  0x25,0x75,0x20,0x5B,0x6D,0x56,0x5D,0xD
	.DB  0xA,0x0,0x44,0x69,0x67,0x69,0x74,0x61
	.DB  0x6C,0x20,0x73,0x75,0x70,0x70,0x6C,0x79
	.DB  0x20,0x76,0x6F,0x6C,0x74,0x61,0x67,0x65
	.DB  0x3A,0x20,0x25,0x75,0x20,0x5B,0x6D,0x56
	.DB  0x5D,0xD,0xA,0x0,0x41,0x44,0x43,0x20
	.DB  0x52,0x61,0x77,0x44,0x61,0x74,0x61,0x3A
	.DB  0x25,0x64,0xD,0xA,0x0,0x44,0x65,0x6D
	.DB  0x6F,0x64,0x75,0x6C,0x61,0x74,0x6F,0x72
	.DB  0x20,0x56,0x6F,0x6C,0x74,0x61,0x67,0x65
	.DB  0x20,0x4C,0x65,0x76,0x65,0x6C,0x3A,0x25
	.DB  0x66,0x20,0x5B,0x76,0x5D,0xD,0xA,0x0
	.DB  0x50,0x72,0x65,0x73,0x65,0x6E,0x74,0x20
	.DB  0x77,0x61,0x76,0x65,0x20,0x66,0x72,0x65
	.DB  0x71,0x75,0x65,0x6E,0x63,0x79,0x20,0x69
	.DB  0x73,0x20,0x73,0x65,0x74,0x74,0x65,0x64
	.DB  0x20,0x74,0x6F,0x3A,0x25,0x64,0xD,0xA
	.DB  0x0,0x56,0x72,0x20,0x53,0x69,0x67,0x6E
	.DB  0x61,0x6C,0x20,0x50,0x68,0x61,0x73,0x65
	.DB  0x20,0x76,0x61,0x6C,0x75,0x65,0x20,0x61
	.DB  0x74,0x20,0x6D,0x61,0x78,0x69,0x6D,0x75
	.DB  0x6D,0x20,0x76,0x6F,0x6C,0x74,0x61,0x67
	.DB  0x65,0x20,0x3A,0x25,0x64,0xD,0xA,0x0
	.DB  0x56,0x67,0x20,0x53,0x69,0x67,0x6E,0x61
	.DB  0x6C,0x20,0x50,0x68,0x61,0x73,0x65,0x20
	.DB  0x76,0x61,0x6C,0x75,0x65,0x20,0x61,0x74
	.DB  0x20,0x6D,0x61,0x78,0x69,0x6D,0x75,0x6D
	.DB  0x20,0x76,0x6F,0x6C,0x74,0x61,0x67,0x65
	.DB  0x20,0x3A,0x25,0x64,0xD,0xA,0x0,0x4D
	.DB  0x75,0x78,0x20,0x69,0x73,0x20,0x73,0x65
	.DB  0x74,0x74,0x65,0x64,0x20,0x74,0x6F,0x3A
	.DB  0x25,0x64,0x0,0xD,0xA,0x41,0x6D,0x70
	.DB  0x6C,0x69,0x66,0x69,0x63,0x61,0x74,0x69
	.DB  0x6F,0x6E,0x20,0x73,0x74,0x61,0x67,0x65
	.DB  0x20,0x33,0x78,0x20,0x73,0x65,0x6C,0x65
	.DB  0x63,0x74,0x65,0x64,0x0,0xD,0xA,0x41
	.DB  0x6D,0x70,0x6C,0x69,0x66,0x69,0x63,0x61
	.DB  0x74,0x69,0x6F,0x6E,0x20,0x73,0x74,0x61
	.DB  0x67,0x65,0x20,0x31,0x33,0x78,0x20,0x73
	.DB  0x65,0x6C,0x65,0x63,0x74,0x65,0x64,0x0
	.DB  0xD,0xA,0x41,0x6D,0x70,0x6C,0x69,0x66
	.DB  0x69,0x63,0x61,0x74,0x69,0x6F,0x6E,0x20
	.DB  0x73,0x74,0x61,0x67,0x65,0x20,0x35,0x78
	.DB  0x20,0x73,0x65,0x6C,0x65,0x63,0x74,0x65
	.DB  0x64,0x0,0xD,0xA,0x41,0x6D,0x70,0x6C
	.DB  0x69,0x66,0x69,0x63,0x61,0x74,0x69,0x6F
	.DB  0x6E,0x20,0x73,0x74,0x61,0x67,0x65,0x20
	.DB  0x31,0x35,0x78,0x20,0x73,0x65,0x6C,0x65
	.DB  0x63,0x74,0x65,0x64,0x0,0xD,0xA,0x44
	.DB  0x61,0x6D,0x70,0x6C,0x69,0x6E,0x67,0x20
	.DB  0x73,0x74,0x61,0x67,0x65,0x20,0x69,0x73
	.DB  0x20,0x73,0x65,0x6C,0x65,0x63,0x74,0x65
	.DB  0x64,0x0,0xD,0xA,0x42,0x79,0x70,0x61
	.DB  0x73,0x73,0x20,0x73,0x74,0x61,0x67,0x65
	.DB  0x20,0x69,0x73,0x20,0x73,0x65,0x6C,0x65
	.DB  0x63,0x74,0x65,0x64,0x0,0x53,0x65,0x6C
	.DB  0x65,0x63,0x74,0x20,0x61,0x6D,0x70,0x6C
	.DB  0x69,0x66,0x69,0x63,0x61,0x74,0x69,0x6F
	.DB  0x6E,0x20,0x73,0x74,0x61,0x67,0x65,0x3A
	.DB  0x20,0x31,0x2D,0x33,0x78,0x2C,0x32,0x2D
	.DB  0x35,0x78,0x2C,0x33,0x2D,0x31,0x33,0x78
	.DB  0x2C,0x34,0x2D,0x31,0x35,0x78,0xD,0xA
	.DB  0x35,0x2D,0x44,0x61,0x6D,0x70,0x69,0x6E
	.DB  0x67,0x20,0x73,0x74,0x61,0x67,0x65,0xD
	.DB  0xA,0x36,0x2D,0x42,0x79,0x70,0x61,0x73
	.DB  0x73,0x20,0x63,0x69,0x72,0x63,0x69,0x75
	.DB  0x74,0xD,0xA,0x0,0x41,0x6D,0x70,0x6C
	.DB  0x69,0x66,0x69,0x63,0x61,0x74,0x69,0x6F
	.DB  0x6E,0x20,0x73,0x74,0x61,0x67,0x65,0x20
	.DB  0x33,0x78,0x20,0x73,0x65,0x6C,0x65,0x63
	.DB  0x74,0x65,0x64,0xD,0xA,0x0,0x41,0x6D
	.DB  0x70,0x6C,0x69,0x66,0x69,0x63,0x61,0x74
	.DB  0x69,0x6F,0x6E,0x20,0x73,0x74,0x61,0x67
	.DB  0x65,0x20,0x35,0x78,0x20,0x73,0x65,0x6C
	.DB  0x65,0x63,0x74,0x65,0x64,0xD,0xA,0x0
	.DB  0x41,0x6D,0x70,0x6C,0x69,0x66,0x69,0x63
	.DB  0x61,0x74,0x69,0x6F,0x6E,0x20,0x73,0x74
	.DB  0x61,0x67,0x65,0x20,0x31,0x33,0x78,0x20
	.DB  0x73,0x65,0x6C,0x65,0x63,0x74,0x65,0x64
	.DB  0xD,0xA,0x0,0x41,0x6D,0x70,0x6C,0x69
	.DB  0x66,0x69,0x63,0x61,0x74,0x69,0x6F,0x6E
	.DB  0x20,0x73,0x74,0x61,0x67,0x65,0x20,0x31
	.DB  0x35,0x78,0x20,0x73,0x65,0x6C,0x65,0x63
	.DB  0x74,0x65,0x64,0xD,0xA,0x0,0x44,0x61
	.DB  0x6D,0x70,0x69,0x6E,0x67,0x20,0x73,0x74
	.DB  0x61,0x67,0x65,0x20,0x73,0x65,0x6C,0x65
	.DB  0x63,0x74,0x65,0x64,0xD,0xA,0x0,0x42
	.DB  0x79,0x70,0x61,0x73,0x73,0x20,0x63,0x69
	.DB  0x72,0x63,0x75,0x69,0x74,0x20,0x73,0x65
	.DB  0x6C,0x65,0x63,0x74,0x65,0x64,0xD,0xA
	.DB  0x0,0x4D,0x75,0x78,0x63,0x68,0x61,0x6E
	.DB  0x65,0x6C,0x20,0x31,0x20,0x44,0x65,0x6D
	.DB  0x6F,0x64,0x75,0x6C,0x61,0x74,0x6F,0x72
	.DB  0x20,0x56,0x6F,0x6C,0x74,0x61,0x67,0x65
	.DB  0x20,0x4C,0x65,0x76,0x65,0x6C,0x3A,0x25
	.DB  0x66,0x20,0x5B,0x76,0x5D,0xD,0xA,0x0
	.DB  0x52,0x65,0x6C,0x61,0x74,0x65,0x64,0x20
	.DB  0x50,0x68,0x61,0x73,0x65,0x20,0x56,0x61
	.DB  0x6C,0x75,0x65,0x3A,0x25,0x64,0xD,0xA
	.DB  0x0,0x4D,0x75,0x78,0x63,0x68,0x61,0x6E
	.DB  0x65,0x6C,0x20,0x32,0x20,0x44,0x65,0x6D
	.DB  0x6F,0x64,0x75,0x6C,0x61,0x74,0x6F,0x72
	.DB  0x20,0x56,0x6F,0x6C,0x74,0x61,0x67,0x65
	.DB  0x20,0x4C,0x65,0x76,0x65,0x6C,0x3A,0x25
	.DB  0x66,0x20,0x5B,0x76,0x5D,0xD,0xA,0x0
	.DB  0x4D,0x75,0x78,0x63,0x68,0x61,0x6E,0x65
	.DB  0x6C,0x20,0x33,0x20,0x44,0x65,0x6D,0x6F
	.DB  0x64,0x75,0x6C,0x61,0x74,0x6F,0x72,0x20
	.DB  0x56,0x6F,0x6C,0x74,0x61,0x67,0x65,0x20
	.DB  0x4C,0x65,0x76,0x65,0x6C,0x3A,0x25,0x66
	.DB  0x20,0x5B,0x76,0x5D,0xD,0xA,0x0,0x4D
	.DB  0x75,0x78,0x63,0x68,0x61,0x6E,0x65,0x6C
	.DB  0x20,0x34,0x20,0x44,0x65,0x6D,0x6F,0x64
	.DB  0x75,0x6C,0x61,0x74,0x6F,0x72,0x20,0x56
	.DB  0x6F,0x6C,0x74,0x61,0x67,0x65,0x20,0x4C
	.DB  0x65,0x76,0x65,0x6C,0x3A,0x25,0x66,0x20
	.DB  0x5B,0x76,0x5D,0xD,0xA,0x0,0x4D,0x75
	.DB  0x78,0x63,0x68,0x61,0x6E,0x65,0x6C,0x20
	.DB  0x35,0x20,0x44,0x65,0x6D,0x6F,0x64,0x75
	.DB  0x6C,0x61,0x74,0x6F,0x72,0x20,0x56,0x6F
	.DB  0x6C,0x74,0x61,0x67,0x65,0x20,0x4C,0x65
	.DB  0x76,0x65,0x6C,0x3A,0x25,0x66,0x20,0x5B
	.DB  0x76,0x5D,0xD,0xA,0x0,0x52,0x65,0x6C
	.DB  0x61,0x74,0x65,0x64,0x20,0x50,0x68,0x61
	.DB  0x73,0x65,0x20,0x56,0x61,0x6C,0x75,0x65
	.DB  0x31,0x3A,0x25,0x64,0xD,0xA,0x0,0x4D
	.DB  0x75,0x78,0x63,0x68,0x61,0x6E,0x65,0x6C
	.DB  0x20,0x36,0x20,0x44,0x65,0x6D,0x6F,0x64
	.DB  0x75,0x6C,0x61,0x74,0x6F,0x72,0x20,0x56
	.DB  0x6F,0x6C,0x74,0x61,0x67,0x65,0x20,0x4C
	.DB  0x65,0x76,0x65,0x6C,0x3A,0x25,0x66,0x20
	.DB  0x5B,0x76,0x5D,0xD,0xA,0x0,0x4D,0x75
	.DB  0x78,0x63,0x68,0x61,0x6E,0x65,0x6C,0x20
	.DB  0x37,0x20,0x44,0x65,0x6D,0x6F,0x64,0x75
	.DB  0x6C,0x61,0x74,0x6F,0x72,0x20,0x56,0x6F
	.DB  0x6C,0x74,0x61,0x67,0x65,0x20,0x4C,0x65
	.DB  0x76,0x65,0x6C,0x3A,0x25,0x66,0x20,0x5B
	.DB  0x76,0x5D,0xD,0xA,0x0,0x4D,0x75,0x78
	.DB  0x63,0x68,0x61,0x6E,0x65,0x6C,0x20,0x38
	.DB  0x20,0x44,0x65,0x6D,0x6F,0x64,0x75,0x6C
	.DB  0x61,0x74,0x6F,0x72,0x20,0x56,0x6F,0x6C
	.DB  0x74,0x61,0x67,0x65,0x20,0x4C,0x65,0x76
	.DB  0x65,0x6C,0x3A,0x25,0x66,0x20,0x5B,0x76
	.DB  0x5D,0xD,0xA,0x0,0x53,0x74,0x61,0x72
	.DB  0x74,0xD,0xA,0x0,0x5A,0x3A,0x25,0x66
	.DB  0x5B,0x4F,0x68,0x6D,0x73,0x5D,0x9,0x0
	.DB  0x56,0x67,0x3A,0x25,0x66,0x5B,0x56,0x5D
	.DB  0x9,0x0,0x56,0x67,0x20,0x70,0x68,0x61
	.DB  0x73,0x65,0x3A,0x25,0x66,0x9,0x0,0x56
	.DB  0x72,0x3A,0x25,0x66,0x5B,0x56,0x5D,0x9
	.DB  0x0,0x56,0x72,0x20,0x70,0x68,0x61,0x73
	.DB  0x65,0x3A,0x25,0x66,0x9,0x0,0x43,0x70
	.DB  0x3A,0x25,0x66,0x5B,0x70,0x46,0x5D,0x9
	.DB  0x0,0x50,0x65,0x72,0x6D,0x69,0x74,0x69
	.DB  0x76,0x69,0x74,0x79,0x3A,0x25,0x66,0xD
	.DB  0xA,0x0,0x53,0x74,0x6F,0x70,0xD,0xA
	.DB  0x0,0x43,0x73,0x3A,0x25,0x66,0x5B,0x70
	.DB  0x46,0x5D,0x9,0x0,0x63,0x68,0x61,0x6B
	.DB  0x69,0x6E,0x67,0x20,0x66,0x6F,0x72,0x20
	.DB  0x64,0x61,0x74,0x61,0x20,0x74,0x6F,0x20
	.DB  0x75,0x73,0x62,0x0,0x54,0x69,0x6D,0x65
	.DB  0x5B,0x73,0x65,0x63,0x5D,0x9,0x50,0x72
	.DB  0x65,0x73,0x73,0x5B,0x72,0x61,0x77,0x5D
	.DB  0x3B,0x5B,0x70,0x73,0x69,0x61,0x5D,0x9
	.DB  0x54,0x65,0x6D,0x70,0x5B,0x72,0x61,0x77
	.DB  0x5D,0x3B,0x5B,0x43,0x20,0x78,0x20,0x30
	.DB  0x2E,0x30,0x31,0x5D,0x9,0x42,0x61,0x74
	.DB  0x74,0x5B,0x72,0x61,0x77,0x5D,0x3B,0x5B
	.DB  0x6D,0x56,0x5D,0x9,0x41,0x56,0x64,0x64
	.DB  0x5B,0x72,0x61,0x77,0x5D,0x3B,0x5B,0x6D
	.DB  0x56,0x5D,0xD,0xA,0x0
_0x20003:
	.DB  LOW(_0x20000*2),HIGH(_0x20000*2),LOW(_0x20000*2+8),HIGH(_0x20000*2+8),LOW(_0x20000*2+12),HIGH(_0x20000*2+12),LOW(_0x20000*2+17),HIGH(_0x20000*2+17)
	.DB  LOW(_0x20000*2+21),HIGH(_0x20000*2+21),LOW(_0x20000*2+25),HIGH(_0x20000*2+25),LOW(_0x20000*2+29),HIGH(_0x20000*2+29),LOW(_0x20000*2+33),HIGH(_0x20000*2+33)
_0x20000:
	.DB  0x4E,0x4F,0x5F,0x43,0x4F,0x4D,0x31,0x0
	.DB  0x69,0x6E,0x66,0x0,0x73,0x63,0x61,0x6E
	.DB  0x0,0x57,0x47,0x46,0x0,0x57,0x47,0x50
	.DB  0x0,0x41,0x44,0x43,0x0,0x4D,0x55,0x58
	.DB  0x0,0x50,0x45,0x52,0x4D,0x0,0x43,0x6F
	.DB  0x6D,0x6D,0x61,0x6E,0x64,0x73,0x3A,0x20
	.DB  0x0,0x2C,0x20,0x0,0xD,0xA,0x0,0x40
	.DB  0x25,0x73,0xD,0xA,0x0,0x43,0x6F,0x6D
	.DB  0x6D,0x61,0x6E,0x64,0x20,0x6E,0x6F,0x74
	.DB  0x20,0x66,0x6F,0x75,0x6E,0x64,0xD,0xA
	.DB  0x0,0x2D,0x3E,0x3F,0x3F,0x3A,0x20,0x27
	.DB  0x25,0x73,0x27,0xD,0xA,0x0
_0x6002C:
	.DB  0xA,0xD7,0xA3,0x3D,0xC6,0x16,0x82,0x3B
	.DB  0xA6,0x9B,0x44,0x3B,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x7C,0xBD,0xE0,0x2D,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x7A,0x44
	.DB  0x0,0x0,0x0,0x0
_0x60000:
	.DB  0x76,0x61,0x6C,0x75,0x65,0x20,0x6F,0x66
	.DB  0x20,0x49,0x6D,0x70,0x65,0x64,0x61,0x6E
	.DB  0x63,0x65,0x20,0x28,0x5A,0x29,0x3A,0x20
	.DB  0x25,0x66,0x5B,0x4F,0x68,0x6D,0x73,0x5D
	.DB  0xD,0xA,0x0,0x6C,0x65,0x76,0x65,0x6C
	.DB  0x20,0x6F,0x66,0x20,0x65,0x78,0x63,0x69
	.DB  0x74,0x61,0x74,0x69,0x6F,0x6E,0x20,0x73
	.DB  0x69,0x67,0x6E,0x61,0x6C,0x20,0x28,0x56
	.DB  0x67,0x29,0x3A,0x20,0x25,0x66,0x5B,0x56
	.DB  0x5D,0xD,0xA,0x0,0x6C,0x65,0x76,0x65
	.DB  0x6C,0x20,0x6F,0x66,0x20,0x72,0x65,0x74
	.DB  0x75,0x72,0x6E,0x20,0x73,0x69,0x67,0x6E
	.DB  0x61,0x6C,0x20,0x28,0x56,0x72,0x29,0x3A
	.DB  0x20,0x25,0x66,0x5B,0x56,0x5D,0xD,0xA
	.DB  0x0,0x76,0x61,0x6C,0x75,0x65,0x20,0x6F
	.DB  0x66,0x20,0x54,0x68,0x65,0x74,0x61,0x3A
	.DB  0x20,0x25,0x66,0xD,0xA,0x0,0x76,0x61
	.DB  0x6C,0x75,0x65,0x20,0x6F,0x66,0x20,0x44
	.DB  0x65,0x6C,0x74,0x61,0x3A,0x20,0x25,0x66
	.DB  0xD,0xA,0x0,0x76,0x61,0x6C,0x75,0x65
	.DB  0x20,0x6F,0x66,0x20,0x4F,0x6D,0x65,0x67
	.DB  0x61,0x3A,0x20,0x25,0x66,0xD,0xA,0x0
	.DB  0x76,0x61,0x6C,0x75,0x65,0x20,0x6F,0x66
	.DB  0x20,0x52,0x65,0x61,0x63,0x74,0x61,0x6E
	.DB  0x63,0x65,0x28,0x58,0x63,0x29,0x3A,0x20
	.DB  0x25,0x66,0xD,0xA,0x0,0x76,0x61,0x6C
	.DB  0x75,0x65,0x20,0x6F,0x66,0x20,0x53,0x65
	.DB  0x72,0x69,0x61,0x6C,0x20,0x52,0x65,0x73
	.DB  0x69,0x73,0x74,0x61,0x6E,0x63,0x65,0x28
	.DB  0x52,0x73,0x29,0x3A,0x20,0x25,0x66,0x5B
	.DB  0x4F,0x68,0x6D,0x73,0x5D,0xD,0xA,0x0
	.DB  0x76,0x61,0x6C,0x75,0x65,0x20,0x6F,0x66
	.DB  0x20,0x53,0x65,0x72,0x69,0x61,0x6C,0x20
	.DB  0x43,0x61,0x70,0x61,0x63,0x69,0x74,0x61
	.DB  0x6E,0x63,0x65,0x28,0x43,0x73,0x29,0x3A
	.DB  0x20,0x25,0x66,0x5B,0x70,0x46,0x5D,0xD
	.DB  0xA,0x0,0x76,0x61,0x6C,0x75,0x65,0x20
	.DB  0x6F,0x66,0x20,0x50,0x61,0x72,0x61,0x6C
	.DB  0x6C,0x65,0x6C,0x20,0x52,0x65,0x73,0x69
	.DB  0x73,0x74,0x61,0x6E,0x63,0x65,0x28,0x52
	.DB  0x70,0x29,0x3A,0x20,0x25,0x66,0x5B,0x4F
	.DB  0x68,0x6D,0x73,0x5D,0xD,0xA,0x0,0x76
	.DB  0x61,0x6C,0x75,0x65,0x20,0x6F,0x66,0x20
	.DB  0x50,0x61,0x72,0x61,0x6C,0x6C,0x65,0x6C
	.DB  0x20,0x43,0x61,0x70,0x61,0x63,0x69,0x74
	.DB  0x61,0x6E,0x63,0x65,0x28,0x43,0x70,0x29
	.DB  0x3A,0x20,0x25,0x66,0x5B,0x70,0x46,0x5D
	.DB  0xD,0xA,0x0,0x76,0x61,0x6C,0x75,0x65
	.DB  0x20,0x6F,0x66,0x20,0x50,0x65,0x72,0x6D
	.DB  0x69,0x74,0x69,0x76,0x69,0x74,0x79,0x20
	.DB  0x66,0x6F,0x72,0x20,0x53,0x65,0x72,0x69
	.DB  0x61,0x6C,0x20,0x4D,0x6F,0x64,0x65,0x6C
	.DB  0x3A,0x20,0x25,0x66,0xD,0xA,0x0,0x76
	.DB  0x61,0x6C,0x75,0x65,0x20,0x6F,0x66,0x20
	.DB  0x50,0x65,0x72,0x6D,0x69,0x74,0x69,0x76
	.DB  0x69,0x74,0x79,0x20,0x66,0x6F,0x72,0x20
	.DB  0x50,0x61,0x72,0x61,0x6C,0x6C,0x65,0x6C
	.DB  0x20,0x4D,0x6F,0x64,0x65,0x6C,0x3A,0x20
	.DB  0x25,0x66,0xD,0xA,0x0,0x76,0x61,0x6C
	.DB  0x75,0x65,0x20,0x6F,0x66,0x20,0x43,0x6F
	.DB  0x6E,0x64,0x75,0x63,0x74,0x69,0x76,0x69
	.DB  0x74,0x79,0x3A,0x20,0x25,0x66,0x5B,0x6D
	.DB  0x53,0x2F,0x6D,0x5D,0xD,0xA,0x0
_0x2000000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0
_0x202005F:
	.DB  0x1
_0x2020000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x01
	.DW  _WaveFreq
	.DW  _0x3*2

	.DW  0x01
	.DW  _flag
	.DW  _0x4*2

	.DW  0x01
	.DW  _status
	.DW  _0x5*2

	.DW  0x01
	.DW  _Param
	.DW  _0x6*2

	.DW  0x10
	.DW  _cmdList
	.DW  _0x20003*2

	.DW  0x01
	.DW  __seed_G101
	.DW  _0x202005F*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x800)
	LDI  R25,HIGH(0x800)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x85F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x85F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x260)
	LDI  R29,HIGH(0x260)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x260

	.CSEG
;
;     /*****************************************************
;    Project : TurboPVT2_Perm
;    Version : 1.0A
;    Date    : 29.05.2012
;    Author  : Lars Ole Espeland
;    Company : Expro Fluids
;    Comments:
;
;
;    Chip type           : ATmega32
;    Program type        : Application
;    Clock frequency     : 16.0000 MHz
;    Memory model        : Small
;    External RAM size   : 0
;    Data Stack size     : 512
;    *****************************************************/
;
;    #include <MEGA32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;    #include <main.h>
;    #include <interface.h>
;    #include <stdio.h>
;    #include <stdlib.h>
;    #include <math.h>
;    #include <delay.h>
;    #include <sleep.h>
;    #include <stdint.h>
;    #include <io.h>
;
;    #define JTD 7
;//    #define SEL
;//    #define STAGEA
;//    #define STAGEB
;
;    // GLOBAL VARIABLES
;
; //  unsigned int i;
;    unsigned char statusreg,Id;
;    unsigned int value,value1, mode, conf, adc,RawData, WaveFreq=125,WavePhase;

	.DSEG
;    unsigned int RawData;
;    float v,v1,Vr,Vg,v5,v6,v7,Analog_Voltage,v2;
;    int m,n,Newvalue1,Phase7,Phase6,Phase5,Phase,Newvalue;
;
;
;
;    //Timer
;    unsigned long unixTime = 0;
;   //  unsigned int ms = 0;
;    unsigned char now = 0;
;    unsigned int logInt = 0;
;    unsigned char flag = 1;
;  //  unsigned int delay = 125;
;
;    //Status
;   // unsigned char state = 0;
;    unsigned char debug = 0;
;    unsigned int status = 0x0010;
;
;    //Measured
;//    char adcStatus;
;//    char adcStatus1;
;//    unsigned int adcMode;
;//    unsigned int adcConfig;
;//    unsigned char adcId;
;//    unsigned int battVoltRaw;
;//    unsigned int battVolt;
;//    unsigned int analogVoltRaw;
;//    unsigned int analogVolt;
;//    unsigned int tempRaw;
;//    unsigned int temp;
;//    unsigned int pressRaw;
;//    unsigned int press = 0;
;//     unsigned int data;
;
;    unsigned int vcc;
;    unsigned int analogVoltPos;
;    unsigned int analogVoltNeg;
;    unsigned int supplyVoltage;
;
;    //Flash
;//    char manufId;
;//    char memType;
;//    char memCap;
;
;    //External variables
;    unsigned char Command;
;    //ADC, stage1, stage2;
;    unsigned int  Param=125;
;    extern unsigned char rx_counter0;
;
;    //Read microcontroller ADC
;    unsigned int ReadMcAdc(unsigned char adcInput)
; 0000 005D     {

	.CSEG
_ReadMcAdc:
; 0000 005E 
; 0000 005F     ADMUX=adcInput | (ADC_VREF_TYPE & 0xff);
;	adcInput -> Y+0
	LD   R30,Y
	ORI  R30,LOW(0xC0)
	OUT  0x7,R30
; 0000 0060     // Delay needed for the stabilization of the ADC input voltage
; 0000 0061     delay_us(10);
	__DELAY_USB 53
; 0000 0062     // Start the AD conversion
; 0000 0063     ADCSRA|=0x40;
	SBI  0x6,6
; 0000 0064     // Wait for the AD conversion to complete
; 0000 0065     while ((ADCSRA & 0x10)==0);
_0x7:
	SBIS 0x6,4
	RJMP _0x7
; 0000 0066     ADCSRA|=0x10;
	SBI  0x6,4
; 0000 0067     return ADCW;
	IN   R30,0x4
	IN   R31,0x4+1
	ADIW R28,1
	RET
; 0000 0068     }
;
;    //Initialize registers
;    void init(void){
; 0000 006B void init(void){
_init:
; 0000 006C 
; 0000 006D     #asm("cli");        //Disable global interrupt
	cli
; 0000 006E 
; 0000 006F     // Input/Output Ports initialization
; 0000 0070     // Port B initialization
; 0000 0071 
; 0000 0072     // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0073     // PORTB=(0<<PB0)|(0<<PB1)|(0<<PB2)|(0<<PB3)|(0<<PB4)|(0<<PB5)|(0<<PB6)|(0<<PB7);
; 0000 0074     PORTB=0x04;
	LDI  R30,LOW(4)
	OUT  0x18,R30
; 0000 0075     // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=Out Func0=Out
; 0000 0076     DDRB=0xBF;
	LDI  R30,LOW(191)
	OUT  0x17,R30
; 0000 0077 
; 0000 0078     // Port C initialization
; 0000 0079     // Func7=out Func6=Out Func5=In Func4=In Func3=In Func2=In Func1=Out Func0=Out
; 0000 007A     // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 007B     PORTC=0x40;
	LDI  R30,LOW(64)
	OUT  0x15,R30
; 0000 007C     DDRC=0xC3;
	LDI  R30,LOW(195)
	OUT  0x14,R30
; 0000 007D 
; 0000 007E 
; 0000 007F     // Port D initialization
; 0000 0080 
; 0000 0081     // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0082     PORTD=0xD4;
	LDI  R30,LOW(212)
	OUT  0x12,R30
; 0000 0083     // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=In Func0=In
; 0000 0084     DDRD=0xFC;
	LDI  R30,LOW(252)
	OUT  0x11,R30
; 0000 0085 
; 0000 0086     // USART initialization
; 0000 0087     // Communication Parameters: 8 Data, 1 Stop, No Parity
; 0000 0088     // USART Receiver: On
; 0000 0089     // USART Transmitter: On
; 0000 008A     // USART0 Mode: Asynchronous
; 0000 008B     // USART Baud Rate: 38400
; 0000 008C     UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
; 0000 008D     UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
; 0000 008E     UBRRL=0x19;
	LDI  R30,LOW(25)
	OUT  0x9,R30
; 0000 008F     UCSRA=0x00;
	LDI  R30,LOW(0)
	OUT  0xB,R30
; 0000 0090     UCSRB=0xD8;
	LDI  R30,LOW(216)
	OUT  0xA,R30
; 0000 0091     //UCSRC=0x86;
; 0000 0092 
; 0000 0093 
; 0000 0094     // ADC initialization
; 0000 0095     // ADC Clock frequency: 1000 kHz
; 0000 0096     // ADC Voltage Reference: AREF pin
; 0000 0097     // ADC Auto Trigger Source: None
; 0000 0098     // Digital input buffers on ADC0: On, ADC1: On, ADC2: On, ADC3: On
; 0000 0099     // ADC4: On, ADC5: On
; 0000 009A     //DIDR0=0x00;
; 0000 009B     ADMUX=ADC_VREF_TYPE & 0xff;
	LDI  R30,LOW(192)
	OUT  0x7,R30
; 0000 009C     ADCSRA=0x84;
	LDI  R30,LOW(132)
	OUT  0x6,R30
; 0000 009D 
; 0000 009E     // SPI initialisation
; 0000 009F     // SPI clock rate fck/16
; 0000 00A0     // SPI master
; 0000 00A1     // SPI MSB first
; 0000 00A2     // SPI CPOL = 1, CPHA = 1
; 0000 00A3     SPCR=0x5D;
	LDI  R30,LOW(93)
	OUT  0xD,R30
; 0000 00A4     //PORTB.1 = 1;    //Flash CS high
; 0000 00A5     PORTB.3 = 1;    //ADC CS high
	SBI  0x18,3
; 0000 00A6 
; 0000 00A7     //Global enable interrupts
; 0000 00A8     #asm("sei")
	sei
; 0000 00A9     }
	RET
;
;    // Execute commands
;    void runCom(void){
; 0000 00AC void runCom(void){
_runCom:
; 0000 00AD                   unsigned char c1;
; 0000 00AE                   unsigned char c;
; 0000 00AF                   //getchar();
; 0000 00B0         switch(Command){
	ST   -Y,R17
	ST   -Y,R16
;	c1 -> R17
;	c -> R16
	LDS  R30,_Command
; 0000 00B1 
; 0000 00B2             case(NO_COM1):
	CPI  R30,0
	BRNE _0xF
; 0000 00B3                 Command = 0;
	RJMP _0x4D
; 0000 00B4                 break;
; 0000 00B5 
; 0000 00B6             case(inf):
_0xF:
	CPI  R30,LOW(0x1)
	BREQ PC+3
	JMP _0x10
; 0000 00B7                 printf("\r\n\r\n");
	__POINTW1FN _0x0,0
	CALL SUBOPT_0x0
; 0000 00B8                 printf("Petrotech\r\n");
	__POINTW1FN _0x0,5
	CALL SUBOPT_0x0
; 0000 00B9                 printf("TurboPVT2 Permittivity\r\n");
	__POINTW1FN _0x0,17
	CALL SUBOPT_0x0
; 0000 00BA                 printf("Ver. 1.0A\r\n");
	__POINTW1FN _0x0,42
	CALL SUBOPT_0x0
; 0000 00BB                 printf("Compiled: %p %p\r\n",__DATE__,__TIME__);
	__POINTW1FN _0x0,54
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,72
	CALL SUBOPT_0x1
	__POINTW1FN _0x0,84
	CALL SUBOPT_0x1
	LDI  R24,8
	CALL _printf
	ADIW R28,10
; 0000 00BC 
; 0000 00BD                 supplyVoltage = (unsigned int)ReadMcAdc(VIN)*30.6065;               //2.5*12*1.0202
	LDI  R30,LOW(3)
	CALL SUBOPT_0x2
	__GETD2N 0x41F4DA1D
	CALL __MULF12
	LDI  R26,LOW(_supplyVoltage)
	LDI  R27,HIGH(_supplyVoltage)
	CALL SUBOPT_0x3
; 0000 00BE                 printf("Power supply voltage: %u [mV]\r\n", supplyVoltage);
	__POINTW1FN _0x0,93
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_supplyVoltage
	LDS  R31,_supplyVoltage+1
	CALL SUBOPT_0x1
	CALL SUBOPT_0x4
; 0000 00BF                 analogVoltPos = (unsigned int)ReadMcAdc(AVP)*15.16443375;           //2.5*5.99*1.01265
	LDI  R30,LOW(1)
	CALL SUBOPT_0x2
	__GETD2N 0x4172A185
	CALL __MULF12
	LDI  R26,LOW(_analogVoltPos)
	LDI  R27,HIGH(_analogVoltPos)
	CALL SUBOPT_0x3
; 0000 00C0                 analogVoltNeg = (unsigned int)ReadMcAdc(AVN)*27.782;           //2.5*10.99*1.011
	LDI  R30,LOW(2)
	CALL SUBOPT_0x2
	__GETD2N 0x41DE4189
	CALL __MULF12
	LDI  R26,LOW(_analogVoltNeg)
	LDI  R27,HIGH(_analogVoltNeg)
	CALL SUBOPT_0x3
; 0000 00C1                 printf("Positive analog voltage: %u [mV]\tNegative analog voltage: -%u [mV]\r\n", analogVoltPos, analogVoltNeg);
	__POINTW1FN _0x0,125
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_analogVoltPos
	LDS  R31,_analogVoltPos+1
	CALL SUBOPT_0x1
	LDS  R30,_analogVoltNeg
	LDS  R31,_analogVoltNeg+1
	CALL SUBOPT_0x1
	LDI  R24,8
	CALL _printf
	ADIW R28,10
; 0000 00C2                 vcc = (unsigned int)ReadMcAdc(VCC)*6.348375;                        //2.5*2.5*1.01574
	LDI  R30,LOW(0)
	CALL SUBOPT_0x2
	__GETD2N 0x40CB25E3
	CALL __MULF12
	LDI  R26,LOW(_vcc)
	LDI  R27,HIGH(_vcc)
	CALL SUBOPT_0x3
; 0000 00C3                 printf("Digital supply voltage: %u [mV]\r\n", vcc);
	__POINTW1FN _0x0,194
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_vcc
	LDS  R31,_vcc+1
	CALL SUBOPT_0x1
	CALL SUBOPT_0x4
; 0000 00C4                 RawData=readADC();
	CALL SUBOPT_0x5
; 0000 00C5                 printf("ADC RawData:%d\r\n", RawData);
	__POINTW1FN _0x0,228
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x6
	CALL SUBOPT_0x1
	CALL SUBOPT_0x4
; 0000 00C6                 Analog_Voltage = voltage(RawData);
	CALL SUBOPT_0x7
	STS  _Analog_Voltage,R30
	STS  _Analog_Voltage+1,R31
	STS  _Analog_Voltage+2,R22
	STS  _Analog_Voltage+3,R23
; 0000 00C7                 printf("Demodulator Voltage Level:%f [v]\r\n",Analog_Voltage);
	__POINTW1FN _0x0,245
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Analog_Voltage
	LDS  R31,_Analog_Voltage+1
	LDS  R22,_Analog_Voltage+2
	LDS  R23,_Analog_Voltage+3
	CALL SUBOPT_0x8
; 0000 00C8 
; 0000 00C9                 printf("Present wave frequency is setted to:%d\r\n",WaveFreq);
	__POINTW1FN _0x0,280
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x9
	CALL SUBOPT_0x1
	CALL SUBOPT_0x4
; 0000 00CA                 printf("Vr Signal Phase value at maximum voltage :%d\r\n",Newvalue);
	__POINTW1FN _0x0,321
	CALL SUBOPT_0xA
; 0000 00CB                 printf("Vg Signal Phase value at maximum voltage :%d\r\n",Newvalue1);
	__POINTW1FN _0x0,368
	CALL SUBOPT_0xB
; 0000 00CC                // printf("Present wave Phase is setted to:%d\r\n",Newvalue7);
; 0000 00CD 
; 0000 00CE                  if(m == 1)   printf("Mux is setted to:%d",m);
	CALL SUBOPT_0xC
	SBIW R26,1
	BRNE _0x11
	CALL SUBOPT_0xD
; 0000 00CF                  if(m == 2)   printf("Mux is setted to:%d",m);
_0x11:
	CALL SUBOPT_0xC
	SBIW R26,2
	BRNE _0x12
	CALL SUBOPT_0xD
; 0000 00D0                  if(m == 3)   printf("Mux is setted to:%d",m);
_0x12:
	CALL SUBOPT_0xC
	SBIW R26,3
	BRNE _0x13
	CALL SUBOPT_0xD
; 0000 00D1                  if(m == 4)   printf("Mux is setted to:%d",m);
_0x13:
	CALL SUBOPT_0xC
	SBIW R26,4
	BRNE _0x14
	CALL SUBOPT_0xD
; 0000 00D2                  if(m == 5)   printf("Mux is setted to:%d",m);
_0x14:
	CALL SUBOPT_0xC
	SBIW R26,5
	BRNE _0x15
	CALL SUBOPT_0xD
; 0000 00D3                  if(m == 6)   printf("Mux is setted to:%d",m);
_0x15:
	CALL SUBOPT_0xC
	SBIW R26,6
	BRNE _0x16
	CALL SUBOPT_0xD
; 0000 00D4                  if(m == 7)   printf("Mux is setted to:%d",m);
_0x16:
	CALL SUBOPT_0xC
	SBIW R26,7
	BRNE _0x17
	CALL SUBOPT_0xD
; 0000 00D5 
; 0000 00D6                  if(n==1) printf("\r\nAmplification stage 3x selected");
_0x17:
	CALL SUBOPT_0xE
	SBIW R26,1
	BRNE _0x18
	__POINTW1FN _0x0,435
	CALL SUBOPT_0x0
; 0000 00D7                  if(n==2) printf("\r\nAmplification stage 13x selected");
_0x18:
	CALL SUBOPT_0xE
	SBIW R26,2
	BRNE _0x19
	__POINTW1FN _0x0,469
	CALL SUBOPT_0x0
; 0000 00D8                  if(n==3) printf("\r\nAmplification stage 5x selected");
_0x19:
	CALL SUBOPT_0xE
	SBIW R26,3
	BRNE _0x1A
	__POINTW1FN _0x0,504
	CALL SUBOPT_0x0
; 0000 00D9                  if(n==4) printf("\r\nAmplification stage 15x selected");
_0x1A:
	CALL SUBOPT_0xE
	SBIW R26,4
	BRNE _0x1B
	__POINTW1FN _0x0,538
	CALL SUBOPT_0x0
; 0000 00DA                  if(n==5) printf("\r\nDampling stage is selected");
_0x1B:
	CALL SUBOPT_0xE
	SBIW R26,5
	BRNE _0x1C
	__POINTW1FN _0x0,573
	CALL SUBOPT_0x0
; 0000 00DB                  if(n==6) printf("\r\nBypass stage is selected");
_0x1C:
	CALL SUBOPT_0xE
	SBIW R26,6
	BRNE _0x1D
	__POINTW1FN _0x0,602
	CALL SUBOPT_0x0
; 0000 00DC 
; 0000 00DD                 Command = 0;
_0x1D:
	RJMP _0x4D
; 0000 00DE                 break;
; 0000 00DF 
; 0000 00E0             case(scan):
_0x10:
	CPI  R30,LOW(0x2)
	BRNE _0x1E
; 0000 00E1                  while (1)
; 0000 00E2                  {
; 0000 00E3                  continous();
	RCALL _continous
; 0000 00E4                   return;
	RJMP _0x20C0010
; 0000 00E5                  }
; 0000 00E6                   Command = 0;
; 0000 00E7                   break;
; 0000 00E8 
; 0000 00E9             case(WGF):
_0x1E:
	CPI  R30,LOW(0x3)
	BRNE _0x22
; 0000 00EA                   if(Param < 500)
	LDS  R26,_Param
	LDS  R27,_Param+1
	CPI  R26,LOW(0x1F4)
	LDI  R30,HIGH(0x1F4)
	CPC  R27,R30
	BRSH _0x23
; 0000 00EB                     SetWGFreq(Param);
	CALL SUBOPT_0xF
	ST   -Y,R31
	ST   -Y,R30
	CALL _SetWGFreq
; 0000 00EC                     WaveFreq = Param;
_0x23:
	CALL SUBOPT_0xF
	STS  _WaveFreq,R30
	STS  _WaveFreq+1,R31
; 0000 00ED                     Command = 0;
	RJMP _0x4D
; 0000 00EE                   break;
; 0000 00EF 
; 0000 00F0             case(WGP):
_0x22:
	CPI  R30,LOW(0x4)
	BRNE _0x24
; 0000 00F1                   if(Param < 4095)
	LDS  R26,_Param
	LDS  R27,_Param+1
	CPI  R26,LOW(0xFFF)
	LDI  R30,HIGH(0xFFF)
	CPC  R27,R30
	BRSH _0x25
; 0000 00F2                     SetWGPhase1(Param); //shifting the signal with a value.
	CALL SUBOPT_0xF
	ST   -Y,R31
	ST   -Y,R30
	CALL _SetWGPhase1
; 0000 00F3                     WavePhase=Param;
_0x25:
	CALL SUBOPT_0xF
	STS  _WavePhase,R30
	STS  _WavePhase+1,R31
; 0000 00F4                   Command = 0;
	RJMP _0x4D
; 0000 00F5                   break;
; 0000 00F6 
; 0000 00F7             case(ADC):
_0x24:
	CPI  R30,LOW(0x5)
	BREQ PC+3
	JMP _0x26
; 0000 00F8                 // if(Param<3)
; 0000 00F9           printf("Select amplification stage: 1-3x,2-5x,3-13x,4-15x\r\n5-Damping stage\r\n6-Bypass circiut\r\n");
	__POINTW1FN _0x0,629
	CALL SUBOPT_0x0
; 0000 00FA                    c1 = getchar();
	CALL _getchar
	MOV  R17,R30
; 0000 00FB                    switch(c1){
	MOV  R30,R17
; 0000 00FC                             case '1':
	CPI  R30,LOW(0x31)
	BRNE _0x2A
; 0000 00FD                                PORTC=0x43;
	LDI  R30,LOW(67)
	OUT  0x15,R30
; 0000 00FE                                PORTD=0xD4;
	LDI  R30,LOW(212)
	OUT  0x12,R30
; 0000 00FF                                printf("Amplification stage 3x selected\r\n");
	__POINTW1FN _0x0,716
	CALL SUBOPT_0x0
; 0000 0100                                n=1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CALL SUBOPT_0x10
; 0000 0101                                Command = 0;
	RJMP _0x4E
; 0000 0102                                break;
; 0000 0103                             case '2':
_0x2A:
	CPI  R30,LOW(0x32)
	BRNE _0x2B
; 0000 0104                                PORTC=0x40;
	LDI  R30,LOW(64)
	OUT  0x15,R30
; 0000 0105                                PORTD=0xD4;
	LDI  R30,LOW(212)
	OUT  0x12,R30
; 0000 0106                                printf("Amplification stage 5x selected\r\n");
	__POINTW1FN _0x0,750
	CALL SUBOPT_0x0
; 0000 0107                                n=2;
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL SUBOPT_0x10
; 0000 0108                                Command = 0;
	RJMP _0x4E
; 0000 0109                                break;
; 0000 010A                             case '3':
_0x2B:
	CPI  R30,LOW(0x33)
	BRNE _0x2C
; 0000 010B                                PORTC=0x42;
	LDI  R30,LOW(66)
	OUT  0x15,R30
; 0000 010C                                PORTD=0x14;
	LDI  R30,LOW(20)
	OUT  0x12,R30
; 0000 010D                                printf("Amplification stage 13x selected\r\n");
	__POINTW1FN _0x0,784
	CALL SUBOPT_0x0
; 0000 010E                                n=3;
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	CALL SUBOPT_0x10
; 0000 010F                                Command = 0;
	RJMP _0x4E
; 0000 0110                                break;
; 0000 0111                             case '4':
_0x2C:
	CPI  R30,LOW(0x34)
	BRNE _0x2D
; 0000 0112                                PORTC=0x40;
	LDI  R30,LOW(64)
	OUT  0x15,R30
; 0000 0113                                PORTD=0x14;
	LDI  R30,LOW(20)
	OUT  0x12,R30
; 0000 0114                                printf("Amplification stage 15x selected\r\n");
	__POINTW1FN _0x0,819
	CALL SUBOPT_0x0
; 0000 0115                                n=4;
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	CALL SUBOPT_0x10
; 0000 0116                                Command = 0;
	RJMP _0x4E
; 0000 0117                                break;
; 0000 0118                             case '5':
_0x2D:
	CPI  R30,LOW(0x35)
	BRNE _0x2E
; 0000 0119                                PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0000 011A                                PORTD=0x14;
	LDI  R30,LOW(20)
	OUT  0x12,R30
; 0000 011B                                printf("Damping stage selected\r\n");
	__POINTW1FN _0x0,854
	CALL SUBOPT_0x0
; 0000 011C                                n=5;
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	CALL SUBOPT_0x10
; 0000 011D                                Command = 0;
	RJMP _0x4E
; 0000 011E                                break;
; 0000 011F                             case '6':
_0x2E:
	CPI  R30,LOW(0x36)
	BRNE _0x30
; 0000 0120                                PORTC=0x01;
	LDI  R30,LOW(1)
	OUT  0x15,R30
; 0000 0121                                PORTD=0x14;
	LDI  R30,LOW(20)
	OUT  0x12,R30
; 0000 0122                                printf("Bypass circuit selected\r\n");
	__POINTW1FN _0x0,879
	CALL SUBOPT_0x0
; 0000 0123                                n=6;
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	CALL SUBOPT_0x10
; 0000 0124                                Command = 0;
; 0000 0125                                break;
; 0000 0126                             default:
_0x30:
; 0000 0127                                Command = 0;
_0x4E:
	LDI  R30,LOW(0)
	STS  _Command,R30
; 0000 0128                                break;
; 0000 0129                              }
; 0000 012A                  Command = 0;
	RJMP _0x4D
; 0000 012B                  break;
; 0000 012C             case(MUX):
_0x26:
	CPI  R30,LOW(0x6)
	BREQ PC+3
	JMP _0x31
; 0000 012D 
; 0000 012E                  c = getchar();
	RCALL _getchar
	MOV  R16,R30
; 0000 012F                  //getchar();
; 0000 0130                    switch(c){
	MOV  R30,R16
; 0000 0131 
; 0000 0132                          case '1':
	CPI  R30,LOW(0x31)
	BRNE _0x35
; 0000 0133                             PORTB=0x00;
	LDI  R30,LOW(0)
	CALL SUBOPT_0x11
; 0000 0134                             phaseshift(&v, &Phase);
; 0000 0135                             Vg=v;
; 0000 0136                             printf("Muxchanel 1 Demodulator Voltage Level:%f [v]\r\n",Vg);
	__POINTW1FN _0x0,905
	CALL SUBOPT_0x12
; 0000 0137                             Newvalue1=Phase;
	CALL SUBOPT_0x13
; 0000 0138                             printf("Related Phase Value:%d\r\n",Newvalue1);
; 0000 0139                             m = 1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CALL SUBOPT_0x14
; 0000 013A                             Command = 0;
	RJMP _0x4F
; 0000 013B                             break;
; 0000 013C 
; 0000 013D                          case '2':
_0x35:
	CPI  R30,LOW(0x32)
	BRNE _0x36
; 0000 013E                             PORTB=0x04;
	CALL SUBOPT_0x15
; 0000 013F                             delay_ms(100);
; 0000 0140                             phaseshift(&v, &Phase);
; 0000 0141                             v2=v;
; 0000 0142                             v2=v2*3;
; 0000 0143                             Vg=v2;
; 0000 0144                             printf("Muxchanel 2 Demodulator Voltage Level:%f [v]\r\n",Vg);
	__POINTW1FN _0x0,977
	CALL SUBOPT_0x12
; 0000 0145                             Newvalue1=Phase;
	CALL SUBOPT_0x13
; 0000 0146                             printf("Related Phase Value:%d\r\n",Newvalue1);
; 0000 0147                             m = 2;
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL SUBOPT_0x14
; 0000 0148                             Command = 0;
	RJMP _0x4F
; 0000 0149                             break;
; 0000 014A 
; 0000 014B                          case '3':
_0x36:
	CPI  R30,LOW(0x33)
	BRNE _0x37
; 0000 014C                             PORTB=0x02;
	LDI  R30,LOW(2)
	CALL SUBOPT_0x11
; 0000 014D                             phaseshift(&v, &Phase);
; 0000 014E                             Vg=v;
; 0000 014F                             printf("Muxchanel 3 Demodulator Voltage Level:%f [v]\r\n",Vg);
	__POINTW1FN _0x0,1024
	CALL SUBOPT_0x12
; 0000 0150                             Newvalue1=Phase;
	CALL SUBOPT_0x13
; 0000 0151                             printf("Related Phase Value:%d\r\n",Newvalue1);
; 0000 0152                             m = 3;
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	CALL SUBOPT_0x14
; 0000 0153                             Command = 0;
	RJMP _0x4F
; 0000 0154                             break;
; 0000 0155 
; 0000 0156                          case '4':
_0x37:
	CPI  R30,LOW(0x34)
	BRNE _0x38
; 0000 0157                             PORTB=0x06;
	LDI  R30,LOW(6)
	CALL SUBOPT_0x11
; 0000 0158                             phaseshift(&v, &Phase);
; 0000 0159                             Vg=v;
; 0000 015A                             printf("Muxchanel 4 Demodulator Voltage Level:%f [v]\r\n",Vg);
	__POINTW1FN _0x0,1071
	CALL SUBOPT_0x12
; 0000 015B                             Newvalue1=Phase;
	CALL SUBOPT_0x13
; 0000 015C                             printf("Related Phase Value:%d\r\n",Newvalue1);
; 0000 015D                             m = 4;
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	CALL SUBOPT_0x14
; 0000 015E                             Command = 0;
	RJMP _0x4F
; 0000 015F                             break;
; 0000 0160 
; 0000 0161                          case '5':
_0x38:
	CPI  R30,LOW(0x35)
	BREQ PC+3
	JMP _0x39
; 0000 0162                             PORTB=0x01;
	LDI  R30,LOW(1)
	CALL SUBOPT_0x16
; 0000 0163                             delay_ms(100);
; 0000 0164                             phaseshift(&v, &Phase);
; 0000 0165                             v5=v;
	CALL SUBOPT_0x17
; 0000 0166                             v5=v5*3;
	LDS  R26,_v5
	LDS  R27,_v5+1
	LDS  R24,_v5+2
	LDS  R25,_v5+3
	CALL SUBOPT_0x18
	CALL SUBOPT_0x17
; 0000 0167                             Vr=v5;
	LDS  R30,_v5
	LDS  R31,_v5+1
	LDS  R22,_v5+2
	LDS  R23,_v5+3
	CALL SUBOPT_0x19
; 0000 0168                             printf("Muxchanel 5 Demodulator Voltage Level:%f [v]\r\n",Vr);
	__POINTW1FN _0x0,1118
	CALL SUBOPT_0x1A
; 0000 0169                             // printf("Related Phase Value:%d\r\n",Phase);
; 0000 016A                             Phase5=Phase;
	CALL SUBOPT_0x1B
	STS  _Phase5,R30
	STS  _Phase5+1,R31
; 0000 016B                             printf("Related Phase Value:%d\r\n",Phase5);
	CALL SUBOPT_0x1C
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x1E
; 0000 016C                             Phase5=(Phase5+0);
	CALL SUBOPT_0x1D
	ADIW R30,0
	STS  _Phase5,R30
	STS  _Phase5+1,R31
; 0000 016D                             Newvalue=Phase5;
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x1F
; 0000 016E                             printf("Related Phase Value1:%d\r\n",Newvalue);
	__POINTW1FN _0x0,1165
	CALL SUBOPT_0xA
; 0000 016F                             m = 5;
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	CALL SUBOPT_0x14
; 0000 0170                             Command = 0;
	RJMP _0x4F
; 0000 0171                             break;
; 0000 0172 
; 0000 0173                          case '6':
_0x39:
	CPI  R30,LOW(0x36)
	BRNE _0x3A
; 0000 0174                             PORTB=0x05;
	LDI  R30,LOW(5)
	CALL SUBOPT_0x16
; 0000 0175                             delay_ms(100);
; 0000 0176                             phaseshift(&v, &Phase);
; 0000 0177                             v6=v;
	CALL SUBOPT_0x20
; 0000 0178                             v6=(v6*3)/5.3548;
	CALL SUBOPT_0x21
	CALL SUBOPT_0x22
; 0000 0179                             Vr=v6;
; 0000 017A                             printf("Muxchanel 6 Demodulator Voltage Level:%f [v]\r\n",Vr);
	__POINTW1FN _0x0,1191
	CALL SUBOPT_0x1A
; 0000 017B                             //printf("Related Phase Value:%d\r\n",Phase);
; 0000 017C                             Phase6=Phase;
	CALL SUBOPT_0x23
; 0000 017D                             printf("Related Phase Value:%d\r\n",Phase6);
	CALL SUBOPT_0x1C
	CALL SUBOPT_0x24
	CALL SUBOPT_0x1E
; 0000 017E                             Phase6=(Phase6-50);
	CALL SUBOPT_0x25
; 0000 017F                             Newvalue=Phase6;
; 0000 0180                             printf("Related Phase Value:%d\r\n",Newvalue);
	__POINTW1FN _0x0,952
	CALL SUBOPT_0xA
; 0000 0181                             m = 6;
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	CALL SUBOPT_0x14
; 0000 0182                             Command = 0;
	RJMP _0x4F
; 0000 0183                             break;
; 0000 0184 
; 0000 0185                          case '7':
_0x3A:
	CPI  R30,LOW(0x37)
	BREQ PC+3
	JMP _0x3B
; 0000 0186                             PORTB=0x03;
	LDI  R30,LOW(3)
	CALL SUBOPT_0x16
; 0000 0187                             delay_ms(100);
; 0000 0188                             phaseshift(&v, &Phase);
; 0000 0189                             v7=v;
	CALL SUBOPT_0x26
; 0000 018A                             v7=(v7*3)/28.53;
	LDS  R26,_v7
	LDS  R27,_v7+1
	LDS  R24,_v7+2
	LDS  R25,_v7+3
	CALL SUBOPT_0x18
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x41E43D71
	CALL __DIVF21
	CALL SUBOPT_0x26
; 0000 018B                             Vr=v7;
	LDS  R30,_v7
	LDS  R31,_v7+1
	LDS  R22,_v7+2
	LDS  R23,_v7+3
	CALL SUBOPT_0x19
; 0000 018C                             printf("Muxchanel 7 Demodulator Voltage Level:%f [v]\r\n",Vr);
	__POINTW1FN _0x0,1238
	CALL SUBOPT_0x1A
; 0000 018D                             //printf("Related Phase Value:%d\r\n",Phase);
; 0000 018E                             Phase7=Phase;
	CALL SUBOPT_0x1B
	STS  _Phase7,R30
	STS  _Phase7+1,R31
; 0000 018F                             printf("Related Phase Value:%d\r\n",Phase7);
	CALL SUBOPT_0x1C
	CALL SUBOPT_0x27
	CALL SUBOPT_0x1E
; 0000 0190                             Phase7=(Phase7-240);
	CALL SUBOPT_0x27
	SUBI R30,LOW(240)
	SBCI R31,HIGH(240)
	STS  _Phase7,R30
	STS  _Phase7+1,R31
; 0000 0191                             Newvalue=Phase7;
	CALL SUBOPT_0x27
	CALL SUBOPT_0x1F
; 0000 0192                             printf("Related Phase Value:%d\r\n",Newvalue);
	__POINTW1FN _0x0,952
	CALL SUBOPT_0xA
; 0000 0193                             m = 7;
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	CALL SUBOPT_0x14
; 0000 0194                             Command = 0;
	RJMP _0x4F
; 0000 0195                             break;
; 0000 0196                          case '8':
_0x3B:
	CPI  R30,LOW(0x38)
	BRNE _0x3D
; 0000 0197                             PORTB=0x04;
	LDI  R30,LOW(4)
	OUT  0x18,R30
; 0000 0198                             //phaseshift1(&v, &Phase);
; 0000 0199                             RawData = readADC();
	CALL SUBOPT_0x5
; 0000 019A                             v2 = voltage(RawData);
	CALL SUBOPT_0x7
	CALL SUBOPT_0x28
; 0000 019B                             v2=(v2*3);
	LDS  R26,_v2
	LDS  R27,_v2+1
	LDS  R24,_v2+2
	LDS  R25,_v2+3
	CALL SUBOPT_0x18
	CALL SUBOPT_0x28
; 0000 019C                            // v2=(v2*3)/5.3548;
; 0000 019D                             Vr=v2;
	LDS  R30,_v2
	LDS  R31,_v2+1
	LDS  R22,_v2+2
	LDS  R23,_v2+3
	CALL SUBOPT_0x19
; 0000 019E                             printf("Muxchanel 8 Demodulator Voltage Level:%f [v]\r\n",Vr);
	__POINTW1FN _0x0,1285
	CALL SUBOPT_0x1A
; 0000 019F                             //Newvalue=Phase;
; 0000 01A0                             printf("Related Phase Value:%d\r\n",WavePhase);
	CALL SUBOPT_0x1C
	LDS  R30,_WavePhase
	LDS  R31,_WavePhase+1
	CALL SUBOPT_0x1
	CALL SUBOPT_0x4
; 0000 01A1                             m=8;
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	CALL SUBOPT_0x14
; 0000 01A2                             Command = 0;
; 0000 01A3                             break;
; 0000 01A4 
; 0000 01A5                          default:
_0x3D:
; 0000 01A6                             Command = 0;
_0x4F:
	LDI  R30,LOW(0)
	STS  _Command,R30
; 0000 01A7                             break;
; 0000 01A8 
; 0000 01A9                           }
; 0000 01AA                  Command = 0;
	RJMP _0x4D
; 0000 01AB                  break;
; 0000 01AC             case(PERM):
_0x31:
	CPI  R30,LOW(0x7)
	BRNE _0x3F
; 0000 01AD                 Permitivity();
	CALL _Permitivity
; 0000 01AE                  Command = 0;
; 0000 01AF                  break;
; 0000 01B0 
; 0000 01B1             default:
_0x3F:
; 0000 01B2                  Command = 0;
_0x4D:
	LDI  R30,LOW(0)
	STS  _Command,R30
; 0000 01B3                  break;
; 0000 01B4         }
; 0000 01B5     }
_0x20C0010:
	LD   R16,Y+
	LD   R17,Y+
	RET
;
; unsigned int continous(void){
; 0000 01B7 unsigned int continous(void){
_continous:
; 0000 01B8 
; 0000 01B9    float Z=0.0F, R=1000.0F,Cp,Cs,theta,theta1,delta,delta1,W,Xcs,C0=25.55E-12,Erp,Ers;
; 0000 01BA    float pi,Cs1,Cp1;
; 0000 01BB    pi = 4.0*atan(1.0);
	SBIW R28,63
	SBIW R28,1
	LDI  R24,44
	LDI  R26,LOW(20)
	LDI  R27,HIGH(20)
	LDI  R30,LOW(_0x40*2)
	LDI  R31,HIGH(_0x40*2)
	CALL __INITLOCB
;	Z -> Y+60
;	R -> Y+56
;	Cp -> Y+52
;	Cs -> Y+48
;	theta -> Y+44
;	theta1 -> Y+40
;	delta -> Y+36
;	delta1 -> Y+32
;	W -> Y+28
;	Xcs -> Y+24
;	C0 -> Y+20
;	Erp -> Y+16
;	Ers -> Y+12
;	pi -> Y+8
;	Cs1 -> Y+4
;	Cp1 -> Y+0
	CALL SUBOPT_0x29
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x2B
; 0000 01BC    printf("Start\r\n");
	__POINTW1FN _0x0,1332
	CALL SUBOPT_0x0
; 0000 01BD    PORTB=0x04;
	CALL SUBOPT_0x15
; 0000 01BE    delay_ms(100);
; 0000 01BF    phaseshift(&v, &Phase);
; 0000 01C0    v2=v;
; 0000 01C1    v2=v2*3;
; 0000 01C2    Vg=v2;
; 0000 01C3    Newvalue1=Phase;
	CALL SUBOPT_0x1B
	STS  _Newvalue1,R30
	STS  _Newvalue1+1,R31
; 0000 01C4 
; 0000 01C5    PORTB=0x05;
	LDI  R30,LOW(5)
	CALL SUBOPT_0x16
; 0000 01C6    delay_ms(100);
; 0000 01C7    phaseshift(&v, &Phase);
; 0000 01C8    v6=v;
	CALL SUBOPT_0x20
; 0000 01C9    v6=(v6*3)/5.3548;
	CALL SUBOPT_0x21
	CALL SUBOPT_0x22
; 0000 01CA    Vr=v6;
; 0000 01CB    Phase6=Phase;
	CALL SUBOPT_0x23
; 0000 01CC    Phase6=(Phase6-50);
	CALL SUBOPT_0x25
; 0000 01CD    Newvalue=Phase6;
; 0000 01CE 
; 0000 01CF      theta=abs(Newvalue1-Newvalue);
	CALL SUBOPT_0x2C
	__PUTD1S 44
; 0000 01D0      theta1= theta/180*pi;
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x2E
	__PUTD1S 40
; 0000 01D1      delta=abs(90-theta);
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x2F
	__PUTD1S 36
; 0000 01D2      delta1= delta/180*pi;
	__GETD2S 36
	CALL SUBOPT_0x2E
	__PUTD1S 32
; 0000 01D3      Z= ((Vg-Vr)/Vr)*R;
	CALL SUBOPT_0x30
	__GETD2S 56
	CALL __MULF12
	__PUTD1S 60
; 0000 01D4      printf("Z:%f[Ohms]\t", Z);
	__POINTW1FN _0x0,1340
	CALL SUBOPT_0x31
; 0000 01D5      printf("Vg:%f[V]\t", Vg);
	__POINTW1FN _0x0,1352
	CALL SUBOPT_0x12
; 0000 01D6      printf("Vg phase:%f\t", Newvalue1);
	__POINTW1FN _0x0,1362
	CALL SUBOPT_0xB
; 0000 01D7      printf("Vr:%f[V]\t",Vr);
	__POINTW1FN _0x0,1375
	CALL SUBOPT_0x1A
; 0000 01D8      printf("Vr phase:%f\t", Newvalue);
	__POINTW1FN _0x0,1385
	CALL SUBOPT_0xA
; 0000 01D9 
; 0000 01DA      W= (2.0*pi*WaveFreq*1000);
	CALL SUBOPT_0x32
	CALL SUBOPT_0x33
	__PUTD1S 28
; 0000 01DB      Xcs= fabs((fabs(Z)* sin(theta1)));
	__GETD1S 60
	CALL SUBOPT_0x34
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD1S 40
	CALL SUBOPT_0x35
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __MULF12
	CALL SUBOPT_0x34
	__PUTD1S 24
; 0000 01DC 
; 0000 01DD      Cs= fabs(1/(W*Xcs));
	__GETD2S 28
	CALL SUBOPT_0x36
	__PUTD1S 48
; 0000 01DE      Cs1= Cs*10E11;
	CALL SUBOPT_0x37
	CALL SUBOPT_0x38
	CALL SUBOPT_0x39
; 0000 01DF      Cp= fabs((Cs/(1+pow(tan(delta1),2))));
	__GETD1S 32
	CALL SUBOPT_0x3A
	CALL SUBOPT_0x3B
	CALL SUBOPT_0x3C
; 0000 01E0      Cp1= Cp*10E11;
	CALL SUBOPT_0x38
	CALL SUBOPT_0x3D
; 0000 01E1      if (Z>=5001){
	CALL SUBOPT_0x3E
	__GETD1N 0x459C4800
	CALL __CMPF12
	BRLO _0x41
; 0000 01E2      printf("Cp:%f[pF]\t", Cp1);
	__POINTW1FN _0x0,1398
	CALL SUBOPT_0x3F
; 0000 01E3      Erp= fabs(Cp/C0);
	CALL SUBOPT_0x40
	__GETD2S 52
	CALL SUBOPT_0x41
	CALL SUBOPT_0x42
; 0000 01E4      printf("Permitivity:%f\r\n", Erp);
	__POINTW1FN _0x0,1409
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 18
	RJMP _0x50
; 0000 01E5      printf("Stop\r\n");
; 0000 01E6      } else   {
_0x41:
; 0000 01E7       printf("Cs:%f[pF]\t", Cs1);
	__POINTW1FN _0x0,1433
	CALL SUBOPT_0x43
; 0000 01E8       Ers= fabs(Cs/C0);
	CALL SUBOPT_0x40
	CALL SUBOPT_0x3B
	CALL SUBOPT_0x44
; 0000 01E9       printf("Permitivity:%f\r\n", Ers);
	__POINTW1FN _0x0,1409
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 14
_0x50:
	CALL __PUTPARD1
	CALL SUBOPT_0x4
; 0000 01EA       printf("Stop\r\n");
	__POINTW1FN _0x0,1426
	CALL SUBOPT_0x0
; 0000 01EB       }
; 0000 01EC      return 0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ADIW R28,63
	ADIW R28,1
	RET
; 0000 01ED  }
;
;
;
;
;
;
;  /*  char *pLong(long num){
;
;        static unsigned char str[16];
;        ltoa(num,str);
;        return str;
;    }*/
;
;    /*
;    void ReadFlashId(void)
;    {
;
;        if(PINB.2){
;            PORTB.1 = 0;
;            while(PINB.1);          //Wait for flash chip select pin to go low
;            //Wait(250);
;            //spi(0x9F);              //Issue read identification instruction
;            spi(0x05);              //Read status register
;            manufId = spi(0xFF);    //Read manufacturer Id byte = 0x20 for STMicroelectronics
;            //memType = spi(0xFF);    //Read memory type byte = 0x20
;            //memCap = spi(0xFF);     //Read memory capacity byte = 0x14
;            PORTB.1 = 1;
;            Wait(10);
;        }
;        else
;            printf("ADC in use, not possible to access flash\r\n");
;    }*/
;
;    void main(void){
; 0000 020F void main(void){
_main:
; 0000 0210 
; 0000 0211             int Flag = 0;
; 0000 0212       status = 0x0010;
;	Flag -> R16,R17
	__GETWRN 16,17,0
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	STS  _status,R30
	STS  _status+1,R31
; 0000 0213 
; 0000 0214 
; 0000 0215            init();                                     //Initialize controller
	RCALL _init
; 0000 0216            // Command = WGF;                            //Initialize waveformgenerator 125 kHz
; 0000 0217            Command = inf;
	LDI  R30,LOW(1)
	STS  _Command,R30
; 0000 0218              printf("chaking for data to usb");
	__POINTW1FN _0x0,1444
	CALL SUBOPT_0x0
; 0000 0219           //  SetWGFreq(125);
; 0000 021A            debug = 0;                                  //Controls output during motor running
	LDI  R30,LOW(0)
	STS  _debug,R30
; 0000 021B             // MCUCSR =(1<<7);
; 0000 021C             // MCUCSR =(1<<7);
; 0000 021D 
; 0000 021E         while (1){
_0x43:
; 0000 021F               SetWGFreq(125);
	LDI  R30,LOW(125)
	LDI  R31,HIGH(125)
	ST   -Y,R31
	ST   -Y,R30
	CALL _SetWGFreq
; 0000 0220             if(rx_counter0) getCom();
	LDS  R30,_rx_counter0
	CPI  R30,0
	BREQ _0x46
	RCALL _getCom
; 0000 0221             if(Command)     runCom();
_0x46:
	LDS  R30,_Command
	CPI  R30,0
	BREQ _0x47
	RCALL _runCom
; 0000 0222 
; 0000 0223 
; 0000 0224             if(logInt > 0){
_0x47:
	LDS  R26,_logInt
	LDS  R27,_logInt+1
	CALL __CPW02
	BRSH _0x48
; 0000 0225                 if(now){
	LDS  R30,_now
	CPI  R30,0
	BREQ _0x49
; 0000 0226                 if(!(unixTime % logInt)){
	LDS  R30,_logInt
	LDS  R31,_logInt+1
	LDS  R26,_unixTime
	LDS  R27,_unixTime+1
	LDS  R24,_unixTime+2
	LDS  R25,_unixTime+3
	CLR  R22
	CLR  R23
	CALL __MODD21U
	CALL __CPD10
	BRNE _0x4A
; 0000 0227                     if(flag){
	LDS  R30,_flag
	CPI  R30,0
	BREQ _0x4B
; 0000 0228                         printf("Time[sec]\tPress[raw];[psia]\tTemp[raw];[C x 0.01]\tBatt[raw];[mV]\tAVdd[raw];[mV]\r\n");
	__POINTW1FN _0x0,1468
	CALL SUBOPT_0x0
; 0000 0229                         flag = 0;
	LDI  R30,LOW(0)
	STS  _flag,R30
; 0000 022A                     }
; 0000 022B                     now = 0;
_0x4B:
	LDI  R30,LOW(0)
	STS  _now,R30
; 0000 022C                    // MeasureAll();
; 0000 022D //                    printf("%s\t", pLong(unixTime));                   //Print the time as number of seconds since 01.01.1960
; 0000 022E //                    printf("%u;%u\t", pressRaw, press);                //Print pressure
; 0000 022F //                    printf("%u;%u\t", tempRaw, temp);                  //Print temperature
; 0000 0230 //                    printf("%u;%u\t", battVoltRaw, battVolt);          //Print battery voltage
; 0000 0231 //                    printf("%u;%u\r\n", analogVoltRaw, analogVolt);    //Print regulated voltage
; 0000 0232                 }
; 0000 0233                 }
_0x4A:
; 0000 0234             }
_0x49:
; 0000 0235 
; 0000 0236             #asm("WDR");        //Reset WD timer
_0x48:
	WDR
; 0000 0237 
; 0000 0238         } // EOF "while(1)"
	RJMP _0x43
; 0000 0239 
; 0000 023A 
; 0000 023B 
; 0000 023C     } // EOF "main(void)"
_0x4C:
	RJMP _0x4C
;
;
;
;    /*
;    void findStPtr(void){
;        while(EEPROM_read(status) != 0xFF){
;            status += 3;
;            if(status > 130){
;                status = 0x10;
;                break;
;            }
;        }
;    }*/
;
;    /*
;    void Wait(unsigned int d)
;    {
;        StartTimer0();
;        while(ms < d);
;        StopTimer0();
;    }*/
;
;    /*
;    void StartTimer0(void)
;    {
;        ms = 0;         //Always start with 0
;
;        TCNT0 = 0x00;   //Start counting from 0
;
;        OCR0A = 0x39;   //To get almost 1 ms update rate
;
;        TIMSK0 = 0x02;  //Enable timer 0 output compare A interrupt
;
;        TCCR0A = 0x02;
;        TCCR0B = 0x03;  //Start timer 0 in CTC-mode (2) with prescale 16
;    }*/
;
;    /*
;    void StopTimer0(void)
;    {
;        TCCR0A = 0x00;
;        TCCR0B = 0x00;  //Stop timer 0
;        TIMSK0 = 0x00;  //Switch of interrupt
;    }*/
;
;    //Start timer 1 for counting seconds
;/*****************************************************
;Company : Expro Fluids
;Project : TurboPVT2_Perm
;Version : 1.0A
;Date    : 29.05.2012
;Author  : Lars Ole Espeland
;*****************************************************/
;
;#include <stdio.h>
;#include <stdlib.h>
;#include <string.h>
;#include <ctype.h>
;#include <interface.h>
;#include <MEGA32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <stdint.h>
;#include <main.h>
;#include "delay.h"
;
;
;flash unsigned char *cmdList[CMD_SIZE] = {
;    "NO_COM1",       // [0] no com
;    "inf",          // [1] Displays version date etc.
;    "scan",          // [2]
;    "WGF",          // [3]
;    "WGP",          // [4] Read Flash memory log (stopLog)
;    "ADC",       // [5] Clear Flash memmory (stopLog)
;    "MUX",
;    //"STAGEA",
;    //"STAGEB",
;    "PERM"           // [6] Set debug function
;};

	.DSEG
;
;
;/***************************************************
;C O M U N I C A T I O N  RS-232
;****************************************************/
;unsigned char CompIndex;            // Index in Copmare array
;unsigned char Compare[COMPBUFSIZE]; // Command string tokenizer
;extern unsigned char Command;              // Current Command is executed
;extern unsigned int  Param;                // Parameter used in command
;//       float  Param2;               // Optional (second) parameter used in command
;//unsigned long Param3;               // Optional (third) parameter in command
;
;unsigned char Step;
;
;extern unsigned char state;
;extern unsigned int status;
;extern unsigned char debug;
;
;#define RXB8 1
;#define TXB8 0
;#define UPE 2
;#define OVR 3
;#define FE 4
;#define UDRE 5
;#define RXC 7
;
;#define FRAMING_ERROR (1<<FE)
;#define PARITY_ERROR (1<<UPE)
;#define DATA_OVERRUN (1<<OVR)
;#define DATA_REGISTER_EMPTY (1<<UDRE)
;#define RX_COMPLETE (1<<RXC)
;
;// USART Receiver buffer
;#define RX_BUFFER_SIZE0 32
;char rx_buffer0[RX_BUFFER_SIZE0];
;
;#if RX_BUFFER_SIZE0<256
;unsigned char rx_wr_index0,rx_rd_index0,rx_counter0;
;#else
;unsigned int rx_wr_index0,rx_rd_index0,rx_counter0;
;#endif
;
;// This flag is set on USART Receiver buffer overflow
;bit rx_buffer_overflow0;
;
;// USART Receiver interrupt service routine
;interrupt [USART_RXC] void usart_rx_isr(void){
; 0001 004E interrupt [14] void usart_rx_isr(void){

	.CSEG
_usart_rx_isr:
	ST   -Y,R26
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0001 004F     char status,data;
; 0001 0050     status=UCSRA;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R17
;	data -> R16
	IN   R17,11
; 0001 0051     data=UDR;
	IN   R16,12
; 0001 0052      // printf("chaking for data to usb");
; 0001 0053     if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x20004
; 0001 0054        {
; 0001 0055        rx_buffer0[rx_wr_index0]=data;
	LDS  R30,_rx_wr_index0
	LDI  R31,0
	SUBI R30,LOW(-_rx_buffer0)
	SBCI R31,HIGH(-_rx_buffer0)
	ST   Z,R16
; 0001 0056        if (++rx_wr_index0 == RX_BUFFER_SIZE0) rx_wr_index0=0;
	LDS  R26,_rx_wr_index0
	SUBI R26,-LOW(1)
	STS  _rx_wr_index0,R26
	CPI  R26,LOW(0x20)
	BRNE _0x20005
	LDI  R30,LOW(0)
	STS  _rx_wr_index0,R30
; 0001 0057        if (++rx_counter0 == RX_BUFFER_SIZE0)
_0x20005:
	LDS  R26,_rx_counter0
	SUBI R26,-LOW(1)
	STS  _rx_counter0,R26
	CPI  R26,LOW(0x20)
	BRNE _0x20006
; 0001 0058           {
; 0001 0059           rx_counter0=0;
	LDI  R30,LOW(0)
	STS  _rx_counter0,R30
; 0001 005A           rx_buffer_overflow0=1;
	SET
	BLD  R2,0
; 0001 005B           };
_0x20006:
; 0001 005C        };
_0x20004:
; 0001 005D }
	LD   R16,Y+
	LD   R17,Y+
	RJMP _0x20032
;
;#ifndef _DEBUG_TERMINAL_IO_
;// Get a character from the USART Receiver buffer
;#define _ALTERNATE_GETCHAR_
;#pragma used+
;char getchar(void){
; 0001 0063 char getchar(void){
_getchar:
; 0001 0064     char data;
; 0001 0065     while (rx_counter0==0);
	ST   -Y,R17
;	data -> R17
_0x20007:
	LDS  R30,_rx_counter0
	CPI  R30,0
	BREQ _0x20007
; 0001 0066     data=rx_buffer0[rx_rd_index0];
	LDS  R30,_rx_rd_index0
	LDI  R31,0
	SUBI R30,LOW(-_rx_buffer0)
	SBCI R31,HIGH(-_rx_buffer0)
	LD   R17,Z
; 0001 0067     if (++rx_rd_index0 == RX_BUFFER_SIZE0) rx_rd_index0=0;
	LDS  R26,_rx_rd_index0
	SUBI R26,-LOW(1)
	STS  _rx_rd_index0,R26
	CPI  R26,LOW(0x20)
	BRNE _0x2000A
	LDI  R30,LOW(0)
	STS  _rx_rd_index0,R30
; 0001 0068     #asm("cli")
_0x2000A:
	cli
; 0001 0069     --rx_counter0;
	LDS  R30,_rx_counter0
	SUBI R30,LOW(1)
	STS  _rx_counter0,R30
; 0001 006A     #asm("sei")
	sei
; 0001 006B     return data;
	MOV  R30,R17
	RJMP _0x20C000F
; 0001 006C }
;#pragma used-
;#endif
;
;// USART Transmitter buffer
;#define TX_BUFFER_SIZE0 32
;char tx_buffer0[TX_BUFFER_SIZE0];
;
;#if TX_BUFFER_SIZE0<256
;unsigned char tx_wr_index0,tx_rd_index0,tx_counter0;
;#else
;unsigned int tx_wr_index0,tx_rd_index0,tx_counter0;
;#endif
;
;// USART Transmitter interrupt service routine
;interrupt [USART_TXC] void usart_tx_isr(void){
; 0001 007B interrupt [16] void usart_tx_isr(void){
_usart_tx_isr:
	ST   -Y,R26
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0001 007C     if (tx_counter0){
	LDS  R30,_tx_counter0
	CPI  R30,0
	BREQ _0x2000B
; 0001 007D         --tx_counter0;
	SUBI R30,LOW(1)
	STS  _tx_counter0,R30
; 0001 007E         UDR=tx_buffer0[tx_rd_index0];
	LDS  R30,_tx_rd_index0
	LDI  R31,0
	SUBI R30,LOW(-_tx_buffer0)
	SBCI R31,HIGH(-_tx_buffer0)
	LD   R30,Z
	OUT  0xC,R30
; 0001 007F         if (++tx_rd_index0 == TX_BUFFER_SIZE0) tx_rd_index0=0;
	LDS  R26,_tx_rd_index0
	SUBI R26,-LOW(1)
	STS  _tx_rd_index0,R26
	CPI  R26,LOW(0x20)
	BRNE _0x2000C
	LDI  R30,LOW(0)
	STS  _tx_rd_index0,R30
; 0001 0080         //#asm("WDR"); // For long words and slow baud-rates
; 0001 0081     }
_0x2000C:
; 0001 0082 }
_0x2000B:
_0x20032:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R26,Y+
	RETI
;
;#ifndef _DEBUG_TERMINAL_IO_
;// Write a character to the USART Transmitter buffer
;#define _ALTERNATE_PUTCHAR_
;#pragma used+
;void putchar(char c){
; 0001 0088 void putchar(char c){
_putchar:
; 0001 0089     while (tx_counter0 == TX_BUFFER_SIZE0);
;	c -> Y+0
_0x2000D:
	LDS  R26,_tx_counter0
	CPI  R26,LOW(0x20)
	BREQ _0x2000D
; 0001 008A     #asm("cli")
	cli
; 0001 008B     if (tx_counter0 || ((UCSRA & DATA_REGISTER_EMPTY)==0)){
	LDS  R30,_tx_counter0
	CPI  R30,0
	BRNE _0x20011
	SBIC 0xB,5
	RJMP _0x20010
_0x20011:
; 0001 008C         tx_buffer0[tx_wr_index0]=c;
	LDS  R30,_tx_wr_index0
	LDI  R31,0
	SUBI R30,LOW(-_tx_buffer0)
	SBCI R31,HIGH(-_tx_buffer0)
	LD   R26,Y
	STD  Z+0,R26
; 0001 008D         if (++tx_wr_index0 == TX_BUFFER_SIZE0) tx_wr_index0=0;
	LDS  R26,_tx_wr_index0
	SUBI R26,-LOW(1)
	STS  _tx_wr_index0,R26
	CPI  R26,LOW(0x20)
	BRNE _0x20013
	LDI  R30,LOW(0)
	STS  _tx_wr_index0,R30
; 0001 008E         ++tx_counter0;
_0x20013:
	LDS  R30,_tx_counter0
	SUBI R30,-LOW(1)
	STS  _tx_counter0,R30
; 0001 008F     }
; 0001 0090     else
	RJMP _0x20014
_0x20010:
; 0001 0091     UDR=c;
	LD   R30,Y
	OUT  0xC,R30
; 0001 0092     #asm("sei")
_0x20014:
	sei
; 0001 0093 }
	JMP  _0x20C000E
;#pragma used-
;#endif
;
;void help(void){
; 0001 0097 void help(void){
_help:
; 0001 0098 
; 0001 0099       unsigned char  i;
; 0001 009A 
; 0001 009B       printf("Commands: ");
	ST   -Y,R17
;	i -> R17
	__POINTW1FN _0x20000,38
	CALL SUBOPT_0x0
; 0001 009C       for(i=0;i<CMD_SIZE;i++){
	LDI  R17,LOW(0)
_0x20016:
	CPI  R17,8
	BRSH _0x20017
; 0001 009D             printf(cmdList[i]);
	CALL SUBOPT_0x45
	CALL SUBOPT_0x0
; 0001 009E             printf(", ");
	__POINTW1FN _0x20000,49
	CALL SUBOPT_0x0
; 0001 009F       }printf("\r\n");
	SUBI R17,-1
	RJMP _0x20016
_0x20017:
	__POINTW1FN _0x20000,52
	CALL SUBOPT_0x0
; 0001 00A0 }
	RJMP _0x20C000F
;
;/***************************************************
;S T R I N G   T O K E N I Z E R
;Searches the input buffer for valid commands
;returns the id of the command if a match is found or 0 if no cmd
;****************************************************/
;
;void getCom(void){
; 0001 00A8 void getCom(void){
_getCom:
; 0001 00A9 
; 0001 00AA       unsigned char c;
; 0001 00AB 
; 0001 00AC       // Read from ring-buffer and fill in Compare buffer
; 0001 00AD       while(rx_counter0){                     // while unread contents in ring-buffer
	ST   -Y,R17
;	c -> R17
_0x20018:
	LDS  R30,_rx_counter0
	CPI  R30,0
	BRNE PC+3
	JMP _0x2001A
; 0001 00AE             c = getchar();                    // fetch next byte
	RCALL _getchar
	MOV  R17,R30
; 0001 00AF             if(CompIndex >= COMPBUFSIZE) CompIndex = 0;// overflow protection
	LDS  R26,_CompIndex
	CPI  R26,LOW(0x40)
	BRLO _0x2001B
	LDI  R30,LOW(0)
	STS  _CompIndex,R30
; 0001 00B0             // Analyze char
; 0001 00B1             if(c == '#'){                     // Manual start
_0x2001B:
	CPI  R17,35
	BRNE _0x2001C
; 0001 00B2                   CompIndex = 0;
	LDI  R30,LOW(0)
	STS  _CompIndex,R30
; 0001 00B3             }else if(c == '\r'){              // CR continue (end of cmd without argument)
	RJMP _0x2001D
_0x2001C:
	CPI  R17,13
	BRNE _0x2001E
; 0001 00B4                   Compare[CompIndex]='\0';    // fill in end character of comp string
	LDS  R30,_CompIndex
	LDI  R31,0
	SUBI R30,LOW(-_Compare)
	SBCI R31,HIGH(-_Compare)
	LDI  R26,LOW(0)
	STD  Z+0,R26
; 0001 00B5                   break;                      // possible valid cmd received -> check out
	RJMP _0x2001A
; 0001 00B6             }else if(c == '\n'){              // New line (ignore)
_0x2001E:
	CPI  R17,10
	BREQ _0x20021
; 0001 00B7                   // Do nothing (ignore)
; 0001 00B8             }else if(c == 8){                 // Backspace
	CPI  R17,8
	BRNE _0x20022
; 0001 00B9                   if(CompIndex) CompIndex--;  // decrement index
	LDS  R30,_CompIndex
	CPI  R30,0
	BREQ _0x20023
	SUBI R30,LOW(1)
	STS  _CompIndex,R30
; 0001 00BA             }else if(c == 9){                 // Horizontal TAB
_0x20023:
	RJMP _0x20024
_0x20022:
	CPI  R17,9
	BRNE _0x20025
; 0001 00BB                   help();                     // Write out cmds
	RCALL _help
; 0001 00BC             }else if(c == 27){                // ESC button
	RJMP _0x20026
_0x20025:
	CPI  R17,27
	BRNE _0x20027
; 0001 00BD                   Command = 0;                // Stop current command
	LDI  R30,LOW(0)
	STS  _Command,R30
; 0001 00BE                   Param = 0;                  // Clear argument
	STS  _Param,R30
	STS  _Param+1,R30
; 0001 00BF                   Step = 0;
	STS  _Step,R30
; 0001 00C0             }else{
	RJMP _0x20028
_0x20027:
; 0001 00C1                   Compare[CompIndex++]=c;     // Default action: Store character
	LDS  R30,_CompIndex
	SUBI R30,-LOW(1)
	STS  _CompIndex,R30
	SUBI R30,LOW(1)
	LDI  R31,0
	SUBI R30,LOW(-_Compare)
	SBCI R31,HIGH(-_Compare)
	ST   Z,R17
; 0001 00C2             }if(!rx_counter0) return;         // if no more data to read -> exit
_0x20028:
_0x20026:
_0x20024:
_0x20021:
_0x2001D:
	LDS  R30,_rx_counter0
	CPI  R30,0
	BRNE _0x20029
	RJMP _0x20C000F
; 0001 00C3       }CompIndex=0;                           // reset, ready for next command
_0x20029:
	RJMP _0x20018
_0x2001A:
	LDI  R30,LOW(0)
	STS  _CompIndex,R30
; 0001 00C4 
; 0001 00C5       c = 1;
	LDI  R17,LOW(1)
; 0001 00C6 
; 0001 00C7       while(c<CMD_SIZE){          // For each command
_0x2002A:
	CPI  R17,8
	BRSH _0x2002C
; 0001 00C8             if(strncmpf(Compare,cmdList[c],strlenf(cmdList[c])) == 0) break;
	LDI  R30,LOW(_Compare)
	LDI  R31,HIGH(_Compare)
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x45
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x45
	CALL SUBOPT_0x46
	ST   -Y,R30
	CALL _strncmpf
	CPI  R30,0
	BREQ _0x2002C
; 0001 00C9             c++;
	SUBI R17,-1
; 0001 00CA       }
	RJMP _0x2002A
_0x2002C:
; 0001 00CB 
; 0001 00CC       if(c<CMD_SIZE){             // If match on normal commands
	CPI  R17,8
	BRSH _0x2002E
; 0001 00CD             Command = c;
	STS  _Command,R17
; 0001 00CE             if(isdigit(Compare[strlenf(cmdList[c])])){
	CALL SUBOPT_0x45
	CALL SUBOPT_0x46
	SUBI R30,LOW(-_Compare)
	SBCI R31,HIGH(-_Compare)
	LD   R30,Z
	ST   -Y,R30
	CALL _isdigit
	CPI  R30,0
	BREQ _0x2002F
; 0001 00CF                   Param = atoi(&Compare[strlenf(cmdList[c])]);
	CALL SUBOPT_0x45
	CALL SUBOPT_0x46
	SUBI R30,LOW(-_Compare)
	SBCI R31,HIGH(-_Compare)
	ST   -Y,R31
	ST   -Y,R30
	CALL _atoi
	STS  _Param,R30
	STS  _Param+1,R31
; 0001 00D0                   /*c = strpos(Compare,':');
; 0001 00D1                   if(c > 0){
; 0001 00D2                         Param2 = atof(&Compare[c+1]);
; 0001 00D3                         c = strrpos(Compare,':');
; 0001 00D4                         if(c > strpos(Compare,':')) Param3 = atol(&Compare[c+1]);
; 0001 00D5                         else  Param3 = 0;
; 0001 00D6                   }else{
; 0001 00D7                     Param2 = 0;
; 0001 00D8                     Param3 = 0;
; 0001 00D9                   } */
; 0001 00DA             }else{
	RJMP _0x20030
_0x2002F:
; 0001 00DB                 Param  = 0;
	LDI  R30,LOW(0)
	STS  _Param,R30
	STS  _Param+1,R30
; 0001 00DC                // Param2 = 0;
; 0001 00DD                // Param3 = 0;
; 0001 00DE             }
_0x20030:
; 0001 00DF             printf("@%s\r\n",&Compare); //Ack command
	__POINTW1FN _0x20000,55
	CALL SUBOPT_0x47
	CALL SUBOPT_0x4
; 0001 00E0       }else{
	RJMP _0x20031
_0x2002E:
; 0001 00E1             printf("Command not found\r\n");  // Command not found
	__POINTW1FN _0x20000,61
	CALL SUBOPT_0x0
; 0001 00E2             printf("->??: '%s'\r\n",&Compare); // If no match
	__POINTW1FN _0x20000,81
	CALL SUBOPT_0x47
	CALL SUBOPT_0x4
; 0001 00E3             Command = 0;
	LDI  R30,LOW(0)
	STS  _Command,R30
; 0001 00E4       }
_0x20031:
; 0001 00E5 
; 0001 00E6 }
_0x20C000F:
	LD   R17,Y+
	RET
;
;/*****************************************************
;Company : Expro Fluids
;Project : TurboPVT2_Perm
;Version : 1.0A
;Date    : 29.05.2012
;Author  : Lars Ole Espeland
;*****************************************************/
;
;#include <MEGA32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <main.h>
;#include <stdio.h>
;#include <stdlib.h>
;#include <string.h>
;#include <ctype.h>
;#include <interface.h>
;#include <delay.h>
;
;
;
;extern unsigned char now;
;extern unsigned long unixTime;
;extern unsigned ms;
;
;// Timer 0 overflow interrupt service routine. Comutation control
;/*
;//interrupt [TIM0_COMPA] void timer0_compa_isr(void){
;
;    ms++;
;    if(ms >= 65000)
;        ms = 0;
;}*/
;
; //Timer1 output compare A interrupt service routine
;
;interrupt [TIM1_COMPA] void timer1_compa_isr(void){
; 0002 0023 interrupt [8] void timer1_compa_isr(void){

	.CSEG
_timer1_compa_isr:
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0002 0024 
; 0002 0025     unixTime++;
	LDI  R26,LOW(_unixTime)
	LDI  R27,HIGH(_unixTime)
	CALL __GETD1P_INC
	__SUBD1N -1
	CALL __PUTDP1_DEC
; 0002 0026     now = 1;
	LDI  R30,LOW(1)
	STS  _now,R30
; 0002 0027 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R23,Y+
	LD   R22,Y+
	RETI
;
;// Watchdog timeout interrupt service routine
;/*
;interrupt [WDT] void wdt_timeout_isr(void){
;
;    if((EECR & 0x02) == 0) EEPROM_write(0x000B,WD_RESET); //Update state if possible
;    printf("WD Reset\r\n");                               //Write...
;
;}*/
;
;
;
;/*****************************************************
;Company : Expro Fluids
;Project : TurboPVT2_Perm
;Version : 1.0A
;Date    : 29.05.2012
;Author  : Lars Ole Espeland
;*****************************************************/
;
;#include <MEGA32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <main.h>
;#include <stdio.h>
;#include <stdlib.h>
;#include <string.h>
;#include <ctype.h>
;#include <interface.h>
;#include <delay.h>
;#include <stdint.h>
;#include <io.h>
;#include <math.h>
;
;
;#define ADC_CS_PIN PINB.3
;#define WG_CS_PIN PINB.4
;
;#define MUX_A2 PORTB.0
;#define MUX_A1 PORTB.1
;#define MUX_A0 PORTB.2
;#define ADC_CS PORTB.3
;#define WG_CS PORTB.4
;#define MOSI PORTB.5
;//#define MISO PINB.6
;#define SCK PORTB.7
;
;
;#define MISO_PU PORTB.6
;#define MISO_PIN PINB.6
;
;
;#define MODE_SW4 PORTC.0
;#define MODE_SW3 PORTC.1
;#define MODE_SW2 PORTC.6
;#define MODE_SW1 PORTC.7
;
;#define MODE_SW10 PORTD.2
;#define MODE_SW9 PORTD.3
;#define MODE_SW8 PORTD.4
;#define MODE_SW7 PORTD.5
;#define MODE_SW6 PORTD.6
;#define MODE_SW5 PORTD.7
;
;
;
;extern char adcStatus;
;extern char adcStatus1;
;extern char adcId;
;extern unsigned int adcMode;
;extern unsigned int adcConfig;
;//extern unsigned int i;
;//extern unsigned int delay;
;extern  unsigned int data;
;
;extern unsigned int battVoltRaw;
;extern unsigned int battVolt;
;extern unsigned int analogVoltRaw;
;extern unsigned int analogVolt;
;extern unsigned int tempRaw;
;extern unsigned int temp;
;extern unsigned int pressRaw;
;extern unsigned int press;
;
;extern unsigned char statusreg,Id;
;extern unsigned int value, value1, mode, conf, adc,Phase,WaveFreq;
;extern float Analog_Voltage,v1,Vg,Vr,v2;
;extern  unsigned int RawData;
;extern int Newvalue1,Newvalue;
;
;
;
;
;
;
;
;  void init_io(void)
; 0003 0054   {

	.CSEG
_init_io:
; 0003 0055     //DDRB = (1<<7)|(1<<5)|(1<<4)|(1<<3);        // make SCK, MOSI, CS1, CS2 outputs
; 0003 0056     DDRB = 0xBF;
	LDI  R30,LOW(191)
	OUT  0x17,R30
; 0003 0057   //  PORTB=0x03;
; 0003 0058     ADC_CS = 1;              //disable ADC
	SBI  0x18,3
; 0003 0059     WG_CS = 1;               //disable WaveGenerator
	SBI  0x18,4
; 0003 005A     MISO_PU = 1;             //enable pull-up on MISO so we can test !RDY
	SBI  0x18,6
; 0003 005B   }
	RET
;
;
;unsigned char spi(unsigned char data)
; 0003 005F {
_spi:
; 0003 0060     //Start transmision
; 0003 0061     SPDR = data;
;	data -> Y+0
	LD   R30,Y
	OUT  0xF,R30
; 0003 0062     //Wait for transmision complete
; 0003 0063     while (!(SPSR & 0x80));
_0x60009:
	SBIS 0xE,7
	RJMP _0x60009
; 0003 0064     return SPDR;
	IN   R30,0xF
_0x20C000E:
	ADIW R28,1
	RET
; 0003 0065 }
;
;
;
;//Sets the waveform generator output to given kHz
;  void SetWGFreq(unsigned int freq)
; 0003 006B   {
_SetWGFreq:
; 0003 006C     unsigned long freg;
; 0003 006D     char fByte0;
; 0003 006E     char fByte1;
; 0003 006F     char fByte2;
; 0003 0070     char fByte3;
; 0003 0071 
; 0003 0072     freg = (unsigned long)freq*33554.432;   //Number based on a MCLK of 8 MHz
	SBIW R28,4
	CALL __SAVELOCR4
;	freq -> Y+8
;	freg -> Y+4
;	fByte0 -> R17
;	fByte1 -> R16
;	fByte2 -> R19
;	fByte3 -> R18
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	CLR  R22
	CLR  R23
	CALL __CDF1U
	__GETD2N 0x4703126F
	CALL __MULF12
	MOVW R26,R28
	ADIW R26,4
	CALL __CFD1U
	CALL __PUTDP1
; 0003 0073     fByte0 = (char)freg;
	LDD  R17,Y+4
; 0003 0074     fByte1 = (char)(freg>>8);
	CALL SUBOPT_0x48
	LDI  R30,LOW(8)
	CALL __LSRD12
	MOV  R16,R30
; 0003 0075     fByte1 = (fByte1 & 0x3F) | 0x40;        //clears bits 15 and 14, then sets for FREQ0
	MOV  R30,R16
	ANDI R30,LOW(0x3F)
	ORI  R30,0x40
	MOV  R16,R30
; 0003 0076     fByte2 = (char)(freg>>14);              //byte1 only has 6 bits, so move over by 8+6
	CALL SUBOPT_0x48
	LDI  R30,LOW(14)
	CALL __LSRD12
	MOV  R19,R30
; 0003 0077     fByte3 = (char)(freg>>22);              //byte1 only has 6 bits, so move over by 8+8+6
	CALL SUBOPT_0x48
	LDI  R30,LOW(22)
	CALL __LSRD12
	MOV  R18,R30
; 0003 0078     fByte3 = (fByte3 & 0x3F) | 0x40;        //clears bits 15 and 14, then sets for FREQ0
	MOV  R30,R18
	ANDI R30,LOW(0x3F)
	ORI  R30,0x40
	MOV  R18,R30
; 0003 0079 
; 0003 007A     SPCR = 0x5A;        //Set SPI to mode 2 and Fosc/64
	LDI  R30,LOW(90)
	OUT  0xD,R30
; 0003 007B     WG_CS = 0;
	CBI  0x18,4
; 0003 007C     while(WG_CS_PIN);   //Wait for chip select pin to go low
_0x6000E:
	SBIC 0x16,4
	RJMP _0x6000E
; 0003 007D     spi(0x20);          //Load control register with B28 high
	CALL SUBOPT_0x49
; 0003 007E     spi(0x00);
; 0003 007F     spi(fByte1);
	ST   -Y,R16
	RCALL _spi
; 0003 0080     spi(fByte0);
	ST   -Y,R17
	RCALL _spi
; 0003 0081     spi(fByte3);
	ST   -Y,R18
	RCALL _spi
; 0003 0082     spi(fByte2);
	ST   -Y,R19
	RCALL _spi
; 0003 0083     WG_CS = 1;
	SBI  0x18,4
; 0003 0084   }
	CALL __LOADLOCR4
	RJMP _0x20C000D
;
;
;
;  void SetWGPhase(unsigned int phase)
; 0003 0089   {
_SetWGPhase:
; 0003 008A     //unsigned long phase;
; 0003 008B     phase = (uint32_t)phase*4096/360;
;	phase -> Y+0
	CALL SUBOPT_0x4A
; 0003 008C     SPCR = 0x5A;
; 0003 008D     WG_CS = 0;
; 0003 008E     while(WG_CS_PIN);
_0x60015:
	SBIC 0x16,4
	RJMP _0x60015
; 0003 008F     spi(0x20);
	CALL SUBOPT_0x49
; 0003 0090     spi(0x00);
; 0003 0091     spi((phase>>8) | 0xC0);     //Load into phase register 0
	CALL SUBOPT_0x4B
; 0003 0092     spi(phase & 0x00FF);
; 0003 0093     WG_CS = 1;
; 0003 0094   }
	RJMP _0x20C000C
;
;   void SetWGPhase1(unsigned int phase)
; 0003 0097   {
_SetWGPhase1:
; 0003 0098     //unsigned long phase;
; 0003 0099     phase = (uint32_t)phase*4096/360;
;	phase -> Y+0
	CALL SUBOPT_0x4A
; 0003 009A     SPCR = 0x5A;
; 0003 009B     WG_CS = 0;
; 0003 009C     while(WG_CS_PIN);
_0x6001C:
	SBIC 0x16,4
	RJMP _0x6001C
; 0003 009D     spi(0x20);
	CALL SUBOPT_0x49
; 0003 009E     spi(0x00);
; 0003 009F     spi((phase>>8) | 0xC0);     //Load into phase register 0
	CALL SUBOPT_0x4B
; 0003 00A0     spi(phase & 0x00FF);
; 0003 00A1     WG_CS = 1;
; 0003 00A2   }
	RJMP _0x20C000C
;
;
;
;
;
;  //function for reading or writing 8 bit registers
;unsigned char AD7798_8(unsigned char cmd, unsigned char value)
; 0003 00AA {
_AD7798_8:
; 0003 00AB     unsigned char data;
; 0003 00AC     SPCR = 0x5D;        // mode #3 F_CPU/16
	ST   -Y,R17
;	cmd -> Y+2
;	value -> Y+1
;	data -> R17
	LDI  R30,LOW(93)
	OUT  0xD,R30
; 0003 00AD     ADC_CS = 0;                 // enable
	CBI  0x18,3
; 0003 00AE     spi(cmd);                   //Place instruction in communication register
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _spi
; 0003 00AF     data = spi(value);          // and lo-byte.
	LDD  R30,Y+1
	ST   -Y,R30
	RCALL _spi
	MOV  R17,R30
; 0003 00B0     ADC_CS = 1;                 // disable
	SBI  0x18,3
; 0003 00B1     return data;
	MOV  R30,R17
	LDD  R17,Y+0
	RJMP _0x20C000B
; 0003 00B2 }
;
;//function for reading or writing 16 bit registers
;unsigned int AD7798_16(unsigned char cmd, unsigned int value)
; 0003 00B6 {
_AD7798_16:
; 0003 00B7     unsigned int data;
; 0003 00B8     SPCR = 0x5D;        // mode #3 F_CPU/16
	ST   -Y,R17
	ST   -Y,R16
;	cmd -> Y+4
;	value -> Y+2
;	data -> R16,R17
	LDI  R30,LOW(93)
	OUT  0xD,R30
; 0003 00B9     ADC_CS = 0;                 // enable
	CBI  0x18,3
; 0003 00BA     spi(cmd);                   //Place instruction in communication register
	LDD  R30,Y+4
	ST   -Y,R30
	RCALL _spi
; 0003 00BB     data = spi(value >> 8);     // read hi-byte
	LDD  R30,Y+3
	ANDI R31,HIGH(0x0)
	ST   -Y,R30
	RCALL _spi
	MOV  R16,R30
	CLR  R17
; 0003 00BC     data = (data << 8) | spi(value);    // and lo-byte.
	MOV  R31,R16
	LDI  R30,LOW(0)
	PUSH R31
	PUSH R30
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _spi
	POP  R26
	POP  R27
	LDI  R31,0
	OR   R30,R26
	OR   R31,R27
	MOVW R16,R30
; 0003 00BD     ADC_CS = 1;                 // disable
	SBI  0x18,3
; 0003 00BE     return data;
	MOVW R30,R16
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,5
	RET
; 0003 00BF }
;
;
;    unsigned int readADC(void)
; 0003 00C3     {
_readADC:
; 0003 00C4 
; 0003 00C5            init_io();                                 // setup SPI pins
	RCALL _init_io
; 0003 00C6 
; 0003 00C7            // read power on default register values
; 0003 00C8            statusreg = AD7798_8(0x40, 0xFF);          // read STATUS register
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _AD7798_8
	MOV  R5,R30
; 0003 00C9            Id = AD7798_8(0x60, 0xFF);                 // read ID register
	LDI  R30,LOW(96)
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _AD7798_8
	MOV  R4,R30
; 0003 00CA            mode = AD7798_16(0x48, 0xFFFF);            // read MODE register
	LDI  R30,LOW(72)
	CALL SUBOPT_0x4C
	MOVW R10,R30
; 0003 00CB            conf = AD7798_16(0x50, 0xFFFF);            // read CONFIGURATIONregister
	LDI  R30,LOW(80)
	CALL SUBOPT_0x4C
	MOVW R12,R30
; 0003 00CC 
; 0003 00CD //           printf("Id register %02x\r\n", Id);            // printing ID reg default value
; 0003 00CE //           printf("status register %02x\r\n", statusreg); // printing STATUS reg default value
; 0003 00CF //           printf(" conf regisetr %04x\r\n", conf);       // printing CONFIGURATION reg default value
; 0003 00D0 //           printf(" mode register %04x\r\n", mode);       // printing MODE reg default value
; 0003 00D1 
; 0003 00D2            AD7798_16(0x10, 0x0010);                 // write Configuration reg = 0x0010.  2.5V range
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _AD7798_16
; 0003 00D3            value = AD7798_16(0x50, 0xFFFF);         // read Configration register
	LDI  R30,LOW(80)
	CALL SUBOPT_0x4C
	MOVW R6,R30
; 0003 00D4 
; 0003 00D5 //         AD7798_16(0x08, 0x000A);                 // write Mode register = 0x0080.
; 0003 00D6 //         value1 = AD7798_16(0x48, 0xFFFF);        // read Mode register
; 0003 00D7 //
; 0003 00D8           // printf("configreg %04x\r\n", value);     // printing Configuration register value
; 0003 00D9 //         printf("modereg %04x\r\n", value1);      // printing Mode register value
; 0003 00DA 
; 0003 00DB //           if (statusreg != 0x80)                                    //check status register
; 0003 00DC //           printf("unexpected power on status %02x\r\n", statusreg);
; 0003 00DD //           if (conf != 0x0710)                                       //check configuration register
; 0003 00DE //           printf("unexpected power on conf %04x\r\n", conf);
; 0003 00DF //           if (mode != 0x000A)                                       //check mode register
; 0003 00E0 //           printf("unexpected power on mode %04x\r\n", mode);
; 0003 00E1 //
; 0003 00E2 //           if (value != 0x0010)
; 0003 00E3 //           printf("unexpected conf setting %04x\r\n", value);
; 0003 00E4 //
; 0003 00E5 //         if (value1 != 0x000A)
; 0003 00E6 //         printf("unexpected mode setting %04x\r\n", value1);
; 0003 00E7 
; 0003 00E8            while ((statusreg & 0x80) != 0);                         // wait till ADC is ready
_0x60029:
	SBRC R5,7
	RJMP _0x60029
; 0003 00E9            adc = AD7798_16(0x58, 0xFFFF);                           // read registe
	LDI  R30,LOW(88)
	CALL SUBOPT_0x4C
	STS  _adc,R30
	STS  _adc+1,R31
; 0003 00EA           return adc;
	RET
; 0003 00EB          }
;
; float voltage(unsigned int a)
; 0003 00EE {
_voltage:
; 0003 00EF            float Ain=0.0F, adcfloat=0.0F;
; 0003 00F0            adcfloat = (float)a;
	SBIW R28,8
	CALL SUBOPT_0x4D
	LDI  R30,LOW(0)
	STD  Y+2,R30
	STD  Y+3,R30
	STD  Y+4,R30
	STD  Y+5,R30
	STD  Y+6,R30
	STD  Y+7,R30
;	a -> Y+8
;	Ain -> Y+4
;	adcfloat -> Y+0
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	CLR  R22
	CLR  R23
	CALL __CDF1
	CALL SUBOPT_0x3D
; 0003 00F1            Ain=((adcfloat / 32768.0F) - 1.0F) / 0.4F;
	CALL SUBOPT_0x4E
	__GETD1N 0x47000000
	CALL __DIVF21
	MOVW R26,R30
	MOVW R24,R22
	CALL SUBOPT_0x29
	CALL SUBOPT_0x4F
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x3ECCCCCD
	CALL __DIVF21
	CALL SUBOPT_0x50
; 0003 00F2            Ain=2.5+Ain;
	__GETD2N 0x40200000
	CALL __ADDF12
	CALL SUBOPT_0x50
; 0003 00F3            return Ain;
_0x20C000D:
	ADIW R28,10
	RET
; 0003 00F4 }
;
;
;void Permitivity(void)
; 0003 00F8 {
_Permitivity:
; 0003 00F9      float Z=0.0F, R=1000.0F, Rs,Cs,Rp,Cp,theta,theta1,delta,delta1,W,Xcs,C0=25.55E-12,Erp,Ers;
; 0003 00FA      float pi, Rin=0.003F,Rout=0.00397F, L=0.08F, Cp1,Cs1,sigma;
; 0003 00FB      pi = 4.0*atan(1.0);
	SBIW R28,63
	SBIW R28,25
	LDI  R24,76
	LDI  R26,LOW(12)
	LDI  R27,HIGH(12)
	LDI  R30,LOW(_0x6002C*2)
	LDI  R31,HIGH(_0x6002C*2)
	CALL __INITLOCB
;	Z -> Y+84
;	R -> Y+80
;	Rs -> Y+76
;	Cs -> Y+72
;	Rp -> Y+68
;	Cp -> Y+64
;	theta -> Y+60
;	theta1 -> Y+56
;	delta -> Y+52
;	delta1 -> Y+48
;	W -> Y+44
;	Xcs -> Y+40
;	C0 -> Y+36
;	Erp -> Y+32
;	Ers -> Y+28
;	pi -> Y+24
;	Rin -> Y+20
;	Rout -> Y+16
;	L -> Y+12
;	Cp1 -> Y+8
;	Cs1 -> Y+4
;	sigma -> Y+0
	CALL SUBOPT_0x29
	CALL SUBOPT_0x2A
	__PUTD1S 24
; 0003 00FC      theta=abs(Newvalue1-Newvalue);
	CALL SUBOPT_0x2C
	__PUTD1S 60
; 0003 00FD      theta1= theta/180*pi;
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x51
	__PUTD1S 56
; 0003 00FE      delta=abs(90-theta);
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x3C
; 0003 00FF      delta1= delta/180*pi;
	CALL SUBOPT_0x51
	__PUTD1S 48
; 0003 0100      Z= ((Vg-Vr)/Vr)*R;
	CALL SUBOPT_0x30
	__GETD2SX 80
	CALL __MULF12
	__PUTD1SX 84
; 0003 0101      printf("value of Impedance (Z): %f[Ohms]\r\n", Z);
	__POINTW1FN _0x60000,0
	ST   -Y,R31
	ST   -Y,R30
	__GETD1SX 86
	CALL SUBOPT_0x8
; 0003 0102      printf("level of excitation signal (Vg): %f[V]\r\n", Vg);
	__POINTW1FN _0x60000,35
	CALL SUBOPT_0x12
; 0003 0103      printf("level of return signal (Vr): %f[V]\r\n",Vr);
	__POINTW1FN _0x60000,76
	CALL SUBOPT_0x1A
; 0003 0104      printf("value of Theta: %f\r\n", theta);
	__POINTW1FN _0x60000,113
	CALL SUBOPT_0x31
; 0003 0105      printf("value of Delta: %f\r\n", delta);
	__POINTW1FN _0x60000,134
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 54
	CALL SUBOPT_0x8
; 0003 0106      //  WavePhase = ((WavePhase * pi)/180)  ;
; 0003 0107     // printf("WavePhase: %d\r\n", WavePhase);
; 0003 0108 
; 0003 0109      W= (2.0*pi*WaveFreq*1000);
	__GETD1S 24
	CALL SUBOPT_0x33
	__PUTD1S 44
; 0003 010A      printf("value of Omega: %f\r\n", W);
	__POINTW1FN _0x60000,155
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 46
	CALL SUBOPT_0x8
; 0003 010B 
; 0003 010C      Rs= (fabs(Z)* cos(theta1));
	CALL SUBOPT_0x52
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD1S 56
	CALL __PUTPARD1
	CALL _cos
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __MULF12
	__PUTD1SX 76
; 0003 010D      Xcs= fabs((fabs(Z)* sin(theta1)));
	CALL SUBOPT_0x52
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD1S 56
	CALL SUBOPT_0x35
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __MULF12
	CALL SUBOPT_0x34
	__PUTD1S 40
; 0003 010E      Rp= ((1+pow(tan(delta1),2))/(pow(tan(delta1),2))*Rs);
	CALL SUBOPT_0x53
	CALL SUBOPT_0x3A
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x53
	CALL __PUTPARD1
	CALL _tan
	CALL __PUTPARD1
	__GETD1N 0x40000000
	CALL __PUTPARD1
	CALL _pow
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __DIVF21
	CALL SUBOPT_0x54
	__PUTD1SX 68
; 0003 010F 
; 0003 0110      Cs= fabs(1/(W*Xcs));
	__GETD1S 40
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x36
	__PUTD1SX 72
; 0003 0111      Cs1= Cs*10E11;
	CALL SUBOPT_0x55
	CALL SUBOPT_0x38
	CALL SUBOPT_0x39
; 0003 0112      Cp= fabs((Cs/(1+pow(tan(delta1),2))));
	CALL SUBOPT_0x53
	CALL SUBOPT_0x3A
	CALL SUBOPT_0x55
	CALL SUBOPT_0x41
	__PUTD1SX 64
; 0003 0113      Cp1= Cp*10E11;
	CALL SUBOPT_0x56
	CALL SUBOPT_0x38
	CALL SUBOPT_0x2B
; 0003 0114 
; 0003 0115      printf("value of Reactance(Xc): %f\r\n", Xcs);
	__POINTW1FN _0x60000,176
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 42
	CALL SUBOPT_0x8
; 0003 0116      printf("value of Serial Resistance(Rs): %f[Ohms]\r\n", Rs);
	__POINTW1FN _0x60000,205
	ST   -Y,R31
	ST   -Y,R30
	__GETD1SX 78
	CALL SUBOPT_0x8
; 0003 0117      printf("value of Serial Capacitance(Cs): %f[pF]\r\n", Cs1);
	__POINTW1FN _0x60000,248
	CALL SUBOPT_0x43
; 0003 0118      printf("value of Parallel Resistance(Rp): %f[Ohms]\r\n", Rp);
	__POINTW1FN _0x60000,290
	ST   -Y,R31
	ST   -Y,R30
	__GETD1SX 70
	CALL SUBOPT_0x8
; 0003 0119      printf("value of Parallel Capacitance(Cp): %f[pF]\r\n", Cp1);
	__POINTW1FN _0x60000,335
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x57
	CALL SUBOPT_0x8
; 0003 011A      Ers= fabs(Cs/C0);
	__GETD1S 36
	CALL SUBOPT_0x55
	CALL SUBOPT_0x41
	__PUTD1S 28
; 0003 011B      printf("value of Permitivity for Serial Model: %f\r\n", Ers);
	__POINTW1FN _0x60000,379
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 30
	CALL SUBOPT_0x8
; 0003 011C      Erp= fabs(Cp/C0);
	__GETD1S 36
	CALL SUBOPT_0x56
	CALL SUBOPT_0x41
	__PUTD1S 32
; 0003 011D      printf("value of Permitivity for Parallel Model: %f\r\n", Erp);
	__POINTW1FN _0x60000,423
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 34
	CALL SUBOPT_0x8
; 0003 011E 
; 0003 011F      sigma= (L/(Rs*log(Rout/Rin))*1000);
	CALL SUBOPT_0x40
	CALL SUBOPT_0x58
	CALL SUBOPT_0x59
	CALL _log
	CALL SUBOPT_0x54
	CALL SUBOPT_0x5A
	CALL __DIVF21
	__GETD2N 0x447A0000
	CALL __MULF12
	CALL SUBOPT_0x3D
; 0003 0120      printf("value of Conductivity: %f[mS/m]\r\n", sigma);
	__POINTW1FN _0x60000,469
	CALL SUBOPT_0x3F
; 0003 0121 }
	ADIW R28,63
	ADIW R28,25
	RET
;
;float voltage_at(int phase1)
; 0003 0124 {
_voltage_at:
; 0003 0125     SetWGPhase(phase1);
;	phase1 -> Y+0
	LD   R30,Y
	LDD  R31,Y+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _SetWGPhase
; 0003 0126     delay_ms(140);
	LDI  R30,LOW(140)
	LDI  R31,HIGH(140)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0003 0127     RawData = readADC();
	CALL SUBOPT_0x5
; 0003 0128     v1=voltage(RawData);
	CALL SUBOPT_0x7
	STS  _v1,R30
	STS  _v1+1,R31
	STS  _v1+2,R22
	STS  _v1+3,R23
; 0003 0129     return v1;
_0x20C000C:
	ADIW R28,2
	RET
; 0003 012A }
;
;//void phaseshift(float *MAX10, unsigned int *INDEX)
;// {
;//   unsigned int idx, second,first;
;//
;//   struct best {
;//    unsigned pos;
;//    float val;
;//    } samples[3] = {{0, 0.0}, };
;//
;//   for (idx = 0;idx < 3;idx++) {
;//    samples[idx].pos = 120*idx;
;//    samples[idx].val = voltage_at(samples[idx].pos);
;//
;//    switch (idx) {
;//    default:
;//        if (samples[idx].val >= samples[first].val) { second = first; first = idx; }
;//        else if (samples[idx].val >= samples[second].val) { second = idx; }
;//        break;
;//    case 1:
;//        if (samples[idx].val >= samples[first].val) { first = idx; }
;//        else second = idx;
;//        break;
;//    case 0:
;//        second = first = idx;
;//        break;
;//        }
;//    }
;//
;// // fprintf(stderr, "Second=%u First=%u\n", second,first );
;//
;//  if (second != first) {
;//    for(idx=3-first-second; samples[second].pos != samples[first].pos; idx=3-first-second) {
;//
;//       // fprintf(stderr, "Second=%u First=%u , Idx=%u\n", second,first,idx );
;//        samples[idx].pos = (samples[second].pos + samples[first].pos) /2;
;//        samples[idx].val = voltage_at( samples[idx].pos );
;//
;//        if (samples[idx].val >= samples[first].val) { second = first; first = idx; }
;//        else if (samples[idx].val > samples[second].val) { second = idx; }
;//        else break;
;//        }
;//     }
;//
;//    *MAX10 = samples[first].val;
;//    *INDEX = samples[first].pos;
;//
;// }
;
;
; void phaseshift1(float *MAX20, int *INDEX1)
; 0003 015E   {
; 0003 015F       int i;
; 0003 0160       *MAX20 = 0.0F;
;	*MAX20 -> Y+4
;	*INDEX1 -> Y+2
;	i -> R16,R17
; 0003 0161      for (i=0;i<=359;i+=1)
; 0003 0162      {
; 0003 0163        SetWGPhase(i);
; 0003 0164       delay_ms(130);
; 0003 0165        RawData = readADC();
; 0003 0166        v2 = voltage(RawData);
; 0003 0167        if(v2>*MAX20)
; 0003 0168            {
; 0003 0169              *MAX20 = v2;
; 0003 016A              *INDEX1 = i;
; 0003 016B            }
; 0003 016C        }
; 0003 016D   }
;
;//BINARY SEARCH
; void phaseshift(float *MAX10, int *INDEX)
; 0003 0171   {
_phaseshift:
; 0003 0172     int  phase2, phase3, i;
; 0003 0173    int range;
; 0003 0174    float voltage;
; 0003 0175    *INDEX = 0;
	SBIW R28,6
	CALL __SAVELOCR6
;	*MAX10 -> Y+14
;	*INDEX -> Y+12
;	phase2 -> R16,R17
;	phase3 -> R18,R19
;	i -> R20,R21
;	range -> Y+10
;	voltage -> Y+6
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
; 0003 0176    *MAX10 = voltage_at(*INDEX);
	CALL SUBOPT_0x5B
	ST   -Y,R31
	ST   -Y,R30
	RCALL _voltage_at
	CALL SUBOPT_0x5C
; 0003 0177    for (i = 1; i < 8; i++) {
	__GETWRN 20,21,1
_0x60032:
	__CPWRN 20,21,8
	BRGE _0x60033
; 0003 0178     phase2 = 45 * i;
	MOVW R30,R20
	LDI  R26,LOW(45)
	LDI  R27,HIGH(45)
	CALL __MULW12
	MOVW R16,R30
; 0003 0179     voltage = voltage_at(phase2);
	CALL SUBOPT_0x5D
; 0003 017A     if (voltage > *MAX10) {
	BREQ PC+2
	BRCC PC+3
	JMP  _0x60034
; 0003 017B         *INDEX = phase2;
	CALL SUBOPT_0x5E
; 0003 017C         *MAX10 = voltage;
; 0003 017D     }
; 0003 017E    }
_0x60034:
	__ADDWRN 20,21,1
	RJMP _0x60032
_0x60033:
; 0003 017F     range=32;  //360/12 = 30, next higher power of two is 32
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	STD  Y+10,R30
	STD  Y+10+1,R31
; 0003 0180     while (range > 1) {
_0x60035:
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,2
	BRGE PC+3
	JMP _0x60037
; 0003 0181   range = range / 2;
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL __DIVW21
	STD  Y+10,R30
	STD  Y+10+1,R31
; 0003 0182   phase2 = *INDEX + range;
	CALL SUBOPT_0x5B
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	ADD  R30,R26
	ADC  R31,R27
	MOVW R16,R30
; 0003 0183   if (phase2 >= 360)
	__CPWRN 16,17,360
	BRLT _0x60038
; 0003 0184       phase2 -= 360;
	__SUBWRN 16,17,360
; 0003 0185   phase3 = *INDEX - range;
_0x60038:
	CALL SUBOPT_0x5B
	MOVW R26,R30
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R26,R30
	SBC  R27,R31
	MOVW R18,R26
; 0003 0186   if (phase3 < 0)
	TST  R19
	BRPL _0x60039
; 0003 0187       phase3 += 360;
	__ADDWRN 18,19,360
; 0003 0188   voltage = voltage_at(phase2);
_0x60039:
	CALL SUBOPT_0x5D
; 0003 0189    if (voltage > *MAX10) {
	BREQ PC+2
	BRCC PC+3
	JMP  _0x6003A
; 0003 018A      *INDEX = phase2;
	CALL SUBOPT_0x5E
; 0003 018B       *MAX10 = voltage;
; 0003 018C    }
; 0003 018D   voltage = voltage_at(phase3);
_0x6003A:
	ST   -Y,R19
	ST   -Y,R18
	RCALL _voltage_at
	CALL SUBOPT_0x5F
; 0003 018E    if (voltage > *MAX10) {
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	CALL __GETD1P
	CALL SUBOPT_0x60
	CALL __CMPF12
	BREQ PC+2
	BRCC PC+3
	JMP  _0x6003B
; 0003 018F       *INDEX = phase3;
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	ST   X+,R18
	ST   X,R19
; 0003 0190       *MAX10 = voltage;
	CALL SUBOPT_0x61
	CALL SUBOPT_0x5C
; 0003 0191    }
; 0003 0192   }
_0x6003B:
	RJMP _0x60035
_0x60037:
; 0003 0193  }
	CALL __LOADLOCR6
	RJMP _0x20C000A
;
;
;
;/* WITH ONE DEGREE ACCURACY
;//void phaseshift(float *MAX10, unsigned int *INDEX)
;//  {
;//   unsigned int index,i,j,k,a,INDEX20,INDEX30;
;//     float MAX = 0.0,MAX20,MAX30;
;//     for (i=0;i<360;i+=45)   //while(i<359){ ------- i=45*j) while(j<8)}{ j++;}
;//     {
;//       SetWGPhase(i);
;//      delay_ms(130);
;//       RawData = readADC();
;//       v1 = voltage(RawData);
;//       if(v1>MAX)
;//           {
;//             MAX = v1;
;//             index = i;
;//           }
;//       }
;//       MAX20 = MAX;
;//       INDEX20=index;
;//        for (i=INDEX20-31; i<=INDEX20+31;i+=15) {
;//         j = i;
;//         SetWGPhase(j); // i should be adjusted if i near zero or 360 :
;//         delay_ms(130);
;//         RawData = readADC();
;//         v1 = voltage(RawData);
;//         if(v1>MAX20)
;//           {
;//             MAX20 = v1;
;//             INDEX20 = j;
;//           }
;//        }
;//         MAX30=MAX20 ;
;//         INDEX30=INDEX20;
;//        for (i=INDEX30-11; i<=INDEX30+11;i+=5) {
;//         k = i;
;//         SetWGPhase(k); // i should be adjusted if i near zero or 360 :
;//         delay_ms(130);
;//         RawData = readADC();
;//         v1 = voltage(RawData);
;//         if(v1>MAX30)
;//           {
;//             MAX30 = v1;
;//             INDEX30 = k;
;//           }
;//        }
;//         *MAX10=MAX30 ;
;//         *INDEX=INDEX30;
;//        for (i=*INDEX-4; i<=*INDEX+4;i+=1) {
;//         a = i;
;//         SetWGPhase(a); // i should be adjusted if i near zero or 360 :
;//         delay_ms(130);
;//         RawData = readADC();
;//         v1 = voltage(RawData);
;//         if(v1>*MAX10)
;//           {
;//             *MAX10 = v1;
;//             *INDEX = a;
;//           }
;//        }
;//  } */
;
;
;
;
;
;
;
;//  void phaseshift(void)
;//  {
;//   for(j=0; j<= 360; j++)
;//            {
;//            SetWGPhase(j);
;//            mux1 = readADC();  stores the Current ADC value to array
;//            v1[j] = voltage(mux1); stores the current voltage to array
;//               if(j=360)
;//               {
;//                MAX = v1[0];
;//                  for (i=0;i<=360;i++)
;//                  {
;//                     if(v1[i]>MAX)
;//                     {
;//                        MAX = v1[i];
;//                        index = i;
;//                     }
;//                  }
;//               }
;//            }
;//            printf("Max Voltage Value:%d\r\n", MAX);
;//            printf("Related Phase Value:%d\r\n", index);
;//  }
;
;
;
;
;
;
;
;
;
;
;
;
;
;
;
;
;// unsigned int get_timer_ticks(void)
;// {
;//    unsigned int i;
;//    i= TCNT1H;
;//    i= i|TCNT1L;
;//    return i;
;// }
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_put_usart_G100:
	LDD  R30,Y+2
	ST   -Y,R30
	CALL _putchar
	LD   R26,Y
	LDD  R27,Y+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
_0x20C000B:
	ADIW R28,3
	RET
__ftoe_G100:
	SBIW R28,4
	CALL SUBOPT_0x4D
	LDI  R30,LOW(128)
	STD  Y+2,R30
	LDI  R30,LOW(63)
	STD  Y+3,R30
	CALL __SAVELOCR4
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x2000019
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2000000,0
	CALL SUBOPT_0x62
	RJMP _0x20C0009
_0x2000019:
	CPI  R30,LOW(0x7FFF)
	LDI  R26,HIGH(0x7FFF)
	CPC  R31,R26
	BRNE _0x2000018
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2000000,1
	CALL SUBOPT_0x62
	RJMP _0x20C0009
_0x2000018:
	LDD  R26,Y+11
	CPI  R26,LOW(0x7)
	BRLO _0x200001B
	LDI  R30,LOW(6)
	STD  Y+11,R30
_0x200001B:
	LDD  R17,Y+11
_0x200001C:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	BREQ _0x200001E
	CALL SUBOPT_0x63
	RJMP _0x200001C
_0x200001E:
	__GETD1S 12
	CALL __CPD10
	BRNE _0x200001F
	LDI  R19,LOW(0)
	CALL SUBOPT_0x63
	RJMP _0x2000020
_0x200001F:
	LDD  R19,Y+11
	CALL SUBOPT_0x64
	BREQ PC+2
	BRCC PC+3
	JMP  _0x2000021
	CALL SUBOPT_0x63
_0x2000022:
	CALL SUBOPT_0x64
	BRLO _0x2000024
	CALL SUBOPT_0x65
	RJMP _0x2000022
_0x2000024:
	RJMP _0x2000025
_0x2000021:
_0x2000026:
	CALL SUBOPT_0x64
	BRSH _0x2000028
	CALL SUBOPT_0x5A
	CALL SUBOPT_0x66
	CALL SUBOPT_0x44
	SUBI R19,LOW(1)
	RJMP _0x2000026
_0x2000028:
	CALL SUBOPT_0x63
_0x2000025:
	__GETD1S 12
	CALL SUBOPT_0x67
	CALL SUBOPT_0x44
	CALL SUBOPT_0x64
	BRLO _0x2000029
	CALL SUBOPT_0x65
_0x2000029:
_0x2000020:
	LDI  R17,LOW(0)
_0x200002A:
	LDD  R30,Y+11
	CP   R30,R17
	BRLO _0x200002C
	CALL SUBOPT_0x48
	CALL SUBOPT_0x68
	CALL SUBOPT_0x67
	CALL SUBOPT_0x69
	CALL SUBOPT_0x50
	CALL SUBOPT_0x5A
	CALL __DIVF21
	CALL __CFD1U
	MOV  R16,R30
	CALL SUBOPT_0x6A
	CALL SUBOPT_0x6B
	CALL SUBOPT_0x6C
	CALL SUBOPT_0x6D
	CALL SUBOPT_0x5A
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x44
	MOV  R30,R17
	SUBI R17,-1
	CPI  R30,0
	BRNE _0x200002A
	CALL SUBOPT_0x6A
	LDI  R30,LOW(46)
	ST   X,R30
	RJMP _0x200002A
_0x200002C:
	CALL SUBOPT_0x6E
	LDD  R26,Y+10
	STD  Z+0,R26
	CPI  R19,0
	BRGE _0x200002E
	CALL SUBOPT_0x6A
	LDI  R30,LOW(45)
	ST   X,R30
	NEG  R19
_0x200002E:
	CPI  R19,10
	BRLT _0x200002F
	CALL SUBOPT_0x6E
	MOVW R22,R30
	MOV  R26,R19
	LDI  R30,LOW(10)
	CALL __DIVB21
	SUBI R30,-LOW(48)
	MOVW R26,R22
	ST   X,R30
_0x200002F:
	CALL SUBOPT_0x6E
	MOVW R22,R30
	MOV  R26,R19
	LDI  R30,LOW(10)
	CALL __MODB21
	SUBI R30,-LOW(48)
	MOVW R26,R22
	ST   X,R30
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(0)
	ST   X,R30
_0x20C0009:
	CALL __LOADLOCR4
_0x20C000A:
	ADIW R28,16
	RET
__print_G100:
	SBIW R28,63
	SBIW R28,17
	CALL __SAVELOCR6
	LDI  R17,0
	__GETW1SX 88
	STD  Y+8,R30
	STD  Y+8+1,R31
	__GETW1SX 86
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2000030:
	MOVW R26,R28
	SUBI R26,LOW(-(92))
	SBCI R27,HIGH(-(92))
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x2000032
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x2000036
	CPI  R18,37
	BRNE _0x2000037
	LDI  R17,LOW(1)
	RJMP _0x2000038
_0x2000037:
	CALL SUBOPT_0x6F
_0x2000038:
	RJMP _0x2000035
_0x2000036:
	CPI  R30,LOW(0x1)
	BRNE _0x2000039
	CPI  R18,37
	BRNE _0x200003A
	CALL SUBOPT_0x6F
	RJMP _0x2000111
_0x200003A:
	LDI  R17,LOW(2)
	LDI  R30,LOW(0)
	STD  Y+21,R30
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x200003B
	LDI  R16,LOW(1)
	RJMP _0x2000035
_0x200003B:
	CPI  R18,43
	BRNE _0x200003C
	LDI  R30,LOW(43)
	STD  Y+21,R30
	RJMP _0x2000035
_0x200003C:
	CPI  R18,32
	BRNE _0x200003D
	LDI  R30,LOW(32)
	STD  Y+21,R30
	RJMP _0x2000035
_0x200003D:
	RJMP _0x200003E
_0x2000039:
	CPI  R30,LOW(0x2)
	BRNE _0x200003F
_0x200003E:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2000040
	ORI  R16,LOW(128)
	RJMP _0x2000035
_0x2000040:
	RJMP _0x2000041
_0x200003F:
	CPI  R30,LOW(0x3)
	BRNE _0x2000042
_0x2000041:
	CPI  R18,48
	BRLO _0x2000044
	CPI  R18,58
	BRLO _0x2000045
_0x2000044:
	RJMP _0x2000043
_0x2000045:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x2000035
_0x2000043:
	LDI  R20,LOW(0)
	CPI  R18,46
	BRNE _0x2000046
	LDI  R17,LOW(4)
	RJMP _0x2000035
_0x2000046:
	RJMP _0x2000047
_0x2000042:
	CPI  R30,LOW(0x4)
	BRNE _0x2000049
	CPI  R18,48
	BRLO _0x200004B
	CPI  R18,58
	BRLO _0x200004C
_0x200004B:
	RJMP _0x200004A
_0x200004C:
	ORI  R16,LOW(32)
	LDI  R26,LOW(10)
	MUL  R20,R26
	MOV  R20,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x2000035
_0x200004A:
_0x2000047:
	CPI  R18,108
	BRNE _0x200004D
	ORI  R16,LOW(2)
	LDI  R17,LOW(5)
	RJMP _0x2000035
_0x200004D:
	RJMP _0x200004E
_0x2000049:
	CPI  R30,LOW(0x5)
	BREQ PC+3
	JMP _0x2000035
_0x200004E:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x2000053
	CALL SUBOPT_0x70
	CALL SUBOPT_0x71
	CALL SUBOPT_0x70
	LDD  R26,Z+4
	ST   -Y,R26
	CALL SUBOPT_0x72
	RJMP _0x2000054
_0x2000053:
	CPI  R30,LOW(0x45)
	BREQ _0x2000057
	CPI  R30,LOW(0x65)
	BRNE _0x2000058
_0x2000057:
	RJMP _0x2000059
_0x2000058:
	CPI  R30,LOW(0x66)
	BREQ PC+3
	JMP _0x200005A
_0x2000059:
	MOVW R30,R28
	ADIW R30,22
	STD  Y+14,R30
	STD  Y+14+1,R31
	CALL SUBOPT_0x73
	CALL __GETD1P
	CALL SUBOPT_0x74
	CALL SUBOPT_0x75
	LDD  R26,Y+13
	TST  R26
	BRMI _0x200005B
	LDD  R26,Y+21
	CPI  R26,LOW(0x2B)
	BREQ _0x200005D
	RJMP _0x200005E
_0x200005B:
	CALL SUBOPT_0x57
	CALL __ANEGF1
	CALL SUBOPT_0x74
	LDI  R30,LOW(45)
	STD  Y+21,R30
_0x200005D:
	SBRS R16,7
	RJMP _0x200005F
	LDD  R30,Y+21
	ST   -Y,R30
	CALL SUBOPT_0x72
	RJMP _0x2000060
_0x200005F:
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	ADIW R30,1
	STD  Y+14,R30
	STD  Y+14+1,R31
	SBIW R30,1
	LDD  R26,Y+21
	STD  Z+0,R26
_0x2000060:
_0x200005E:
	SBRS R16,5
	LDI  R20,LOW(6)
	CPI  R18,102
	BRNE _0x2000062
	CALL SUBOPT_0x57
	CALL __PUTPARD1
	ST   -Y,R20
	LDD  R30,Y+19
	LDD  R31,Y+19+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _ftoa
	RJMP _0x2000063
_0x2000062:
	CALL SUBOPT_0x57
	CALL __PUTPARD1
	ST   -Y,R20
	ST   -Y,R18
	LDD  R30,Y+20
	LDD  R31,Y+20+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL __ftoe_G100
_0x2000063:
	MOVW R30,R28
	ADIW R30,22
	CALL SUBOPT_0x76
	RJMP _0x2000064
_0x200005A:
	CPI  R30,LOW(0x73)
	BRNE _0x2000066
	CALL SUBOPT_0x75
	CALL SUBOPT_0x77
	CALL SUBOPT_0x76
	RJMP _0x2000067
_0x2000066:
	CPI  R30,LOW(0x70)
	BRNE _0x2000069
	CALL SUBOPT_0x75
	CALL SUBOPT_0x77
	STD  Y+14,R30
	STD  Y+14+1,R31
	CALL SUBOPT_0x46
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2000067:
	ANDI R16,LOW(127)
	CPI  R20,0
	BREQ _0x200006B
	CP   R20,R17
	BRLO _0x200006C
_0x200006B:
	RJMP _0x200006A
_0x200006C:
	MOV  R17,R20
_0x200006A:
_0x2000064:
	LDI  R20,LOW(0)
	LDI  R30,LOW(0)
	STD  Y+20,R30
	LDI  R19,LOW(0)
	RJMP _0x200006D
_0x2000069:
	CPI  R30,LOW(0x64)
	BREQ _0x2000070
	CPI  R30,LOW(0x69)
	BRNE _0x2000071
_0x2000070:
	ORI  R16,LOW(4)
	RJMP _0x2000072
_0x2000071:
	CPI  R30,LOW(0x75)
	BRNE _0x2000073
_0x2000072:
	LDI  R30,LOW(10)
	STD  Y+20,R30
	SBRS R16,1
	RJMP _0x2000074
	__GETD1N 0x3B9ACA00
	CALL SUBOPT_0x42
	LDI  R17,LOW(10)
	RJMP _0x2000075
_0x2000074:
	__GETD1N 0x2710
	CALL SUBOPT_0x42
	LDI  R17,LOW(5)
	RJMP _0x2000075
_0x2000073:
	CPI  R30,LOW(0x58)
	BRNE _0x2000077
	ORI  R16,LOW(8)
	RJMP _0x2000078
_0x2000077:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x20000B6
_0x2000078:
	LDI  R30,LOW(16)
	STD  Y+20,R30
	SBRS R16,1
	RJMP _0x200007A
	__GETD1N 0x10000000
	CALL SUBOPT_0x42
	LDI  R17,LOW(8)
	RJMP _0x2000075
_0x200007A:
	__GETD1N 0x1000
	CALL SUBOPT_0x42
	LDI  R17,LOW(4)
_0x2000075:
	CPI  R20,0
	BREQ _0x200007B
	ANDI R16,LOW(127)
	RJMP _0x200007C
_0x200007B:
	LDI  R20,LOW(1)
_0x200007C:
	SBRS R16,1
	RJMP _0x200007D
	CALL SUBOPT_0x75
	CALL SUBOPT_0x73
	ADIW R26,4
	CALL __GETD1P
	RJMP _0x2000112
_0x200007D:
	SBRS R16,2
	RJMP _0x200007F
	CALL SUBOPT_0x75
	CALL SUBOPT_0x77
	CALL __CWD1
	RJMP _0x2000112
_0x200007F:
	CALL SUBOPT_0x75
	CALL SUBOPT_0x77
	CLR  R22
	CLR  R23
_0x2000112:
	__PUTD1S 10
	SBRS R16,2
	RJMP _0x2000081
	LDD  R26,Y+13
	TST  R26
	BRPL _0x2000082
	CALL SUBOPT_0x57
	CALL __ANEGD1
	CALL SUBOPT_0x74
	LDI  R30,LOW(45)
	STD  Y+21,R30
_0x2000082:
	LDD  R30,Y+21
	CPI  R30,0
	BREQ _0x2000083
	SUBI R17,-LOW(1)
	SUBI R20,-LOW(1)
	RJMP _0x2000084
_0x2000083:
	ANDI R16,LOW(251)
_0x2000084:
_0x2000081:
	MOV  R19,R20
_0x200006D:
	SBRC R16,0
	RJMP _0x2000085
_0x2000086:
	CP   R17,R21
	BRSH _0x2000089
	CP   R19,R21
	BRLO _0x200008A
_0x2000089:
	RJMP _0x2000088
_0x200008A:
	SBRS R16,7
	RJMP _0x200008B
	SBRS R16,2
	RJMP _0x200008C
	ANDI R16,LOW(251)
	LDD  R18,Y+21
	SUBI R17,LOW(1)
	RJMP _0x200008D
_0x200008C:
	LDI  R18,LOW(48)
_0x200008D:
	RJMP _0x200008E
_0x200008B:
	LDI  R18,LOW(32)
_0x200008E:
	CALL SUBOPT_0x6F
	SUBI R21,LOW(1)
	RJMP _0x2000086
_0x2000088:
_0x2000085:
_0x200008F:
	CP   R17,R20
	BRSH _0x2000091
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x2000092
	CALL SUBOPT_0x78
	BREQ _0x2000093
	SUBI R21,LOW(1)
_0x2000093:
	SUBI R17,LOW(1)
	SUBI R20,LOW(1)
_0x2000092:
	LDI  R30,LOW(48)
	ST   -Y,R30
	CALL SUBOPT_0x72
	CPI  R21,0
	BREQ _0x2000094
	SUBI R21,LOW(1)
_0x2000094:
	SUBI R20,LOW(1)
	RJMP _0x200008F
_0x2000091:
	MOV  R19,R17
	LDD  R30,Y+20
	CPI  R30,0
	BRNE _0x2000095
_0x2000096:
	CPI  R19,0
	BREQ _0x2000098
	SBRS R16,3
	RJMP _0x2000099
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	LPM  R18,Z+
	STD  Y+14,R30
	STD  Y+14+1,R31
	RJMP _0x200009A
_0x2000099:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	LD   R18,X+
	STD  Y+14,R26
	STD  Y+14+1,R27
_0x200009A:
	CALL SUBOPT_0x6F
	CPI  R21,0
	BREQ _0x200009B
	SUBI R21,LOW(1)
_0x200009B:
	SUBI R19,LOW(1)
	RJMP _0x2000096
_0x2000098:
	RJMP _0x200009C
_0x2000095:
_0x200009E:
	CALL SUBOPT_0x79
	CALL __DIVD21U
	MOV  R18,R30
	CPI  R18,10
	BRLO _0x20000A0
	SBRS R16,3
	RJMP _0x20000A1
	SUBI R18,-LOW(55)
	RJMP _0x20000A2
_0x20000A1:
	SUBI R18,-LOW(87)
_0x20000A2:
	RJMP _0x20000A3
_0x20000A0:
	SUBI R18,-LOW(48)
_0x20000A3:
	SBRC R16,4
	RJMP _0x20000A5
	CPI  R18,49
	BRSH _0x20000A7
	CALL SUBOPT_0x58
	__CPD2N 0x1
	BRNE _0x20000A6
_0x20000A7:
	RJMP _0x20000A9
_0x20000A6:
	CP   R20,R19
	BRSH _0x2000113
	CP   R21,R19
	BRLO _0x20000AC
	SBRS R16,0
	RJMP _0x20000AD
_0x20000AC:
	RJMP _0x20000AB
_0x20000AD:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x20000AE
_0x2000113:
	LDI  R18,LOW(48)
_0x20000A9:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x20000AF
	CALL SUBOPT_0x78
	BREQ _0x20000B0
	SUBI R21,LOW(1)
_0x20000B0:
_0x20000AF:
_0x20000AE:
_0x20000A5:
	CALL SUBOPT_0x6F
	CPI  R21,0
	BREQ _0x20000B1
	SUBI R21,LOW(1)
_0x20000B1:
_0x20000AB:
	SUBI R19,LOW(1)
	CALL SUBOPT_0x79
	CALL __MODD21U
	CALL SUBOPT_0x74
	LDD  R30,Y+20
	CALL SUBOPT_0x58
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __DIVD21U
	CALL SUBOPT_0x42
	__GETD1S 16
	CALL __CPD10
	BREQ _0x200009F
	RJMP _0x200009E
_0x200009F:
_0x200009C:
	SBRS R16,0
	RJMP _0x20000B2
_0x20000B3:
	CPI  R21,0
	BREQ _0x20000B5
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL SUBOPT_0x72
	RJMP _0x20000B3
_0x20000B5:
_0x20000B2:
_0x20000B6:
_0x2000054:
_0x2000111:
	LDI  R17,LOW(0)
_0x2000035:
	RJMP _0x2000030
_0x2000032:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CALL __GETW1P
	CALL __LOADLOCR6
	ADIW R28,63
	ADIW R28,31
	RET
_printf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	MOVW R16,R26
	LDI  R30,LOW(0)
	STD  Y+4,R30
	STD  Y+4+1,R30
	STD  Y+6,R30
	STD  Y+6+1,R30
	MOVW R26,R28
	ADIW R26,8
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_usart_G100)
	LDI  R31,HIGH(_put_usart_G100)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,8
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G100
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,8
	POP  R15
	RET

	.CSEG
_abs:
    ld   r30,y+
    ld   r31,y+
    sbiw r30,0
    brpl __abs0
    com  r30
    com  r31
    adiw r30,1
__abs0:
    ret
_fabs:
    ld   r30,y+
    ld   r31,y+
    ld   r22,y+
    ld   r23,y+
    cbr  r23,0x80
    ret
_atoi:
   	ldd  r27,y+1
   	ld   r26,y
__atoi0:
   	ld   r30,x
	ST   -Y,R30
	CALL _isspace
   	tst  r30
   	breq __atoi1
   	adiw r26,1
   	rjmp __atoi0
__atoi1:
   	clt
   	ld   r30,x
   	cpi  r30,'-'
   	brne __atoi2
   	set
   	rjmp __atoi3
__atoi2:
   	cpi  r30,'+'
   	brne __atoi4
__atoi3:
   	adiw r26,1
__atoi4:
   	clr  r22
   	clr  r23
__atoi5:
   	ld   r30,x
	ST   -Y,R30
	CALL _isdigit
   	tst  r30
   	breq __atoi6
   	movw r30,r22
   	lsl  r22
   	rol  r23
   	lsl  r22
   	rol  r23
   	add  r22,r30
   	adc  r23,r31
   	lsl  r22
   	rol  r23
   	ld   r30,x+
   	clr  r31
   	subi r30,'0'
   	add  r22,r30
   	adc  r23,r31
   	rjmp __atoi5
__atoi6:
   	movw r30,r22
   	brtc __atoi7
   	com  r30
   	com  r31
   	adiw r30,1
__atoi7:
   	adiw r28,2
   	ret
_ftoa:
	SBIW R28,4
	CALL SUBOPT_0x4D
	LDI  R30,LOW(0)
	STD  Y+2,R30
	LDI  R30,LOW(63)
	STD  Y+3,R30
	ST   -Y,R17
	ST   -Y,R16
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x202000D
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2020000,0
	CALL SUBOPT_0x62
	RJMP _0x20C0008
_0x202000D:
	CPI  R30,LOW(0x7FFF)
	LDI  R26,HIGH(0x7FFF)
	CPC  R31,R26
	BRNE _0x202000C
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2020000,1
	CALL SUBOPT_0x62
	RJMP _0x20C0008
_0x202000C:
	LDD  R26,Y+12
	TST  R26
	BRPL _0x202000F
	__GETD1S 9
	CALL __ANEGF1
	CALL SUBOPT_0x7A
	CALL SUBOPT_0x7B
	LDI  R30,LOW(45)
	ST   X,R30
_0x202000F:
	LDD  R26,Y+8
	CPI  R26,LOW(0x7)
	BRLO _0x2020010
	LDI  R30,LOW(6)
	STD  Y+8,R30
_0x2020010:
	LDD  R17,Y+8
_0x2020011:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	BREQ _0x2020013
	CALL SUBOPT_0x7C
	CALL SUBOPT_0x68
	CALL SUBOPT_0x7D
	RJMP _0x2020011
_0x2020013:
	CALL SUBOPT_0x7E
	CALL __ADDF12
	CALL SUBOPT_0x7A
	LDI  R17,LOW(0)
	CALL SUBOPT_0x29
	CALL SUBOPT_0x7D
_0x2020014:
	CALL SUBOPT_0x7E
	CALL __CMPF12
	BRLO _0x2020016
	CALL SUBOPT_0x7C
	CALL SUBOPT_0x66
	CALL SUBOPT_0x7D
	SUBI R17,-LOW(1)
	RJMP _0x2020014
_0x2020016:
	CPI  R17,0
	BRNE _0x2020017
	CALL SUBOPT_0x7B
	LDI  R30,LOW(48)
	ST   X,R30
	RJMP _0x2020018
_0x2020017:
_0x2020019:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	BREQ _0x202001B
	CALL SUBOPT_0x7C
	CALL SUBOPT_0x68
	CALL SUBOPT_0x67
	CALL SUBOPT_0x69
	CALL SUBOPT_0x7D
	CALL SUBOPT_0x7E
	CALL __DIVF21
	CALL __CFD1U
	MOV  R16,R30
	CALL SUBOPT_0x7B
	CALL SUBOPT_0x6B
	CALL SUBOPT_0x7C
	CALL SUBOPT_0x6C
	CALL __MULF12
	CALL SUBOPT_0x7F
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x7A
	RJMP _0x2020019
_0x202001B:
_0x2020018:
	LDD  R30,Y+8
	CPI  R30,0
	BREQ _0x20C0007
	CALL SUBOPT_0x7B
	LDI  R30,LOW(46)
	ST   X,R30
_0x202001D:
	LDD  R30,Y+8
	SUBI R30,LOW(1)
	STD  Y+8,R30
	SUBI R30,-LOW(1)
	BREQ _0x202001F
	CALL SUBOPT_0x7F
	CALL SUBOPT_0x66
	CALL SUBOPT_0x7A
	__GETD1S 9
	CALL __CFD1U
	MOV  R16,R30
	CALL SUBOPT_0x7B
	CALL SUBOPT_0x6B
	CALL SUBOPT_0x7F
	CALL SUBOPT_0x6C
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x7A
	RJMP _0x202001D
_0x202001F:
_0x20C0007:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
_0x20C0008:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,13
	RET

	.DSEG

	.CSEG

	.CSEG
_ftrunc:
   ldd  r23,y+3
   ldd  r22,y+2
   ldd  r31,y+1
   ld   r30,y
   bst  r23,7
   lsl  r23
   sbrc r22,7
   sbr  r23,1
   mov  r25,r23
   subi r25,0x7e
   breq __ftrunc0
   brcs __ftrunc0
   cpi  r25,24
   brsh __ftrunc1
   clr  r26
   clr  r27
   clr  r24
__ftrunc2:
   sec
   ror  r24
   ror  r27
   ror  r26
   dec  r25
   brne __ftrunc2
   and  r30,r26
   and  r31,r27
   and  r22,r24
   rjmp __ftrunc1
__ftrunc0:
   clt
   clr  r23
   clr  r30
   clr  r31
   clr  r22
__ftrunc1:
   cbr  r22,0x80
   lsr  r23
   brcc __ftrunc3
   sbr  r22,0x80
__ftrunc3:
   bld  r23,7
   ld   r26,y+
   ld   r27,y+
   ld   r24,y+
   ld   r25,y+
   cp   r30,r26
   cpc  r31,r27
   cpc  r22,r24
   cpc  r23,r25
   bst  r25,7
   ret
_floor:
	CALL SUBOPT_0x80
	CALL __PUTPARD1
	CALL _ftrunc
	CALL SUBOPT_0x3D
    brne __floor1
__floor0:
	CALL SUBOPT_0x80
	RJMP _0x20C0001
__floor1:
    brtc __floor0
	CALL SUBOPT_0x81
	CALL __SUBF12
	RJMP _0x20C0001
_log:
	SBIW R28,4
	ST   -Y,R17
	ST   -Y,R16
	CALL SUBOPT_0x60
	CALL __CPD02
	BRLT _0x204000C
	__GETD1N 0xFF7FFFFF
	RJMP _0x20C0006
_0x204000C:
	CALL SUBOPT_0x61
	CALL __PUTPARD1
	IN   R30,SPL
	IN   R31,SPH
	SBIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	PUSH R17
	PUSH R16
	CALL _frexp
	POP  R16
	POP  R17
	CALL SUBOPT_0x5F
	CALL SUBOPT_0x60
	__GETD1N 0x3F3504F3
	CALL __CMPF12
	BRSH _0x204000D
	CALL SUBOPT_0x82
	CALL __ADDF12
	CALL SUBOPT_0x5F
	__SUBWRN 16,17,1
_0x204000D:
	CALL SUBOPT_0x83
	CALL __SUBF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x83
	CALL __ADDF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __DIVF21
	CALL SUBOPT_0x5F
	CALL SUBOPT_0x82
	CALL SUBOPT_0x84
	__GETD2N 0x3F654226
	CALL __MULF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x4054114E
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x60
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x85
	__GETD2N 0x3FD4114D
	CALL __SUBF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __DIVF21
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	MOVW R30,R16
	CALL __CWD1
	CALL __CDF1
	__GETD2N 0x3F317218
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDF12
_0x20C0006:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,10
	RET
_exp:
	SBIW R28,8
	ST   -Y,R17
	ST   -Y,R16
	CALL SUBOPT_0x86
	__GETD1N 0xC2AEAC50
	CALL __CMPF12
	BRSH _0x204000F
	CALL SUBOPT_0x87
	RJMP _0x20C0005
_0x204000F:
	CALL SUBOPT_0x57
	CALL __CPD10
	BRNE _0x2040010
	CALL SUBOPT_0x29
	RJMP _0x20C0005
_0x2040010:
	CALL SUBOPT_0x86
	__GETD1N 0x42B17218
	CALL __CMPF12
	BREQ PC+2
	BRCC PC+3
	JMP  _0x2040011
	__GETD1N 0x7F7FFFFF
	RJMP _0x20C0005
_0x2040011:
	CALL SUBOPT_0x86
	__GETD1N 0x3FB8AA3B
	CALL __MULF12
	CALL SUBOPT_0x74
	CALL SUBOPT_0x57
	CALL SUBOPT_0x69
	CALL __CFD1
	MOVW R16,R30
	MOVW R30,R16
	CALL SUBOPT_0x86
	CALL __CWD1
	CALL __CDF1
	CALL SUBOPT_0x4F
	MOVW R26,R30
	MOVW R24,R22
	CALL SUBOPT_0x88
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x5F
	CALL SUBOPT_0x82
	CALL SUBOPT_0x84
	__GETD2N 0x3D6C4C6D
	CALL __MULF12
	__GETD2N 0x40E6E3A6
	CALL __ADDF12
	CALL SUBOPT_0x60
	CALL __MULF12
	CALL SUBOPT_0x5F
	CALL SUBOPT_0x85
	__GETD2N 0x41A68D28
	CALL __ADDF12
	CALL SUBOPT_0x7D
	CALL SUBOPT_0x61
	CALL SUBOPT_0x7C
	CALL __ADDF12
	__GETD2N 0x3FB504F3
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x60
	CALL SUBOPT_0x85
	CALL __SUBF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x59
	ST   -Y,R17
	ST   -Y,R16
	CALL _ldexp
_0x20C0005:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,14
	RET
_pow:
	SBIW R28,4
	CALL SUBOPT_0x32
	CALL __CPD10
	BRNE _0x2040012
	CALL SUBOPT_0x87
	RJMP _0x20C0004
_0x2040012:
	__GETD2S 8
	CALL __CPD02
	BRGE _0x2040013
	CALL SUBOPT_0x89
	CALL __CPD10
	BRNE _0x2040014
	CALL SUBOPT_0x29
	RJMP _0x20C0004
_0x2040014:
	CALL SUBOPT_0x32
	CALL SUBOPT_0x8A
	CALL __PUTPARD1
	RCALL _exp
	RJMP _0x20C0004
_0x2040013:
	CALL SUBOPT_0x89
	MOVW R26,R28
	CALL __CFD1
	CALL __PUTDP1
	CALL SUBOPT_0x80
	CALL __CDF1
	MOVW R26,R30
	MOVW R24,R22
	CALL SUBOPT_0x89
	CALL __CPD12
	BREQ _0x2040015
	CALL SUBOPT_0x87
	RJMP _0x20C0004
_0x2040015:
	CALL SUBOPT_0x32
	CALL __ANEGF1
	CALL SUBOPT_0x8A
	CALL __PUTPARD1
	RCALL _exp
	CALL SUBOPT_0x2B
	CALL SUBOPT_0x80
	ANDI R30,LOW(0x1)
	BRNE _0x2040016
	CALL SUBOPT_0x32
	RJMP _0x20C0004
_0x2040016:
	CALL SUBOPT_0x32
	CALL __ANEGF1
_0x20C0004:
	ADIW R28,12
	RET
_sin:
	SBIW R28,4
	ST   -Y,R17
	LDI  R17,0
	CALL SUBOPT_0x8B
	__GETD1N 0x3E22F983
	CALL __MULF12
	CALL SUBOPT_0x8C
	CALL SUBOPT_0x8D
	CALL SUBOPT_0x69
	CALL SUBOPT_0x8B
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x8C
	CALL SUBOPT_0x8B
	CALL SUBOPT_0x88
	CALL __CMPF12
	BREQ PC+2
	BRCC PC+3
	JMP  _0x2040017
	CALL SUBOPT_0x8D
	__GETD2N 0x3F000000
	CALL __SUBF12
	CALL SUBOPT_0x8C
	LDI  R17,LOW(1)
_0x2040017:
	CALL SUBOPT_0x8B
	__GETD1N 0x3E800000
	CALL __CMPF12
	BREQ PC+2
	BRCC PC+3
	JMP  _0x2040018
	CALL SUBOPT_0x8B
	CALL SUBOPT_0x88
	CALL __SUBF12
	CALL SUBOPT_0x8C
_0x2040018:
	CPI  R17,0
	BREQ _0x2040019
	CALL SUBOPT_0x8D
	CALL __ANEGF1
	CALL SUBOPT_0x8C
_0x2040019:
	CALL SUBOPT_0x8D
	CALL SUBOPT_0x8B
	CALL __MULF12
	__PUTD1S 1
	__GETD2N 0x4226C4B1
	CALL __MULF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x422DE51D
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x8E
	__GETD2N 0x4104534C
	CALL __ADDF12
	CALL SUBOPT_0x8B
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD1S 1
	__GETD2N 0x3FDEED11
	CALL __ADDF12
	CALL SUBOPT_0x8E
	__GETD2N 0x3FA87B5E
	CALL __ADDF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __DIVF21
	LDD  R17,Y+0
	ADIW R28,9
	RET
_cos:
	CALL SUBOPT_0x4E
	__GETD1N 0x3FC90FDB
	CALL __SUBF12
	CALL SUBOPT_0x35
	RJMP _0x20C0001
_tan:
	SBIW R28,4
	CALL SUBOPT_0x89
	CALL __PUTPARD1
	RCALL _cos
	CALL SUBOPT_0x3D
	CALL __CPD10
	BRNE _0x204001A
	CALL SUBOPT_0x48
	CALL __CPD02
	BRGE _0x204001B
	__GETD1N 0x7F7FFFFF
	RJMP _0x20C0003
_0x204001B:
	__GETD1N 0xFF7FFFFF
	RJMP _0x20C0003
_0x204001A:
	CALL SUBOPT_0x89
	CALL SUBOPT_0x35
	MOVW R26,R30
	MOVW R24,R22
	CALL SUBOPT_0x80
	RJMP _0x20C0002
_xatan:
	SBIW R28,4
	CALL SUBOPT_0x89
	CALL SUBOPT_0x6D
	CALL SUBOPT_0x3D
	CALL SUBOPT_0x80
	__GETD2N 0x40CBD065
	CALL SUBOPT_0x8F
	CALL SUBOPT_0x6D
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x80
	__GETD2N 0x41296D00
	CALL __ADDF12
	CALL SUBOPT_0x4E
	CALL SUBOPT_0x8F
	POP  R26
	POP  R27
	POP  R24
	POP  R25
_0x20C0002:
	CALL __DIVF21
_0x20C0003:
	ADIW R28,8
	RET
_yatan:
	CALL SUBOPT_0x4E
	__GETD1N 0x3ED413CD
	CALL __CMPF12
	BRSH _0x2040020
	CALL SUBOPT_0x80
	CALL __PUTPARD1
	RCALL _xatan
	RJMP _0x20C0001
_0x2040020:
	CALL SUBOPT_0x4E
	__GETD1N 0x401A827A
	CALL __CMPF12
	BREQ PC+2
	BRCC PC+3
	JMP  _0x2040021
	CALL SUBOPT_0x81
	CALL SUBOPT_0x59
	RCALL _xatan
	__GETD2N 0x3FC90FDB
	CALL SUBOPT_0x4F
	RJMP _0x20C0001
_0x2040021:
	CALL SUBOPT_0x81
	CALL __SUBF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x81
	CALL __ADDF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x59
	RCALL _xatan
	__GETD2N 0x3F490FDB
	CALL __ADDF12
	RJMP _0x20C0001
_atan:
	LDD  R26,Y+3
	TST  R26
	BRMI _0x204002C
	CALL SUBOPT_0x80
	CALL __PUTPARD1
	RCALL _yatan
	RJMP _0x20C0001
_0x204002C:
	CALL SUBOPT_0x80
	CALL __ANEGF1
	CALL __PUTPARD1
	RCALL _yatan
	CALL __ANEGF1
_0x20C0001:
	ADIW R28,4
	RET
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG

	.CSEG
_strcpyf:
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strcpyf0:
	lpm  r0,z+
    st   x+,r0
    tst  r0
    brne strcpyf0
    movw r30,r24
    ret
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret
_strncmpf:
    clr  r0
    clr  r1
    ld   r22,y+
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
strncmpf0:
    tst  r22
    breq strncmpf1
    dec  r22
    ld   r1,x+
	lpm  r0,z+
    cp   r0,r1
    brne strncmpf1
    tst  r0
    brne strncmpf0
strncmpf3:
    clr  r30
    ret
strncmpf1:
    sub  r1,r0
    breq strncmpf3
    ldi  r30,1
    brcc strncmpf2
    subi r30,2
strncmpf2:
    ret

	.CSEG
_isdigit:
    ldi  r30,1
    ld   r31,y+
    cpi  r31,'0'
    brlo isdigit0
    cpi  r31,'9'+1
    brlo isdigit1
isdigit0:
    clr  r30
isdigit1:
    ret
_isspace:
    ldi  r30,1
    ld   r31,y+
    cpi  r31,' '
    breq isspace1
    cpi  r31,9
    brlo isspace0
    cpi  r31,13+1
    brlo isspace1
isspace0:
    clr  r30
isspace1:
    ret

	.DSEG
_adc:
	.BYTE 0x2
_RawData:
	.BYTE 0x2
_WaveFreq:
	.BYTE 0x2
_WavePhase:
	.BYTE 0x2
_v:
	.BYTE 0x4
_v1:
	.BYTE 0x4
_Vr:
	.BYTE 0x4
_Vg:
	.BYTE 0x4
_v5:
	.BYTE 0x4
_v6:
	.BYTE 0x4
_v7:
	.BYTE 0x4
_Analog_Voltage:
	.BYTE 0x4
_v2:
	.BYTE 0x4
_m:
	.BYTE 0x2
_n:
	.BYTE 0x2
_Newvalue1:
	.BYTE 0x2
_Phase7:
	.BYTE 0x2
_Phase6:
	.BYTE 0x2
_Phase5:
	.BYTE 0x2
_Phase:
	.BYTE 0x2
_Newvalue:
	.BYTE 0x2
_unixTime:
	.BYTE 0x4
_now:
	.BYTE 0x1
_logInt:
	.BYTE 0x2
_flag:
	.BYTE 0x1
_debug:
	.BYTE 0x1
_status:
	.BYTE 0x2
_vcc:
	.BYTE 0x2
_analogVoltPos:
	.BYTE 0x2
_analogVoltNeg:
	.BYTE 0x2
_supplyVoltage:
	.BYTE 0x2
_Command:
	.BYTE 0x1
_Param:
	.BYTE 0x2
_rx_counter0:
	.BYTE 0x1
_cmdList:
	.BYTE 0x10
_CompIndex:
	.BYTE 0x1
_Compare:
	.BYTE 0x40
_Step:
	.BYTE 0x1
_rx_buffer0:
	.BYTE 0x20
_rx_wr_index0:
	.BYTE 0x1
_rx_rd_index0:
	.BYTE 0x1
_tx_buffer0:
	.BYTE 0x20
_tx_wr_index0:
	.BYTE 0x1
_tx_rd_index0:
	.BYTE 0x1
_tx_counter0:
	.BYTE 0x1
__seed_G101:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 26 TIMES, CODE SIZE REDUCTION:97 WORDS
SUBOPT_0x0:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x1:
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x2:
	ST   -Y,R30
	CALL _ReadMcAdc
	CLR  R22
	CLR  R23
	CALL __CDF1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3:
	CALL __CFD1U
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 57 TIMES, CODE SIZE REDUCTION:109 WORDS
SUBOPT_0x4:
	LDI  R24,4
	CALL _printf
	ADIW R28,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x5:
	CALL _readADC
	STS  _RawData,R30
	STS  _RawData+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x6:
	LDS  R30,_RawData
	LDS  R31,_RawData+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x7:
	RCALL SUBOPT_0x6
	ST   -Y,R31
	ST   -Y,R30
	JMP  _voltage

;OPTIMIZER ADDED SUBROUTINE, CALLED 49 TIMES, CODE SIZE REDUCTION:93 WORDS
SUBOPT_0x8:
	CALL __PUTPARD1
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	LDS  R30,_WaveFreq
	LDS  R31,_WaveFreq+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0xA:
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Newvalue
	LDS  R31,_Newvalue+1
	CALL __CWD1
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0xB:
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Newvalue1
	LDS  R31,_Newvalue1+1
	CALL __CWD1
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xC:
	LDS  R26,_m
	LDS  R27,_m+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:57 WORDS
SUBOPT_0xD:
	__POINTW1FN _0x0,415
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_m
	LDS  R31,_m+1
	CALL __CWD1
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xE:
	LDS  R26,_n
	LDS  R27,_n+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xF:
	LDS  R30,_Param
	LDS  R31,_Param+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x10:
	STS  _n,R30
	STS  _n+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:47 WORDS
SUBOPT_0x11:
	OUT  0x18,R30
	LDI  R30,LOW(_v)
	LDI  R31,HIGH(_v)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_Phase)
	LDI  R31,HIGH(_Phase)
	ST   -Y,R31
	ST   -Y,R30
	CALL _phaseshift
	LDS  R30,_v
	LDS  R31,_v+1
	LDS  R22,_v+2
	LDS  R23,_v+3
	STS  _Vg,R30
	STS  _Vg+1,R31
	STS  _Vg+2,R22
	STS  _Vg+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:47 WORDS
SUBOPT_0x12:
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Vg
	LDS  R31,_Vg+1
	LDS  R22,_Vg+2
	LDS  R23,_Vg+3
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:27 WORDS
SUBOPT_0x13:
	LDS  R30,_Phase
	LDS  R31,_Phase+1
	STS  _Newvalue1,R30
	STS  _Newvalue1+1,R31
	__POINTW1FN _0x0,952
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x14:
	STS  _m,R30
	STS  _m+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:67 WORDS
SUBOPT_0x15:
	LDI  R30,LOW(4)
	OUT  0x18,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	LDI  R30,LOW(_v)
	LDI  R31,HIGH(_v)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_Phase)
	LDI  R31,HIGH(_Phase)
	ST   -Y,R31
	ST   -Y,R30
	CALL _phaseshift
	LDS  R30,_v
	LDS  R31,_v+1
	LDS  R22,_v+2
	LDS  R23,_v+3
	STS  _v2,R30
	STS  _v2+1,R31
	STS  _v2+2,R22
	STS  _v2+3,R23
	LDS  R26,_v2
	LDS  R27,_v2+1
	LDS  R24,_v2+2
	LDS  R25,_v2+3
	__GETD1N 0x40400000
	CALL __MULF12
	STS  _v2,R30
	STS  _v2+1,R31
	STS  _v2+2,R22
	STS  _v2+3,R23
	STS  _Vg,R30
	STS  _Vg+1,R31
	STS  _Vg+2,R22
	STS  _Vg+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:66 WORDS
SUBOPT_0x16:
	OUT  0x18,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	LDI  R30,LOW(_v)
	LDI  R31,HIGH(_v)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_Phase)
	LDI  R31,HIGH(_Phase)
	ST   -Y,R31
	ST   -Y,R30
	CALL _phaseshift
	LDS  R30,_v
	LDS  R31,_v+1
	LDS  R22,_v+2
	LDS  R23,_v+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x17:
	STS  _v5,R30
	STS  _v5+1,R31
	STS  _v5+2,R22
	STS  _v5+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x18:
	__GETD1N 0x40400000
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x19:
	STS  _Vr,R30
	STS  _Vr+1,R31
	STS  _Vr+2,R22
	STS  _Vr+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:47 WORDS
SUBOPT_0x1A:
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_Vr
	LDS  R31,_Vr+1
	LDS  R22,_Vr+2
	LDS  R23,_Vr+3
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1B:
	LDS  R30,_Phase
	LDS  R31,_Phase+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1C:
	__POINTW1FN _0x0,952
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1D:
	LDS  R30,_Phase5
	LDS  R31,_Phase5+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1E:
	CALL __CWD1
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1F:
	STS  _Newvalue,R30
	STS  _Newvalue+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x20:
	STS  _v6,R30
	STS  _v6+1,R31
	STS  _v6+2,R22
	STS  _v6+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x21:
	LDS  R26,_v6
	LDS  R27,_v6+1
	LDS  R24,_v6+2
	LDS  R25,_v6+3
	RJMP SUBOPT_0x18

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x22:
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x40AB5A86
	CALL __DIVF21
	RCALL SUBOPT_0x20
	LDS  R30,_v6
	LDS  R31,_v6+1
	LDS  R22,_v6+2
	LDS  R23,_v6+3
	RJMP SUBOPT_0x19

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x23:
	RCALL SUBOPT_0x1B
	STS  _Phase6,R30
	STS  _Phase6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x24:
	LDS  R30,_Phase6
	LDS  R31,_Phase6+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x25:
	RCALL SUBOPT_0x24
	SBIW R30,50
	STS  _Phase6,R30
	STS  _Phase6+1,R31
	RCALL SUBOPT_0x24
	RJMP SUBOPT_0x1F

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x26:
	STS  _v7,R30
	STS  _v7+1,R31
	STS  _v7+2,R22
	STS  _v7+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x27:
	LDS  R30,_Phase7
	LDS  R31,_Phase7+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x28:
	STS  _v2,R30
	STS  _v2+1,R31
	STS  _v2+2,R22
	STS  _v2+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x29:
	__GETD1N 0x3F800000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2A:
	CALL __PUTPARD1
	CALL _atan
	__GETD2N 0x40800000
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2B:
	__PUTD1S 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x2C:
	LDS  R26,_Newvalue
	LDS  R27,_Newvalue+1
	LDS  R30,_Newvalue1
	LDS  R31,_Newvalue1+1
	SUB  R30,R26
	SBC  R31,R27
	ST   -Y,R31
	ST   -Y,R30
	CALL _abs
	CLR  R22
	CLR  R23
	CALL __CDF1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2D:
	__GETD2S 44
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x2E:
	__GETD1N 0x43340000
	CALL __DIVF21
	__GETD2S 8
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x2F:
	__GETD1N 0x42B40000
	CALL __SUBF12
	CALL __CFD1
	ST   -Y,R31
	ST   -Y,R30
	CALL _abs
	CLR  R22
	CLR  R23
	CALL __CDF1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x30:
	LDS  R26,_Vr
	LDS  R27,_Vr+1
	LDS  R24,_Vr+2
	LDS  R25,_Vr+3
	LDS  R30,_Vg
	LDS  R31,_Vg+1
	LDS  R22,_Vg+2
	LDS  R23,_Vg+3
	CALL __SUBF12
	MOVW R26,R30
	MOVW R24,R22
	LDS  R30,_Vr
	LDS  R31,_Vr+1
	LDS  R22,_Vr+2
	LDS  R23,_Vr+3
	CALL __DIVF21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x31:
	ST   -Y,R31
	ST   -Y,R30
	__GETD1SX 62
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x32:
	__GETD1S 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x33:
	__GETD2N 0x40000000
	CALL __MULF12
	MOVW R26,R30
	MOVW R24,R22
	RCALL SUBOPT_0x9
	CLR  R22
	CLR  R23
	CALL __CDF1
	CALL __MULF12
	__GETD2N 0x447A0000
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x34:
	CALL __PUTPARD1
	JMP  _fabs

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x35:
	CALL __PUTPARD1
	JMP  _sin

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x36:
	CALL __MULF12
	__GETD2N 0x3F800000
	CALL __DIVF21
	RJMP SUBOPT_0x34

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x37:
	__GETD2S 48
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x38:
	__GETD1N 0x5368D4A5
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x39:
	__PUTD1S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x3A:
	CALL __PUTPARD1
	CALL _tan
	CALL __PUTPARD1
	__GETD1N 0x40000000
	CALL __PUTPARD1
	CALL _pow
	__GETD2N 0x3F800000
	CALL __ADDF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3B:
	RCALL SUBOPT_0x37
	CALL __DIVF21
	RJMP SUBOPT_0x34

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3C:
	__PUTD1S 52
	__GETD2S 52
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x3D:
	CALL __PUTD1S0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3E:
	__GETD2S 60
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3F:
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 2
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x40:
	__GETD1S 20
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x41:
	CALL __DIVF21
	RJMP SUBOPT_0x34

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x42:
	__PUTD1S 16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x43:
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 6
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x44:
	__PUTD1S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x45:
	MOV  R30,R17
	LDI  R26,LOW(_cmdList)
	LDI  R27,HIGH(_cmdList)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x46:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _strlenf

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x47:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_Compare)
	LDI  R31,HIGH(_Compare)
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:23 WORDS
SUBOPT_0x48:
	__GETD2S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x49:
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL _spi
	LDI  R30,LOW(0)
	ST   -Y,R30
	JMP  _spi

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x4A:
	LD   R26,Y
	LDD  R27,Y+1
	CLR  R24
	CLR  R25
	__GETD1N 0x1000
	CALL __MULD12U
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x168
	CALL __DIVD21U
	ST   Y,R30
	STD  Y+1,R31
	LDI  R30,LOW(90)
	OUT  0xD,R30
	CBI  0x18,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x4B:
	LDD  R30,Y+1
	ANDI R31,HIGH(0x0)
	ORI  R30,LOW(0xC0)
	ST   -Y,R30
	CALL _spi
	LD   R30,Y
	ST   -Y,R30
	CALL _spi
	SBI  0x18,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x4C:
	ST   -Y,R30
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _AD7798_16

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4D:
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x4E:
	CALL __GETD2S0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x4F:
	CALL __SWAPD12
	CALL __SUBF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x50:
	RCALL SUBOPT_0x39
	__GETD1S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x51:
	__GETD1N 0x43340000
	CALL __DIVF21
	__GETD2S 24
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x52:
	__GETD1SX 84
	RJMP SUBOPT_0x34

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x53:
	__GETD1S 48
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x54:
	__GETD2SX 76
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x55:
	__GETD2SX 72
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x56:
	__GETD2SX 64
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x57:
	__GETD1S 10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x58:
	__GETD2S 16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x59:
	CALL __DIVF21
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x5A:
	__GETD2S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5B:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5C:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	CALL __PUTDP1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x5D:
	ST   -Y,R17
	ST   -Y,R16
	CALL _voltage_at
	__PUTD1S 6
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	CALL __GETD1P
	__GETD2S 6
	CALL __CMPF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x5E:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	ST   X+,R16
	ST   X,R17
	__GETD1S 6
	RJMP SUBOPT_0x5C

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x5F:
	__PUTD1S 6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x60:
	__GETD2S 6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x61:
	__GETD1S 6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x62:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _strcpyf

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x63:
	RCALL SUBOPT_0x48
	__GETD1N 0x41200000
	CALL __MULF12
	RJMP SUBOPT_0x39

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x64:
	__GETD1S 4
	RCALL SUBOPT_0x5A
	CALL __CMPF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x65:
	RCALL SUBOPT_0x5A
	__GETD1N 0x3DCCCCCD
	CALL __MULF12
	RCALL SUBOPT_0x44
	SUBI R19,-LOW(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x66:
	__GETD1N 0x41200000
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x67:
	__GETD2N 0x3F000000
	CALL __ADDF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x68:
	__GETD1N 0x3DCCCCCD
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x69:
	CALL __PUTPARD1
	JMP  _floor

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x6A:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADIW R26,1
	STD  Y+8,R26
	STD  Y+8+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6B:
	MOV  R30,R16
	SUBI R30,-LOW(48)
	ST   X,R30
	MOV  R30,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x6C:
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __CDF1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x6D:
	RCALL SUBOPT_0x48
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x6E:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ADIW R30,1
	STD  Y+8,R30
	STD  Y+8+1,R31
	SBIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x6F:
	ST   -Y,R18
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x70:
	__GETW1SX 90
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x71:
	SBIW R30,4
	__PUTW1SX 90
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x72:
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x73:
	__GETW2SX 90
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x74:
	__PUTD1S 10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x75:
	RCALL SUBOPT_0x70
	RJMP SUBOPT_0x71

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x76:
	STD  Y+14,R30
	STD  Y+14+1,R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	MOV  R17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x77:
	RCALL SUBOPT_0x73
	ADIW R26,4
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x78:
	ANDI R16,LOW(251)
	LDD  R30,Y+21
	ST   -Y,R30
	__GETW1SX 87
	ST   -Y,R31
	ST   -Y,R30
	__GETW1SX 91
	ICALL
	CPI  R21,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x79:
	__GETD1S 16
	__GETD2S 10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x7A:
	__PUTD1S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x7B:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x7C:
	__GETD2S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x7D:
	__PUTD1S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x7E:
	__GETD1S 2
	__GETD2S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7F:
	__GETD2S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:23 WORDS
SUBOPT_0x80:
	CALL __GETD1S0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x81:
	RCALL SUBOPT_0x80
	__GETD2N 0x3F800000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x82:
	RCALL SUBOPT_0x61
	RJMP SUBOPT_0x60

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x83:
	RCALL SUBOPT_0x61
	__GETD2N 0x3F800000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x84:
	CALL __MULF12
	RCALL SUBOPT_0x7D
	__GETD1S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x85:
	__GETD1S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x86:
	__GETD2S 10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x87:
	__GETD1N 0x0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x88:
	__GETD1N 0x3F000000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x89:
	__GETD1S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8A:
	CALL __PUTPARD1
	CALL _log
	RJMP SUBOPT_0x6D

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x8B:
	__GETD2S 5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x8C:
	__PUTD1S 5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x8D:
	__GETD1S 5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8E:
	__GETD2S 1
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x8F:
	CALL __MULF12
	__GETD2N 0x414A8F4E
	CALL __ADDF12
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

_frexp:
	LD   R26,Y+
	LD   R27,Y+
	LD   R30,Y+
	LD   R31,Y+
	LD   R22,Y+
	LD   R23,Y+
	BST  R23,7
	LSL  R22
	ROL  R23
	CLR  R24
	SUBI R23,0x7E
	SBC  R24,R24
	ST   X+,R23
	ST   X,R24
	LDI  R23,0x7E
	LSR  R23
	ROR  R22
	BRTS __ANEGF1
	RET

_ldexp:
	LD   R26,Y+
	LD   R27,Y+
	LD   R30,Y+
	LD   R31,Y+
	LD   R22,Y+
	LD   R23,Y+
	BST  R23,7
	LSL  R22
	ROL  R23
	ADD  R23,R26
	LSR  R23
	ROR  R22
	BRTS __ANEGF1
	RET

__ANEGF1:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __ANEGF10
	SUBI R23,0x80
__ANEGF10:
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF1211
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF1211:
	BRCC __ADDF128
	RJMP __ADDF129
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSRD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSRD12R
__LSRD12L:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRD12L
__LSRD12R:
	RET

__CBD1:
	MOV  R31,R30
	ADD  R31,R31
	SBC  R31,R31
	MOV  R22,R31
	MOV  R23,R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__DIVB21:
	RCALL __CHKSIGNB
	RCALL __DIVB21U
	BRTC __DIVB211
	NEG  R30
__DIVB211:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODB21:
	CLT
	SBRS R26,7
	RJMP __MODB211
	NEG  R26
	SET
__MODB211:
	SBRC R30,7
	NEG  R30
	RCALL __DIVB21U
	MOV  R30,R26
	BRTC __MODB212
	NEG  R30
__MODB212:
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__CHKSIGNB:
	CLT
	SBRS R30,7
	RJMP __CHKSB1
	NEG  R30
	SET
__CHKSB1:
	SBRS R26,7
	RJMP __CHKSB2
	NEG  R26
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSB2:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__GETD1P_INC:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X+
	RET

__PUTDP1:
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	RET

__PUTDP1_DEC:
	ST   -X,R23
	ST   -X,R22
	ST   -X,R31
	ST   -X,R30
	RET

__GETD1S0:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R22,Y+2
	LDD  R23,Y+3
	RET

__GETD2S0:
	LD   R26,Y
	LDD  R27,Y+1
	LDD  R24,Y+2
	LDD  R25,Y+3
	RET

__PUTD1S0:
	ST   Y,R30
	STD  Y+1,R31
	STD  Y+2,R22
	STD  Y+3,R23
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__CPD02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	CPC  R0,R24
	CPC  R0,R25
	RET

__CPD12:
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD  R26,R28
	ADC  R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
